//*****************************************************************************
//*
//*
//*		AzArchiver.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2010
//
//	Syntax:			-E:Pfad		: extrahiern nach Ordner
//					-G:Pfad		: extrahiern nach Ordner (mit Zipliste)
//					-A:Pfad		: eine Datei hinzufgen
//					-B:Pfad		: eine Datei hinzufgen (direkt ohne Dialog, Wildcards erlaubt "*.txt|Not*.txt")
//					-F:Pfad		: eine Datei hinzufgen (mit Dialog-Archiv-Auswahl)
//					-C:Pfad		: eine Datei in ein neues Archiv einfgen
//					-D:Pfad		: eine Datei in ein neues Archiv einfgen (direkt ohne Dialog, Wildcards erlaubt "*.txt|Not*.txt")
//					-L:Liste	: eine Dateiliste hinzufgen
//					-J:Liste	: eine Dateiliste hinzufgen (direkt ohne Dialog)
//					-K:Liste	: eine Dateiliste hinzufgen (mit Dialog-Archiv-Auswahl)
//					-M:Liste	: eine Dateiliste in ein neues Archiv einfgen
//					-N:Liste	: eine Dateiliste in ein neues Archiv einfgen (direkt ohne Dialog)
//					-P:Add		: Zusatzpfad fr das Einfgen (nur fr -B und -D)
//					-W:PassWd	: Passwort angeben
//					-Y			: Konfigurationsdialog ffnen wenn noch nie konfiguriert
//					-X			: Konfigurationsdialog ffnen
//					-U			: Konfiguration lschen
//					-O			: Immer berschreiben
//
//			Statt -?:... ist auch 	-? ... mglich (mit zwei Parametern)
//	
#include	"StdAfx.h"
#include	"MainFrm.h"
#include	"AzArchiver.h"
#include	"AzArchiverDoc.h"
#include	"AzArchiverView.h"
#include	"AzArchiverData.h"
#include	"PeFunctions.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CAzArchiverApp, CWinApp)
	//{{AFX_MSG_MAP(CAzArchiverApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
END_MESSAGE_MAP()



CAzArchiverApp	theApp;
static LPVOID	pOldProc;

HWND	volatile CAzArchiverApp::m_hFindWindow;
int 	volatile CAzArchiverApp::m_hFindMode;


//*****************************************************************************
//*
//*		SHGetFileInfoNew
//*
//*****************************************************************************
DWORD WINAPI SHGetFileInfoNew(LPCTSTR pPath,DWORD dwFileAttributes,SHFILEINFO *pSfi,UINT cbFileInfo,UINT uFlags)
{

	if(pOldProc)
		{
		SetImportProc("Shell32","SHGetFileInfoA",pOldProc,NULL);
		pOldProc = NULL;
		}


return FALSE;
}


//*****************************************************************************
//*
//*		CAzArchiverApp
//*
//*****************************************************************************
// 	CAzArchiverApp Konstruktion
CAzArchiverApp::CAzArchiverApp()
{

	m_iOpenCommand = 0;

}

//*****************************************************************************
//*
//*		FindCallback
//*
//*****************************************************************************
BOOL CALLBACK CAzArchiverApp::FindCallback(HWND hWnd,LPARAM lParam)
{
DWORD_PTR	lResult;


	if(!::SendMessageTimeout(hWnd,(lParam>>16)&0xFFFF,lParam&0xFFFF,0,SMTO_NORMAL,200,&lResult))
		{
		return TRUE;
		}

	if(lResult==0x11223355)
		{
		m_hFindWindow = hWnd;
		m_hFindMode   = 2;
		}

	if(lResult==0x11223344 && m_hFindMode<1)
		{
		m_hFindWindow = hWnd;
		m_hFindMode   = 1;
		}


return TRUE;
}

//*****************************************************************************
//*
//*		InitInstance
//*
//*****************************************************************************
// 	CAzArchiverApp Initialisierung
BOOL CAzArchiverApp::InitInstance()
{
CSingleDocTemplate *pDocTemplate;
TCHAR				cPath[MAX_PATH];
LPCTSTR				pParam;
LPCTSTR				pSufix;
CCommandLineInfo	sInfo;
int					iFile;
int					iFlag;
int					i;



	AfxUtilityInit();
	AfxOleInit();
	AfxEnableControlContainer();

	#ifdef		_AFXDLL
	Enable3dControls();											// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
	#else
	Enable3dControlsStatic();									// Diese Funktion bei statischen MFC-Anbindungen aufrufen
	#endif

																// ndern des Registrierungsschlssels, unter dem unsere Einstellungen gespeichert sind.
	SetRegistryKey(_T("AZ"));

	LoadStdProfileSettings(9);									// Standard INI-Dateioptionen laden (einschlielich MRU)

	pDocTemplate = new CSingleDocTemplate(IDR_MAINFRAME,
										  RUNTIME_CLASS(CAzArchiverDoc),
										  RUNTIME_CLASS(CMainFrame),
										  RUNTIME_CLASS(CAzArchiverView));
	AddDocTemplate(pDocTemplate);


	iFile = 0;
	iFlag = 0;

	for(i=1;i<__argc;i++)										// Parameter auswerten
		{
		pParam = __targv[i];

		if(pParam[0]!='-' && pParam[0]!='/')
			{
			iFile = i;
			continue;
			}

		if(pParam[1]=='O' || pParam[1]=='o')					// Immer berschreiben
			{
			iFlag		   = 1;
			continue;
			}

		if(pParam[1]=='U' || pParam[1]=='u')					// Konfiguration lschen
			{
			m_nCmdShow	   = SW_HIDE;
			m_iOpenCommand = 253;
			continue;
			}

		if(pParam[1]=='X' || pParam[1]=='x')					// Konfigurationsdialog ffnen
			{
			m_nCmdShow	   = SW_HIDE;
			m_iOpenCommand = 254;
			continue;
			}

		if(pParam[1]=='Y' || pParam[1]=='y')					// Konfigurationsdialog ffnen wenn noch nie konfiguriert
			{
			CRegKeys	sKey;

			if(!sKey.Open(HKEY_CURRENT_USER,0,CRK_READ) ||
			   !sKey.Open(HKEY_CLASSES_ROOT,_T("CLSID\\{782565E4-41BC-4D85-80DF-885C2F5897DA}\\InprocServer32"),CRK_READ|CRK_WOW64_64KEY))
				{
				m_nCmdShow	   = SW_HIDE;
				m_iOpenCommand = 254;
				continue;
				}

			return FALSE;
			}

		if(pParam[1]==0)										// Falscher Parameter							
			{
			continue;
			}
		else if(pParam[2]==0)									// Format "-X ..." 
			{
			if(i+1>=__argc)continue;
			pSufix =__targv[i+1];

			if(pSufix[0]=='-' || pSufix[0]=='/')
				{
				continue;
				}

			i++;
			}
		else if(pParam[2]==':')									// Format "-X:..." 
			{
			pSufix = pParam+3;
			}
		else{													
			continue;
			}

		if(pParam[1]=='W' || pParam[1]=='w')					// Passwort
			{
			CAzArchiverDoc::SetPassword(pSufix);
			continue;
			}

		if(pParam[1]=='E' || pParam[1]=='e')					// Extrahieren nach
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 1;
			continue;
			}

		if(pParam[1]=='C' || pParam[1]=='c')					// Erzeuge Archiv und fge Datei hinzu (mit Dialog)
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 2;
			continue;
			}

		if(pParam[1]=='M' || pParam[1]=='m')					// Erzeuge Archiv und fge Dateiliste hinzu (mit Dialog)
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 3;
			continue;
			}

		if(pParam[1]=='D' || pParam[1]=='d')					// Erzeuge Archiv und fge Datei hinzu (direkt ohne Dialog)
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 4;
			continue;
			}

		if(pParam[1]=='N' || pParam[1]=='n')					// Erzeuge Archiv und fge Dateiliste hinzu (direkt ohne Dialog)
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 5;
			continue;
			}

		if(pParam[1]=='A' || pParam[1]=='a')					// Fge Datei zu vorhandene Archiv hinzu
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 6;
			continue;
			}

		if(pParam[1]=='L' || pParam[1]=='l')					// Fge Dateiliste zu vorhandene Archiv hinzu
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 7;
			continue;
			}

		if(pParam[1]=='B' || pParam[1]=='b')					// Fge Datei zu vorhandene Archiv hinzu (direkt ohne Dialog)
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 8;
			continue;
			}

		if(pParam[1]=='J' || pParam[1]=='j')					// Fge Dateiliste zu vorhandene Archiv hinzu (direkt ohne Dialog)
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 9;
			continue;
			}

		if(pParam[1]=='F' || pParam[1]=='f')					// Fge Datei zu Archiv hinzu (mit Dialog-Archiv-Auswahl)
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 10;
			continue;
			}

		if(pParam[1]=='K' || pParam[1]=='k')					// Fge Dateiliste zu Archiv hinzu (mit Dialog-Archiv-Auswahl)
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 11;
			continue;
			}

		if(pParam[1]=='G' || pParam[1]=='g')					// Extrahieren nach eine Liste mit ZIP-Dateien
			{
			m_nCmdShow	   = SW_HIDE;
			m_sCommandPath = pSufix;
			m_iOpenCommand = 12;
			continue;
			}

		if(pParam[1]=='P' || pParam[1]=='p')					// Den Add-Pfad setzen
			{
			m_sCommandAdd  = pSufix;
			continue;
			}
		}

		  														// Dokumentvorlagen registrieren

	ParseCommandLine(sInfo);

	if((m_iOpenCommand>=2 && m_iOpenCommand<=5) && iFile)		// Kein ffnen beim Erzeugen
		{
		sInfo.m_nShellCommand = CCommandLineInfo::FileNew;
		m_sCommandFile = sInfo.m_strFileName;
		}

	if(m_iOpenCommand==12 && iFile)								// Entpacke eine Zip-Liste
		{
		sInfo.m_nShellCommand = CCommandLineInfo::FileNew;
		m_sCommandList = sInfo.m_strFileName;
		}

																// Beim erstenmal konfigurieren
	if(m_iOpenCommand==0 && sInfo.m_nShellCommand==CCommandLineInfo::FileNew)
		{
		CRegKeys	sKey;

		if(!sKey.Open(HKEY_CURRENT_USER,0,CRK_READ) ||
		   !sKey.Open(HKEY_CLASSES_ROOT,_T("CLSID\\{782565E4-41BC-4D85-80DF-885C2F5897DA}\\InprocServer32"),CRK_READ|CRK_WOW64_64KEY))
			{
			m_iOpenCommand = 255;
			}
		}


	if(m_iOpenCommand==0 && sInfo.m_nShellCommand==CCommandLineInfo::FileOpen)
		{
		wchar_t			cPath[MAX_PATH];
		int				iMode;
		UINT			uCode;
		COPYDATASTRUCT	sData;
		CRegKeys		sKey;


		if(sKey.Open() && sKey.Up(_T("Config")))				// In anderen Fenster ffnen
		if(sKey.Get(iMode,_T("OwnWindow")))
			{
			if(iMode)
				{
				m_hFindMode   = 0;
				m_hFindWindow = 0;

				uCode = RegisterWindowMessage(_T("AzArchiver"));
				EnumWindows(FindCallback,(uCode<<16)|iMode);
				}

			if(m_hFindWindow && m_hFindMode>=iMode)				// Wurde ein Fenster gefunden
				{
				sData.cbData = strawcpy(cPath,sInfo.m_strFileName,MAX_PATH)*sizeof(wchar_t)+sizeof(wchar_t);
				sData.dwData = 0x11223344;
				sData.lpData = cPath;

				if(SendMessage(m_hFindWindow,WM_COPYDATA,0,(LPARAM)&sData)==0x11223344)
					{
					return FALSE;
					}
				}
			}
		}

			

	if(sInfo.m_nShellCommand==CCommandLineInfo::FileOpen)		// Bei ZIP-Dateien SHGetFileInfo aushngen 
	if(CmpFileType(sInfo.m_strFileName,"zip"))
		{
		SetImportProc("Shell32","SHGetFileInfoA",SHGetFileInfoNew,&pOldProc);
		}

	if(!ProcessShellCommand(sInfo))
		{
		return FALSE;
		}

	if(pOldProc)
		{
		SetImportProc("Shell32","SHGetFileInfoA",pOldProc,NULL);
		}

	m_pMainWnd->ShowWindow((m_iOpenCommand && m_iOpenCommand<255)? SW_HIDE:SW_SHOW);
	m_pMainWnd->UpdateWindow();

	if(m_iOpenCommand)											// Kommandos weiterleiten
		{
		if(iFile)
			{
			m_sCommandTemp = sInfo.m_strFileName;
			pParam         = m_sCommandTemp;
			m_pMainWnd->PostMessage(WM_STARTCOMMAND,256,(LPARAM)pParam);
			}

		if(m_sCommandList.IsEmpty()==0)
			{
			pParam = m_sCommandList;
			m_pMainWnd->PostMessage(WM_STARTCOMMAND,258,(LPARAM)pParam);
			}

		if(m_sCommandAdd.IsEmpty()==0)
			{
			pParam = m_sCommandAdd;
			m_pMainWnd->PostMessage(WM_STARTCOMMAND,259,(LPARAM)pParam);
			}

		if(iFlag)
			{
			m_pMainWnd->PostMessage(WM_STARTCOMMAND,257);
			}
																// Nur absolute Pfade sind erlaubt
		if(m_sCommandPath!=_T("*") && IsFullPathName(m_sCommandPath)<3)
			{
			GetFullPathName(m_sCommandPath,MAX_PATH,cPath,NULL);
			m_sCommandPath = cPath;
			}

		pParam = m_sCommandPath;

		m_pMainWnd->PostMessage(WM_STARTCOMMAND,m_iOpenCommand,(LPARAM)pParam);
		}
				  


return TRUE;
}


//*****************************************************************************
//*
//*		OnAppAbout
//*
//*****************************************************************************
// 	Anwendungsbefehl zum Ausfhren des Dialogfelds
void CAzArchiverApp::OnAppAbout()
{
	CDialog		sDlg(IDD_ABOUTBOX);


	sDlg.DoModal();

}



//*****************************************************************************
//*
//*		OnFileOpen
//*
//*****************************************************************************
void CAzArchiverApp::OnFileOpen()
{
POSITION		pPos;
CString			sPath;
CDocument	   *pDoc;
CDocTemplate   *pTemp;



	CFileDialog sDlg(TRUE,NULL,_T(""),OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,_T("Archive|") FILTER_ALL _T("|Alle Dateien|*.*|"));


	   sDlg.m_ofn.lpstrTitle=_T("Archivdatei auswhlen");
	if(sDlg.DoModal()!=IDOK)return;


		pPos = GetFirstDocTemplatePosition();
	if(!pPos)return;

		pTemp= GetNextDocTemplate(pPos);
	if(!pTemp)return;

		pPos = pTemp->GetFirstDocPosition();
	if(!pPos)return;

		pDoc = pTemp->GetNextDoc(pPos);
	if(!pDoc)return;

	sPath=sDlg.GetPathName();

	pDoc->OnOpenDocument(sPath);

}
