//*****************************************************************************
//*
//*
//*		AzArchiverDoc.h
//*
//*
//*****************************************************************************
// AzArchiverDoc.h : Schnittstelle der Klasse CAzArchiverDoc
#ifndef		AFX_AZARCHIVERDOC_H__C54F9ABC_42D0_47A0_8AA5_C32B577E28CB__INCLUDED_
#define		AFX_AZARCHIVERDOC_H__C54F9ABC_42D0_47A0_8AA5_C32B577E28CB__INCLUDED_	




#if _MSC_VER > 1000
#pragma once
#endif

class CProgressDlg;

//*****************************************************************************
//*
//*		Klasse CAzArchiverDoc
//*
//*****************************************************************************
class CAzArchiverDoc : public CDocument
{
protected: 
	
	CAzArchiverDoc();
	DECLARE_DYNCREATE(CAzArchiverDoc)
	CArchiveFile	*GetArchive();	

public:

	//{{AFX_VIRTUAL(CAzArchiverDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR pPathName);
	virtual BOOL OnSaveDocument(LPCTSTR pPathName);
	virtual void OnCloseDocument();
	afx_msg void OnCopyPath();
	//}}AFX_VIRTUAL

	static  void  	SetPassword(LPCTSTR pPasswort);
	virtual void	SetModifiedFlag(BOOL bModified = TRUE);
	BOOL			OnCreateDocument(LPCTSTR pPathName);
	void			InitProgress(CProgressDlg *pDlg,int iMode=0);	
	void			SetNotOverWrite();
	void			ExitProgress();	
	void			CloseArchiv();

public:

	virtual ~CAzArchiverDoc();
	#ifdef		_DEBUG					
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
	#endif

	static	int  _cdecl ChangeProc(CProgressDlg *pDlg);
	static	int  _cdecl CloseProc (CProgressDlg *pDlg);
	static	int  _cdecl OpenProc  (CProgressDlg *pDlg);
	static	void _cdecl TimeProc  (CProgressDlg *pDlg);
	static	int  _cdecl TextProc  (void *pParam,int iMode,int iSub,CArchiveFile *pFile,LPTSTR pText); 
								  
 

	
	static	BYTE		m_aCharWidths[256];
	static	int		   *m_pTextWidth;
	static	int 		m_iCharInit;

protected:

	CArchiveFile       *m_pArchive;	
	static CString		m_sPassword;
	CString				m_sArchivePath;
	BOOL				m_bNotOverWrite;
	BOOL				m_bChanged;


	//{{AFX_MSG(CAzArchiverDoc)
	afx_msg void OnNewZip();
	//}}AFX_MSG

	int CheckCueHeader(char *pHeader,LPCTSTR &pPathName);
	int CheckUueHeader(char *pHeader,int iLen);
	int CheckLzmHeader(char *pHeader);
	int CheckTarHeader(void *pHeader);
	int CheckIsoHeader(void *pFile);
	int CheckHxsHeader(void *pFile,char *pHeader);

	DECLARE_MESSAGE_MAP()
};


//*****************************************************************************
//*
//*		InlineFunktionen
//*
//*****************************************************************************
inline CArchiveFile	*CAzArchiverDoc::GetArchive(){return m_pArchive;}	
inline void			 CAzArchiverDoc::SetNotOverWrite(){m_bNotOverWrite=TRUE;}

//{{AFX_INSERT_LOCATION}}

#endif

