//*****************************************************************************
//*
//*
//*		AzArchiverView.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2010
//
#include	"StdAfx.h"
#include	"PathDlg.h"
#include	"AzArchiver.h"
#include	"AzArchiverDoc.h"
#include	"AzArchiverData.h"
#include	"AzArchiverView.h"
#include	"PictureBoxFrame.h"
#include	"ShellContextMenu.h"
#include	"InsertNewDlg.h"
#include	"InsertExDlg.h"
#include	"QuestionDlg.h"
#include	"PasswordDlg.h"
#include	"InsertDlg.h"
#include	"ConfigDlg.h"
#include	"StartProg.h"
								  

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_SELECTFIRST	0x1095
#define 	 ID_SELTEXT		0x1096
#define 	 ID_DROPDONE	0x1097
#define 	 IDC_TREELIST	0x1098
#define 	 EXTRACT_WAIT	500

IMPLEMENT_DYNCREATE(CAzArchiverView, CView)

BEGIN_MESSAGE_MAP(CAzArchiverView, CView)
	//{{AFX_MSG_MAP(CAzArchiverView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_TEST               		,OnTest)
	ON_COMMAND(ID_CONFIG					,OnConfig)
	ON_COMMAND(ID_EDITOR					,OnEditor)
	ON_COMMAND(ID_DELETE					,OnDelete)
	ON_COMMAND(ID_INSERT					,OnInsert)
	ON_COMMAND(ID_EXTRACT					,OnExtract)
	ON_COMMAND(ID_SVECOPY					,OnSaveCopy)
	ON_COMMAND(ID_HEXEDITOR					,OnHexEditor)
	ON_COMMAND(ID_PICTUREBOX				,OnPictureBox)
	ON_COMMAND(ID_SELECTFIRST				,OnSelectFirst)
	ON_COMMAND(ID_SELECTALL					,OnSelectAll)
	ON_COMMAND(ID_DROPDONE					,OnDropDone)
	ON_COMMAND(ID_MODE_DIR			 		,OnModeDir)
	ON_COMMAND(ID_MODE_TREE			 		,OnModeTree)
	ON_COMMAND(ID_MODE_LIST			 		,OnModeList)
	ON_COMMAND(ID_MODE_FULLROW				,OnModeFullRow)
	ON_COMMAND(ID_MODE_ALTERNATE			,OnModeAlternate)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE		,OnFileSaveUI)
	ON_UPDATE_COMMAND_UI(ID_MODE_DIR 		,OnModeDirUI)
	ON_UPDATE_COMMAND_UI(ID_MODE_TREE		,OnModeTreeUI)
	ON_UPDATE_COMMAND_UI(ID_MODE_LIST		,OnModeListUI)
	ON_UPDATE_COMMAND_UI(ID_MODE_FULLROW	,OnModeFullRowUI)
	ON_UPDATE_COMMAND_UI(ID_MODE_ALTERNATE	,OnModeAlternateUI)
	ON_UPDATE_COMMAND_UI(ID_PICTUREBOX		,OnPictureBoxUI)
	ON_UPDATE_COMMAND_UI(ID_HEXEDITOR		,OnHexEditorUI)
	ON_UPDATE_COMMAND_UI(ID_EXTRACT			,OnExtractUI)
	ON_UPDATE_COMMAND_UI(ID_DELETE			,OnDeleteUI)
	ON_UPDATE_COMMAND_UI(ID_INSERT			,OnInsertUI)
	ON_UPDATE_COMMAND_UI(ID_EDITOR			,OnEditorUI)
	ON_MESSAGE(WM_STARTCOMMAND				,OnStartCommand)
	ON_MESSAGE(WM_PICTUREBOX				,OnPictureBox)
	//}}AFX_MSG_MAP
	ON_NOTIFY(NM_RETURN		 ,IDC_TREELIST	,OnReturn)
	ON_NOTIFY(NM_DBLCLK		 ,IDC_TREELIST	,OnDoubleClick)
	ON_NOTIFY(TVN_GETDISPINFO,IDC_TREELIST	,OnGetDispInfo)
	ON_NOTIFY(TVN_COLUMNCLICK,IDC_TREELIST	,OnColumnClick)
	ON_NOTIFY(TVN_SELCHANGED ,IDC_TREELIST  ,OnSelChanged)
	ON_NOTIFY(TVN_BEGINDRAG	 ,IDC_TREELIST  ,OnBeginDrag)
END_MESSAGE_MAP()

DROP_FUNC_SIMPLE(CAzArchiverView);

#define 		ENTRIES(a)		(sizeof(a)/sizeof((a)[0]))

int				CAzArchiverView::m_iAchiveId=0;
int				CAzArchiverView::m_iSortDir =1;
int	volatile	CAzArchiverView::m_iRunning =1;
TCHAR			CAzArchiverView::m_cSelText[128];


//*****************************************************************************
//*
//*		CAzArchiverView
//*
//*****************************************************************************
// 	CAzArchiverView Konstruktion/Destruktion
CAzArchiverView::CAzArchiverView()
{
CRegKeys	sKey;


	m_cTempDir [0]	=  0;
	m_cTempBase[0]	=  0;
	m_pPictureBox	=  0;
	m_iProgressLock	=  0;
	m_iWriteAllow	=  0;
	m_iAlterante	=  1;
	m_iMarkValue	=  1;
	m_iSelCount		=  0;
	m_iSelBytes		=  0;
	m_iDragMode		=  0;
	m_iShowMode		=  0;
	m_iSortMode 	=  0;
	m_iSelTimer		=  0;
	m_iSelLock		=  0;
	m_iFullRow		=  0;
	m_iHasSub		=  0;
	m_iSortDir		=  1;
	m_iColMark		= -1;
	m_iPictureSel	= -1;
	m_pPictureOn	=  0;
	m_pPictureStop  =  0;
	m_bUserBreak	=  0;
	m_hLastSelect	=  0;
	m_hItemSelect	=  0;

	sKey.Open();
	sKey.Get(m_iFullRow   ,_T("FullRow"       ));
	sKey.Get(m_iShowMode  ,_T("ShowMode"      ));
	sKey.Get(m_iSortMode  ,_T("SortMode"      ));
	sKey.Get(m_iSortDir   ,_T("SortDirection" ));
	sKey.Get(m_iAlterante ,_T("AlteranteColor"));

	if(m_iSortDir!=1 && m_iSortDir!=-1)
		{
		m_iSortDir=1;
		}


	m_sOldExpand.DataLength(sizeof(int));
	m_sTempFiles.DataLength(sizeof(int));

	GetCharWidths(m_aFontSize);

}

//*****************************************************************************
//*
//*		CAzArchiverView
//*
//*****************************************************************************
CAzArchiverView::~CAzArchiverView()
{
TCHAR		cPath[MAX_PATH];
time_t		iTimeNow;
LPCTSTR		pTemName;
UINT		uLastDel;
CRegKeys	sKey;
int			iLen;
int			iPos;




	while(m_pPictureOn)									// Den Thread fr die Bildvorschau stoppen
		{
		m_pPictureStop = 1;
		Sleep(100);
		}

	if(m_pPictureBox)
		{
		delete m_pPictureBox;
		m_pPictureBox = 0;
		}

	if(m_sTempFiles.Count()>0)							// Temporre Dateien lschen
		{
		iLen = strlcpy(cPath,m_cTempBase,MAX_PATH);

		for(iPos=0;iPos<m_sTempFiles.Count();iPos++)
			{
			strlcpy(cPath+iLen,m_sTempFiles[iPos],MAX_PATH-iLen);
			RemoveFile(cPath);
			}
		}

	m_iRunning = 0;
	uLastDel   = 0;

	sKey.Open();
	sKey.Set(m_iFullRow   ,_T("FullRow"       ));
	sKey.Set(m_iShowMode  ,_T("ShowMode"      ));
	sKey.Set(m_iSortMode  ,_T("SortMode"      ));
	sKey.Set(m_iSortDir   ,_T("SortDirection" ));
	sKey.Set(m_iAlterante ,_T("AlteranteColor"));
	sKey.Get(uLastDel	  ,_T("LastDelete"    ));

	iTimeNow = time(0);

	if(uLastDel+3600*24*2<(UINT)iTimeNow)				// Restliche temporre Dateien alle 2 Tage lschen
		{
		CFileFinder	sFind;

		sKey.Set((UINT)iTimeNow,_T("LastDelete"));

		iTimeNow -= 3600*24;

		sFind.Set(m_cTempBase,CFF_FIND_SUBDIR,_T("AZ_????????_????????_*.tmp"));

		for(;;)
			{
				pTemName = sFind.Next(1);
			if(!pTemName)break;
			if(sFind.Time()>iTimeNow)continue;

			RemoveFile(pTemName);
			}


		GetTempPath(ENTRIES(cPath)-16,cPath);

		if(_tcscmp(cPath,m_cTempBase) && _tcslen(cPath)>10)
			{
			sFind.Set(cPath,CFF_FIND_SUBDIR,_T("AZ_????????_????????_*.tmp"));

			for(;;)
				{
					pTemName = sFind.Next(1);
				if(!pTemName)break;
				if(sFind.Time()>iTimeNow)continue;

				RemoveFile(pTemName);
				}
			}

		if((iTimeNow/3600/24)%8==3 && _tcslen(cPath)>10)// ltere Temp-Dateien lschen
			{
			sFind.Set(cPath,CFF_FIND_SUBDIR);

			iTimeNow -= 3600*24*3;

			for(;;)
				{
					pTemName = sFind.Next(1);
				if(!pTemName)break;
				if(sFind.Time()>iTimeNow)continue;

				RemoveFile(pTemName);
				}
			}
		}


	RemovePath(m_cTempDir);
}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CAzArchiverView::PreCreateWindow(CREATESTRUCT& cs)
{

return CView::PreCreateWindow(cs);
}

//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
// 	CAzArchiverView Zeichnen
void CAzArchiverView::OnDraw(CDC *pDC)
{

}

//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void CAzArchiverView::OnSetFocus(CWnd *pWnd)
{

	m_cTreeList.SetFocus();

}

//*****************************************************************************
//*
//*		OnModeFullRow
//*
//*****************************************************************************
void CAzArchiverView::OnModeFullRowUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iFullRow);}
void CAzArchiverView::OnModeFullRow()
{

	m_iFullRow = !m_iFullRow;
	m_cTreeList.SetExtendedStyle((m_iFullRow)? TVS_EX_FULLROWMARK:0,TVS_EX_FULLROWMARK);
}

//*****************************************************************************
//*
//*		OnModeAlternate
//*
//*****************************************************************************
void CAzArchiverView::OnModeAlternateUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iAlterante);}
void CAzArchiverView::OnModeAlternate()
{

	m_iAlterante = !m_iAlterante;
	m_cTreeList.SetExtendedStyle((m_iAlterante)? TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES:0,TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES);
}

//*****************************************************************************
//*
//*		OnModeDir
//*
//*****************************************************************************
void CAzArchiverView::OnModeDirUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iShowMode==2);}
void CAzArchiverView::OnModeDir()
{
	if(m_iShowMode==2)return;
	if(m_iShowMode==1)SaveExpands();

	m_iShowMode=2;
	OnUpdate(NULL,3,NULL);
}

//*****************************************************************************
//*
//*		OnModeTree
//*
//*****************************************************************************
void CAzArchiverView::OnModeTreeUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iShowMode==1);}
void CAzArchiverView::OnModeTree()
{
	if(m_iShowMode==1)return;
	m_iShowMode=1;
	OnUpdate(NULL,3,NULL);
}

//*****************************************************************************
//*
//*		OnModeList
//*
//*****************************************************************************
void CAzArchiverView::OnModeListUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iShowMode==0);}
void CAzArchiverView::OnModeList()
{
	if(m_iShowMode==0)return;
	if(m_iShowMode==1)SaveExpands();

	m_iShowMode=0;
	OnUpdate(NULL,3,NULL);
}

//*****************************************************************************
//*
//*		OnDeleteUI
//*
//*****************************************************************************
void CAzArchiverView::OnDeleteUI(CCmdUI *pCmdUI)
{
CArchiveFile   *pFile;
HTREEITEM		hItem;

	hItem = m_cTreeList.GetFirstSelected();
	pFile = GetArchive();
	pCmdUI->Enable(hItem && pFile && pFile->HasCommpress());
}

//*****************************************************************************
//*
//*		OnDelete
//*
//*****************************************************************************
//	Lschen von einzelen Dateien
void CAzArchiverView::OnDelete()
{
CArchiveFile   *pFile;
CStringChain	sDirs;
CString			sText;
HTREEITEM		hItem;
HTREEITEM		hNext;
LPCTSTR			pPath;
LPCTSTR			pName;
LPBYTE			pBits;
int				iItem;
int				iCount;
int				iError;
int				iMax;
int				iPos;
int				iLen;


		hItem = m_cTreeList.GetFirstSelected();
	if(!hItem)return;

		pFile = GetArchive();
	if(!pFile)
		{
		return;
		}

	if(!pFile->HasCommpress())
		{
		MessageBox(_T("Das Archiv kann nicht verndert werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	if(pFile->GetMode()==CAF_READ)
		{
		if(pFile->Change()!=CAF_ERROR_OK)
			{
			MessageBox(_T("Das Archiv kann nicht in den Schreibmodus gebracht werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
			return;
			}
		}

	iCount = 0;
	iMax   = pFile->Count();
	pBits  = new BYTE[(iMax+15)/8];
	memset(pBits,0,(iMax+15)/8);


	while(hItem)								// Ausgewhlte Eintrge lschen
		{
		   iItem = m_cTreeList.GetItemData(hItem);
 		if(iItem<0)
			{
			pPath = m_cTreeList.GetItemText(hItem,6);
			pName = m_cTreeList.GetItemText(hItem,0);

			if(*pPath==' ')pPath++;

			if(m_iShowMode==2)
				{
				iLen = _tcslen(pPath);
				if(iLen>0 && pPath[iLen-1]=='/')iLen--;
				sDirs.Add(iLen,pPath);
				}
			else{
				sDirs.AddFormat(_T("%s%s/"),pPath,pName);
				}
			}
		else{
			if(iItem<iMax)
				{
				bit_set(pBits,iItem);
				iCount++;
				}
			}

		hNext = m_cTreeList.GetNextSelected(hItem);
		m_cTreeList.DeleteItem(hItem);
		hItem = hNext;
		}


	iPos = sDirs.Count();

	while(iPos>0)								// Unterdateien der Verzeichnisse lschen
		{
		iPos  -= 1;
		pPath  = sDirs.Get(iPos);
		iLen   = sDirs.Len(iPos);
		iItem  = pFile->Count();

		while(iItem>0)
			{
			iItem -= 1;
			pName  = pFile->Name(iItem);

			if(_tcsnicmp(pName,pPath,iLen))continue;

			if(iItem<iMax)
				{
				bit_set(pBits,iItem);
				iCount++;
				}
			}
		}


	if(!iCount)									// Gab es Lschungen
		{
		delete pBits;
		return;
		}


	iCount = 0;
	iError = 0;

	for(iMax--;iMax>=0;iMax--)					// Von oben nach unter lschen (gelschte kommen ans Ende)
		{
		if(!bit_read(pBits,iMax))continue;
		if(pFile->Del(iMax)==CAF_ERROR_OK)
			{
			iCount++;
			}
		else{
			iError++;
			}
		}

	delete pBits;


	if(iCount>0)								// Fenster neu aufbauen
		{
		GetDocument()->SetModifiedFlag(1);
		OnUpdate(NULL,3,NULL);
		}

	if(iError)									// Gab es Fehler
		{
		sText.Format(_T("%i Dateien konnten nicht gelscht werden !"),iError);
		MessageBox(sText,_T("Fehler"),MB_OK|MB_ICONERROR);
		}


}


#ifdef		_DEBUG

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CAzArchiverView::AssertValid() const
{
	CView::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CAzArchiverView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
CAzArchiverDoc* CAzArchiverView::GetDocument()					// Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAzArchiverDoc)));

return (CAzArchiverDoc*)m_pDocument;
}
#endif

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CAzArchiverView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
CRect		sRect(0,0,500,0);
CRegKeys	sKey;
unsigned	uStyle;
unsigned	uSize;




	uStyle = TVS_HASBUTTONS|TVS_HASBUTTONS|TVS_HASLINES|TVS_FULLROWSELECT;


	if(CView::OnCreate(lpCreateStruct) == -1)
		{
		return -1;
		}

	if(!m_cTreeList.Create(uStyle|WS_CHILD|WS_VISIBLE,sRect,this,IDC_TREELIST))
		{
		return -1;
		}

	uSize = GetSystemMetrics(SM_CXICON);

	m_cTreeList.InsertColumn(0,_T("Name")				,TVCFMT_LEFT,  -35,-110);
	m_cTreeList.InsertColumn(1,_T("Typ")				,TVCFMT_LEFT,  (70*uSize)/32);
	m_cTreeList.InsertColumn(2,_T("Datum")				,TVCFMT_LEFT,  (98*uSize)/32);
	m_cTreeList.InsertColumn(3,_T("Gre")				,TVCFMT_RIGHT, (70*uSize)/32);
	m_cTreeList.InsertColumn(4,_T("Komprimierung")		,TVCFMT_RIGHT, (55*uSize)/32);
	m_cTreeList.InsertColumn(5,_T("Komprimierte Gre")	,TVCFMT_RIGHT, (70*uSize)/32);
	m_cTreeList.InsertColumn(6,_T("Pfad")				,TVCFMT_LEFT,  -65);

	m_cTreeList.SetImageList(CImageList::FromHandle(GetIconList()),TVSIL_NORMAL);
	m_cTreeList.SetExtendedStyle(TVS_EX_MULTISELECT|TVS_EX_HOMEENDSELECT|TVS_EX_AUTOEXPANDICON|TVS_EX_HEADERDRAGDROP,TVS_EX_MULTISELECT|TVS_EX_HOMEENDSELECT|TVS_EX_AUTOEXPANDICON|TVS_EX_HEADERDRAGDROP);

	sKey.Open();
	sKey.Up(_T("Config"));
	sKey.Get(m_cTempBase,ENTRIES(m_cTempBase)-16,_T("PathTemp"));

	if(!m_cTempBase[0] || ExistFile(m_cTempBase)!=2)
		{
		GetTempPath(ENTRIES(m_cTempBase)-16,m_cTempBase);
		}

	AddBackSlash(m_cTempBase);
	CArchiveFile::SetTempPath(m_cTempBase);

	m_iTempDirSize = _stprintf(m_cTempDir,_T("%sAZ%08X\\"),m_cTempBase,GetCurrentProcessId());

	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)GetStockObject(NULL_BRUSH));

	if(m_iAlterante)
		{
		m_cTreeList.SetExtendedStyle(TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES,TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES);
		}

	if(m_iFullRow)
		{
		m_cTreeList.SetExtendedStyle(TVS_EX_FULLROWMARK,TVS_EX_FULLROWMARK);
		}


	DROP_FUNC_REGISTER1(&m_cTreeList);


return 0;
}


//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CAzArchiverView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	if(cx>0 && cy>0)
		{
		m_cTreeList.MoveWindow(0,0,cx,cy);
		}

}


//*****************************************************************************
//*
//*		SaveExpands
//*
//*****************************************************************************
void CAzArchiverView::SaveExpands()
{
LPCTSTR		pPtr;
HTREEITEM	hItem;
HTREEITEM	hChild;
HTREEITEM	hLevels[32];
TCHAR		cName [256];
int			aLength[32];
int			iLevel;
int			iPos;
int			iNum;
int			iBit;



	hItem  = m_cTreeList.GetChildItem(TVI_ROOT);
	iLevel = 0;
	iPos   = 0;

	while(hItem)
		{
		   hChild = m_cTreeList.GetChildItem(hItem);
		if(hChild)
			{
			aLength[iLevel]=iPos;
			hLevels[iLevel]=hItem;
			iLevel++;

			iBit  = m_cTreeList.GetItemState(hItem,TVIS_EXPANDED);
			pPtr  = m_cTreeList.GetItemText (hItem);
			iPos += strlcpy(cName+iPos,pPtr,ENTRIES(cName)-iPos);

			if(iPos<ENTRIES(cName)-4)
				{
				cName[iPos]='/';iPos++;
				cName[iPos]= 0;
				iNum = m_sOldExpand.FindFast(iPos,cName,0,-1);

				if(iNum>=0)
						m_sOldExpand.DataSet(iNum,iBit);
				else	m_sOldExpand.Add(iPos,cName,CSC_ABCG,&iBit);
				}

			hItem = hChild;
			continue;
			}


		hItem = m_cTreeList.GetNextSiblingItem(hItem);

		while(!hItem)
			{
			if(iLevel<=0)break;

			iLevel--;

			iPos  = aLength[iLevel];
			hItem = hLevels[iLevel];
			hItem = m_cTreeList.GetNextSiblingItem(hItem);
			}
		}




}

//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
//	Das Fenster aktualisieren
//	lHint	: 0 = MFC interer Aufruf
//			  1 = Leeres Dokument erzeugen
//			  2 = Ein neues Archiv wurde geladen
//		 	  3 = Nur die Ansicht neu aufbauen
void CAzArchiverView::OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint)
{
CArchiveFile   *pFile;
CAzArchiverDoc *pDoc;



	if(lHint==0)return;

	m_cTreeList.DeleteAllItems();

	if(lHint==1)
		{
		m_sOldExpand.Del();
		return;
		}


		pFile = GetArchive();
	if(!pFile)
		{
		m_cTreeList.SetColumnMark(m_iColMark ,0);
		m_iColMark = -1;

		if(lHint==2)
			{
			m_cTreeList.DeleteAllItems();
			m_cTreeList.RedrawWindow();
			}

		return;
		}


	m_cTreeList.SetColumnMark(m_iColMark ,0);
	m_cTreeList.SetColumnMark(m_iSortMode,1);
	m_iColMark = m_iSortMode;


	if(lHint==2)
		{
		pDoc		  = GetDocument();
		m_iAchiveId	  = GetCurrentProcessId()^time(0);
		m_iWriteAllow = (pDoc && pFile->HasCommpress())? 1:0;
		m_sOldExpand.Del();
		m_sCurrentPath=_T("");
		if(m_pPictureBox)m_pPictureBox->ClearCache();
		}


	if(pFile->Count()<4096)
		{
		SetCursor(IDC_WAIT);
		UpdateItems(pFile);
		SetCursor(IDC_ARROW);
		}
	else{
		CProgressDlg	sDlg(this);

		sDlg.HideCancel();
		sDlg.SetRange(pFile->Count());
		sDlg.SetTitle(_T("Fenster aufbauen"));
		sDlg.SetProc (UpdateProc,this,pFile);
		sDlg.DoModal ();
		}

}


//*****************************************************************************
//*
//*		UpdateProc
//*
//*****************************************************************************
int _cdecl CAzArchiverView::UpdateProc(CProgressDlg *pDlg)
{
CAzArchiverView	   *pThis=(CAzArchiverView*)pDlg->GetVoid1();
CArchiveFile	   *pFile=(CArchiveFile   *)pDlg->GetVoid2();


	pThis->UpdateItems(pFile,pDlg);


return 0;
}

//*****************************************************************************
//*
//*		SizeString
//*
//*****************************************************************************
//	Wandelt eine Dateigre in einen Text um
void CAzArchiverView::SizeString(char *pText,__int64 iSize)
{
int		iVal;


	iVal = (int)iSize;

		 if(iSize<          1000)_stprintf(pText,_T("%i"               ),iVal);
	else if(iSize<     1000*1000)_stprintf(pText,_T("%i.%03i"          ),               iVal/1000     ,iVal%1000);
	else if(iSize<1000*1000*1000)_stprintf(pText,_T("%i.%03i.%03i"     ),iVal/1000/1000,iVal/1000%1000,iVal%1000);
	else		 			     _stprintf(pText,_T("%i.%03i.%03i.%03i"),(int)(iSize/1000/1000/1000),(int)(iSize/1000/1000%1000),(int)(iSize/1000%1000),(int)(iSize%1000));

}

//*****************************************************************************
//*
//*		PercentString
//*
//*****************************************************************************
void CAzArchiverView::PercentString(char *pText,__int64 iFull,__int64 iComp)
{
int		iVal;


	if(iFull<=0)
		{
		iVal = 1000;
		}
	else if(iComp>0x10000000 || iFull>0x00200000)
		{
		iVal = ((int)(iComp>>16)*1000)/(int)(iFull>>16);
		}
	else if(iComp>0x00100000)
		{
		iVal = ((int)(iComp>>10)*1000)/(int)(iFull>>10);
		}
	else if(iFull>0x7FFFFFFF)
		{
		iVal = (int)((iComp*1000)/iFull);
		}
	else{
		iVal = ((int)iComp*1000)/(int)iFull;
		}

	_stprintf(pText,_T("%i.%i %%"),iVal/10,iVal%10);

}

//*****************************************************************************
//*
//*		UpdateItems
//*
//*****************************************************************************
//	Die Eintrge im Fensterneu einfgen
void CAzArchiverView::UpdateItems(CArchiveFile *pFile,CProgressDlg *pDlg)
{
HTREEITEM		hItem;
TVSORTEX		sSort;
TCHAR			cLast[256];
TCHAR			cPath[256];
TCHAR			cTemp[256];
LPCTSTR			pPath;
LPCTSTR			pName;
LPCTSTR			pType;
time_t			iTime;
unsigned		uTick;
unsigned		uStart;
unsigned		uDelta;
unsigned		uInsert;
__int64			iSizeFull;
__int64			iSizeComp;
int				iOpenIcon;
int				iDirIcon;
int				iParam;
int				iIcon;
int				iVal;
int				iPos;
int				iLen;
int				iNum;
int				i;



	uStart		= GetTickCount();
	uInsert		= 0xFFFF;
	m_iSelCount	= 0;
	m_iSelBytes	= 0;

	SetSelText(); 	    
							 
					  
//******************** Liste **************************************************

	if(m_iShowMode==0)	 
		{
		m_cTreeList.SetStyle(0,TVS_LINESATROOT);

		for(i=0;i<pFile->Count();i++)
			{
			if(pDlg)pDlg->SetPos();

			if(pFile->IsDel(i))continue;
			if(pFile->IsDir(i))continue;

			iSizeFull	= pFile->Len(i,0);
			iSizeComp	= pFile->Len(i,1);
			iTime		= pFile->Time(i);
			pPath		= pFile->Name(i);
			pName		= GetFileName(pPath);
			pType		= GetFileType(pPath);
			iIcon		= I_IMAGECALLBACK;


			cPath[0]=' ';
			strlcpy(cPath+1,pPath,ENTRIES(cPath)-1,pName-pPath);

			hItem = m_cTreeList.InsertItemEx(TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_TEXT|TVIF_PARAM,pName,iIcon,iIcon,0,0,i,TVI_ROOT,NULL);

			m_cTreeList.SetItemTextEx(hItem,cPath,6);
			m_cTreeList.SetItemTextEx(hItem,pType,1);


			strtimeset(cTemp,iTime,STR_DATE_ISO|STR_TIME|STR_LONG);
			m_cTreeList.SetItemTextEx(hItem,cTemp,2);

			SizeString(cTemp,iSizeFull);
			m_cTreeList.SetItemTextEx(hItem,cTemp,3);

			PercentString(cTemp,iSizeFull,iSizeComp);
			m_cTreeList.SetItemTextEx(hItem,cTemp,4);

			SizeString(cTemp,iSizeComp);
			m_cTreeList.SetItemTextEx(hItem,cTemp,5);


			uInsert++;

			if(uInsert>128)
				{
				uInsert	= 0;
				uTick	= GetTickCount();
				uDelta	= uStart-uTick;

				if(uDelta>200 && pDlg)
					{
					_stprintf(cTemp,_T("%s einfgen"),pName);
					pDlg->SetText(cTemp);
					uStart	= uTick;
					}
				}
			}
		}


//******************** Baum ***************************************************


	if(m_iShowMode==1)
		{
		CStringChain	sDirs(sizeof(hItem));

		m_cTreeList.SetStyle(TVS_LINESATROOT,TVS_LINESATROOT);
		GetWindowsDirectory(cPath,ENTRIES(cPath));
		iOpenIcon = GetSmallIcon(cPath,SHGFI_OPENICON);
		iDirIcon  = GetSmallIcon(cPath);
		pFile->Sort(CAF_FLAG_FULLPATH);
		hItem=TVI_ROOT;
		sDirs.Add(_T(""),CSC_ABCG,&hItem);
		m_cTreeList.SetOption(TVOP_AUTOEXPANDOFF,iOpenIcon-iDirIcon);


		for(i=0;i<pFile->Count();i++)
			{
			if(pDlg)pDlg->SetPos();

			if(pFile->IsDel(i))continue;

			iSizeFull	= pFile->Len(i,0);
			iSizeComp	= pFile->Len(i,1);
			iTime		= pFile->Time(i);
			pPath		= pFile->Name(i);
			pName		= GetFileName(pPath);
			pType		= GetFileType(pPath);

			if(pFile->IsDir(i))
				{
				continue;
				}

			cPath[0] = ' ';
			iIcon    = I_IMAGECALLBACK;
			iPos     = strlcpy(cPath+1,pPath,ENTRIES(cPath)-1,pName-pPath);
			iVal     = sDirs.FindFast(iPos,cPath+1,0,-1,1);

			if(iVal>=0)
				{
				sDirs.DataGet(iVal,&hItem);
				}
			else{
				hItem=TVI_ROOT;

				for(iLen=0;iLen<iPos;)
					{
					iNum  = iLen;
					iLen += strchar(pPath+iLen,'/')+1;
					iVal  = sDirs.FindFast(iLen,pPath,0,-1,1);

					if(iVal>=0)
						{
						sDirs.DataGet(iVal,&hItem);
						continue;
						}

					strlcpy(cLast,pPath+iNum,ENTRIES(cLast),iLen-iNum-1);
					hItem = m_cTreeList.InsertItemEx(TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_TEXT|TVIF_PARAM,cLast,iDirIcon,iDirIcon,0,0,-1,hItem,NULL);
					sDirs.Add(iLen,pPath,CSC_ABCG,&hItem);
					cLast[0]=' ';
					strlcpy(cLast+1,pPath,ENTRIES(cLast)-1,iNum);
					m_cTreeList.SetItemTextEx(hItem,cLast,6);

					   iVal = m_sOldExpand.FindFast(iLen,pPath,0,-1,1);
					if(iVal>=0 && m_sOldExpand.DataGet(iVal))
						{
						m_cTreeList.SetItemStateEx(hItem,TVIS_EXPANDED,TVIS_EXPANDED);
						}
					}
				}


			hItem = m_cTreeList.InsertItemEx(TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_TEXT|TVIF_PARAM,pName,iIcon,iIcon,0,0,i,hItem,NULL);

			m_cTreeList.SetItemTextEx(hItem,cPath,6);
			m_cTreeList.SetItemTextEx(hItem,pType,1);


			strtimeset(cTemp,iTime,STR_DATE_ISO|STR_TIME|STR_LONG);
			m_cTreeList.SetItemTextEx(hItem,cTemp,2);

			SizeString(cTemp,iSizeFull);
			m_cTreeList.SetItemTextEx(hItem,cTemp,3);

			PercentString(cTemp,iSizeFull,iSizeComp);
			m_cTreeList.SetItemTextEx(hItem,cTemp,4);

			SizeString(cTemp,iSizeComp);
			m_cTreeList.SetItemTextEx(hItem,cTemp,5);

			uInsert++;

			if(uInsert>128)
				{
				uInsert	= 0;
				uTick	= GetTickCount();
				uDelta	= uStart-uTick;

				if(uDelta>200 && pDlg)
					{
					_stprintf(cTemp,_T("%s einfgen"),pName);
					pDlg->SetText(cTemp);
					uStart	= uTick;
					}
				}
			}
		}

//******************** Ebenen *************************************************

	if(m_iShowMode==2)
		{
		CStringChain	sDirs;

		m_cTreeList.SetStyle(0,TVS_LINESATROOT);

		iPos = m_sCurrentPath.GetLength();
		GetWindowsDirectory(cPath,ENTRIES(cPath));
		iDirIcon = GetSmallIcon(cPath);
		pFile->Sort(CAF_FLAG_FULLPATH);
		cLast[0]=0;

		if(iPos>0)
			{
			cPath[0]=' ';
			hItem = m_cTreeList.InsertItemEx(TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_TEXT|TVIF_PARAM,_T(".."),iDirIcon,iDirIcon,0,0,-1,TVI_ROOT,NULL);
			strlcpy(cPath+1,m_sCurrentPath,ENTRIES(cPath)-1);
			m_cTreeList.SetItemTextEx(hItem,cPath,6);
			}

		for(i=0;i<pFile->Count();i++)
			{
			if(pDlg)pDlg->SetPos();

			if(pFile->IsDel(i))continue;

			iSizeFull	= pFile->Len(i,0);
			iSizeComp	= pFile->Len(i,1);
			iTime		= pFile->Time(i);
			pPath		= pFile->Name(i);
			pName		= GetFileName(pPath);
			pType		= GetFileType(pPath);


			if(pFile->IsDir(i))
				{
				iParam=-1;
				cPath[0]=' ';
				iIcon = iDirIcon;
				iVal  = strlcpy(cPath+1,pPath,ENTRIES(cPath)-1);
				if(iVal>0 && cPath[iVal-1]=='/')cPath[iVal-1]=0;

				if(sDirs.FindFast(cPath+1+(pName-pPath),0,-1,1)>=0)continue;
				}
			else{
				iParam=i;
				cPath[0]=' ';
				iIcon = I_IMAGECALLBACK;
				strlcpy(cPath+1,pPath,ENTRIES(cPath)-1,pName-pPath);
				}

			if(_tcsnicmp(m_sCurrentPath,cPath+1,iPos))			// Ist die Datei im aktuellen Verzeichnis
				{
				continue;
				}

			if(stricmp(m_sCurrentPath,cPath+1) || !*pName)
				{
				if(pPath[iPos]==0)
					{
					continue;
					}

				if(iPos && pPath[iPos-1]!='/')
					{
					continue;
					}

				iVal = strchar(cPath+iPos+1,'/')+iPos;

				if(!strnicmp(cLast,cPath+1,iVal) && !cLast[iVal])
					{
					continue;
					}

				strlcpy(cLast,cPath+1,ENTRIES(cLast),iVal);		// Pfad zu Datei ermitteln
				iParam	  = -1;
				iIcon	  = iDirIcon;
				pName     = cLast+iPos;
				pPath     = cLast;
				pType	  = _T("");
				iSizeFull = 0;
				iSizeComp = 0;

				if(sDirs.FindFast(cLast+iPos,0,-1,1)>=0)continue;

				sDirs.Add(cLast+iPos,CSC_ABCG);
				}


			hItem = m_cTreeList.InsertItemEx(TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_TEXT|TVIF_PARAM,pName,iIcon,iIcon,0,0,iParam,TVI_ROOT,NULL);

			if(pFile->IsDir(i))
				{
				cPath[iPos+1] = 0;
				m_cTreeList.SetItemTextEx(hItem,cPath,6);
				continue;
				}


			m_cTreeList.SetItemTextEx(hItem,cPath,6);
			m_cTreeList.SetItemTextEx(hItem,pType,1);

			strtimeset(cTemp,iTime,STR_DATE_ISO|STR_TIME|STR_LONG);
			m_cTreeList.SetItemTextEx(hItem,cTemp,2);

			iVal = (int)iSizeFull;

			SizeString(cTemp,iSizeFull);
			m_cTreeList.SetItemTextEx(hItem,cTemp,3);

			PercentString(cTemp,iSizeFull,iSizeComp);
			m_cTreeList.SetItemTextEx(hItem,cTemp,4);

			SizeString(cTemp,iSizeComp);
			m_cTreeList.SetItemTextEx(hItem,cTemp,5);

			uInsert++;

			if(uInsert>128)
				{
				uInsert	= 0;
				uTick	= GetTickCount();
				uDelta	= uStart-uTick;

				if(uDelta>200 && pDlg)
					{
					_stprintf(cTemp,_T("%s einfgen"),pName);
					pDlg->SetText(cTemp);
					uStart	= uTick;
					}
				}
			}
		}


	switch(m_iSortMode)
		{
	default:sSort.lpfnCompare	= SortProc0;	break;
	case 1:	sSort.lpfnCompare	= SortProc1;	break;
	case 2:	sSort.lpfnCompare	= SortProc2;	break;
	case 3:	sSort.lpfnCompare	= SortProc3;	break;
	case 4:	sSort.lpfnCompare	= SortProc4;	break;
	case 5:	sSort.lpfnCompare	= SortProc5;	break;
	case 6:	sSort.lpfnCompare	= SortProc6;	break;
		}


	sSort.hParent	= TVI_ROOT;
    sSort.lParam	= (LPARAM)pFile;

	m_cTreeList.SortChildrenEX(&sSort,1);


}

//*****************************************************************************
//*
//*		SortProc0
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Namen
int CALLBACK CAzArchiverView::SortProc0(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
CArchiveFile   *pFile=(CArchiveFile*)lParamSort;
int				iNum1=(int)lParam1;
int				iNum2=(int)lParam2;
int				iLen1;
int				iLen2;
int				iRet;
TV_ITEM			sItem;
LPTSTR			pPtr1;
LPTSTR			pPtr2;


	if(iNum1<0)
		{
		if(iNum2>=0)return -1;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem1;

		TreeList_GetItem(hTree,&sItem);
		pPtr1 = sItem.pszText;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem2;

		TreeList_GetItem(hTree,&sItem);
		pPtr2 = sItem.pszText;

		return _tcsicmp(pPtr1,pPtr2)*m_iSortDir;
		}
	else{
		if(iNum2<0)return  1;
		}


	pPtr1 = pFile->Name(iNum1);
	pPtr2 = pFile->Name(iNum2);
	iLen1 = GetFileName(pPtr1)-pPtr1;
	iLen2 = GetFileName(pPtr2)-pPtr2;

	   iRet = strvicmp(pPtr1+iLen1,pPtr2+iLen2);
	if(iRet)return iRet*m_iSortDir;

	   iRet = strnvicmp(pPtr1,pPtr2,(iLen1<iLen2)? iLen1:iLen2)*m_iSortDir;
	if(iRet==0)return (iLen1-iLen2)*m_iSortDir;


return iRet*m_iSortDir;
}

//*****************************************************************************
//*
//*		SortProc1
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Typ
int CALLBACK CAzArchiverView::SortProc1(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
CArchiveFile   *pFile=(CArchiveFile*)lParamSort;
int				iNum1=(int)lParam1;
int				iNum2=(int)lParam2;
int				iLen1;
int				iLen2;
TV_ITEM			sItem;
LPCTSTR			pPtr1;
LPCTSTR			pPtr2;
int				iRet;


	if(iNum1<0)
		{
		if(iNum2>=0)return -1;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem1;

		TreeList_GetItem(hTree,&sItem);
		pPtr1 = sItem.pszText;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem2;

		TreeList_GetItem(hTree,&sItem);
		pPtr2 = sItem.pszText;

		return _tcsicmp(pPtr1,pPtr2);
		}
	else{
		if(iNum2< 0)return  1;
		}


	pPtr1 = pFile->Name(iNum1);
	pPtr2 = pFile->Name(iNum2);
	iLen1 = GetFileName(pPtr1)-pPtr1;
	iLen2 = GetFileName(pPtr2)-pPtr2;

	   iRet = strvicmp(GetFileType(pPtr1+iLen1),GetFileType(pPtr2+iLen2));
	if(iRet)return iRet*m_iSortDir;

	   iRet = strvicmp(pPtr1+iLen1,pPtr2+iLen2);
	if(iRet)return iRet*m_iSortDir;

	   iRet = strnvicmp(pPtr1,pPtr2,(iLen1<iLen2)? iLen1:iLen2)*m_iSortDir;
	if(iRet==0)return (iLen1-iLen2)*m_iSortDir;


return iRet*m_iSortDir;
}



//*****************************************************************************
//*
//*		SortProc2
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Datum
int CALLBACK CAzArchiverView::SortProc2(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
CArchiveFile   *pFile=(CArchiveFile*)lParamSort;
int				iNum1=(int)lParam1;
int				iNum2=(int)lParam2;
int				iLen1;
int				iLen2;
TV_ITEM			sItem;
LPCTSTR			pPtr1;
LPCTSTR			pPtr2;
int				iRet;


	if(iNum1<0)
		{
		if(iNum2>=0)return -1;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem1;

		TreeList_GetItem(hTree,&sItem);
		pPtr1 = sItem.pszText;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem2;

		TreeList_GetItem(hTree,&sItem);
		pPtr2 = sItem.pszText;

		return stricmp(pPtr1,pPtr2);
		}
	else{
		if(iNum2<0)return  1;
		}

	   iRet  = pFile->Time(iNum1)-pFile->Time(iNum2);
	if(iRet)return iRet*m_iSortDir;


	pPtr1 = pFile->Name(iNum1);
	pPtr2 = pFile->Name(iNum2);
	iLen1 = GetFileName(pPtr1)-pPtr1;
	iLen2 = GetFileName(pPtr2)-pPtr2;

	   iRet = strvicmp(pPtr1+iLen1,pPtr2+iLen2);
	if(iRet)return iRet*m_iSortDir;

	   iRet = strnvicmp(pPtr1,pPtr2,(iLen1<iLen2)? iLen1:iLen2)*m_iSortDir;
	if(iRet==0)return (iLen1-iLen2)*m_iSortDir;


return iRet*m_iSortDir;
}


//*****************************************************************************
//*
//*		SortProc3
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Lnge
int CALLBACK CAzArchiverView::SortProc3(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
CArchiveFile   *pFile=(CArchiveFile*)lParamSort;
int				iNum1=(int)lParam1;
int				iNum2=(int)lParam2;
int				iLen1;
int				iLen2;
__int64			iSize1;
__int64			iSize2;
TV_ITEM			sItem;
LPCTSTR			pPtr1;
LPCTSTR			pPtr2;
int				iRet;


	if(iNum1<0)
		{
		if(iNum2>=0)return -1;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem1;

		TreeList_GetItem(hTree,&sItem);
		pPtr1 = sItem.pszText;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem2;

		TreeList_GetItem(hTree,&sItem);
		pPtr2 = sItem.pszText;

		return _tcsicmp(pPtr1,pPtr2);
		}
	else{
		if(iNum2< 0)return  1;
		}

	iSize1 = pFile->Len(iNum1);
	iSize2 = pFile->Len(iNum2);

	if(iSize1!=iSize2)
		{
	    iRet = (iSize1<iSize2)? -1:1;
		return iRet*m_iSortDir;
		}

	pPtr1 = pFile->Name(iNum1);
	pPtr2 = pFile->Name(iNum2);
	iLen1 = GetFileName(pPtr1)-pPtr1;
	iLen2 = GetFileName(pPtr2)-pPtr2;

	   iRet = strvicmp(pPtr1+iLen1,pPtr2+iLen2);
	if(iRet)return iRet*m_iSortDir;

	   iRet = strnvicmp(pPtr1,pPtr2,(iLen1<iLen2)? iLen1:iLen2)*m_iSortDir;
	if(iRet==0)return (iLen1-iLen2)*m_iSortDir;


return iRet*m_iSortDir;
}

//*****************************************************************************
//*
//*		SortProc4
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Komprimierung
int CALLBACK CAzArchiverView::SortProc4(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
CArchiveFile   *pFile=(CArchiveFile*)lParamSort;
int				iNum1=(int)lParam1;
int				iNum2=(int)lParam2;
int				iSize1;
int				iSize2;
__int64			iCnt1;
__int64			iCnt2;
__int64			iLen1;
__int64			iLen2;
TV_ITEM			sItem;
LPCTSTR			pPtr1;
LPCTSTR			pPtr2;
int				iVal1;
int				iVal2;
int				iRet;


	if(iNum1<0)
		{
		if(iNum2>=0)return -1;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem1;

		TreeList_GetItem(hTree,&sItem);
		pPtr1 = sItem.pszText;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem2;

		TreeList_GetItem(hTree,&sItem);
		pPtr2 = sItem.pszText;

		return _tcsicmp(pPtr1,pPtr2);
		}
	else{
		if(iNum2< 0)return  1;
		}

	iLen1 =  pFile->Len(iNum1,0);if(iLen1<=0)iLen1=1;
	iLen2 =  pFile->Len(iNum2,0);if(iLen2<=0)iLen2=1;
	iCnt1 =  pFile->Len(iNum1,1);if(iCnt1<=0)iCnt1=1;
	iCnt2 =  pFile->Len(iNum2,1);if(iCnt2<=0)iCnt2=1;
	iVal1 = (int)((iCnt1*1000)/iLen1);
	iVal2 = (int)((iCnt2*1000)/iLen2);

	   iRet  = iVal1-iVal2;
	if(iRet)return iRet*m_iSortDir;


	pPtr1  = pFile->Name(iNum1);
	pPtr2  = pFile->Name(iNum2);
	iSize1 = GetFileName(pPtr1)-pPtr1;
	iSize2 = GetFileName(pPtr2)-pPtr2;

	   iRet = strvicmp(pPtr1+iSize1,pPtr2+iSize2);
	if(iRet)return iRet*m_iSortDir;

	   iRet = strnvicmp(pPtr1,pPtr2,(iSize1<iSize2)? iSize1:iSize2)*m_iSortDir;
	if(iRet==0)return (iSize1-iSize2)*m_iSortDir;


return iRet*m_iSortDir;
}


//*****************************************************************************
//*
//*		SortProc5
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach komprimierter Lnge
int CALLBACK CAzArchiverView::SortProc5(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
CArchiveFile   *pFile=(CArchiveFile*)lParamSort;
int				iNum1=(int)lParam1;
int				iNum2=(int)lParam2;
int				iLen1;
int				iLen2;
__int64			iSize1;
__int64			iSize2;
TV_ITEM			sItem;
LPTSTR			pPtr1;
LPTSTR			pPtr2;
int				iRet;


	if(iNum1<0)
		{
		if(iNum2>=0)return -1;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem1;

		TreeList_GetItem(hTree,&sItem);
		pPtr1 = sItem.pszText;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem2;

		TreeList_GetItem(hTree,&sItem);
		pPtr2 = sItem.pszText;

		return _tcsicmp(pPtr1,pPtr2);
		}
	else{
		if(iNum2< 0)return  1;
		}

	iSize1 = pFile->Len(iNum1,1);
	iSize2 = pFile->Len(iNum2,1);

	if(iSize1!=iSize2)
		{
		iRet = (iSize1<iSize2)? -1:1;
		return iRet*m_iSortDir;
		}

	pPtr1 = pFile->Name(iNum1);
	pPtr2 = pFile->Name(iNum2);
	iLen1 = GetFileName(pPtr1)-pPtr1;
	iLen2 = GetFileName(pPtr2)-pPtr2;

	   iRet = strvicmp(pPtr1+iLen1,pPtr2+iLen2);
	if(iRet)return iRet*m_iSortDir;

	   iRet = strnvicmp(pPtr1,pPtr2,(iLen1<iLen2)? iLen1:iLen2)*m_iSortDir;
	if(iRet==0)return (iLen1-iLen2)*m_iSortDir;


return iRet*m_iSortDir;
}

//*****************************************************************************
//*
//*		SortProc6
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Pfad
int CALLBACK CAzArchiverView::SortProc6(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
CArchiveFile   *pFile=(CArchiveFile*)lParamSort;
int				iNum1=(int)lParam1;
int				iNum2=(int)lParam2;
int				iLen1;
int				iLen2;
TV_ITEM			sItem;
LPTSTR			pPtr1;
LPTSTR			pPtr2;
int				iRet;


	if(iNum1<0)
		{
		if(iNum2>=0)return -1;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem1;

		TreeList_GetItem(hTree,&sItem);
		pPtr1 = sItem.pszText;

		sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
		sItem.hItem		 = hItem2;

		TreeList_GetItem(hTree,&sItem);
		pPtr2 = sItem.pszText;

		return _tcsicmp(pPtr1,pPtr2)*m_iSortDir;
		}
	else{
		if(iNum2<0)return  1;
		}


	pPtr1 = pFile->Name(iNum1);
	pPtr2 = pFile->Name(iNum2);
	iLen1 = GetFileName(pPtr1)-pPtr1;
	iLen2 = GetFileName(pPtr2)-pPtr2;

	iRet  = strnvicmp(pPtr1,pPtr2,(iLen1<iLen2)? iLen1:iLen2)*m_iSortDir;

	if(iRet)return iRet;
	if(iLen1!=iLen2)return (iLen1-iLen2)*m_iSortDir;


return strvicmp(pPtr1+iLen1,pPtr2+iLen2)*m_iSortDir;
}

//*****************************************************************************
//*
//*		OnGetDispInfo
//*
//*****************************************************************************
void CAzArchiverView::OnGetDispInfo(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO	   *pInfo=(NMTVDISPINFO*)pNmHdr;
CArchiveFile	   *pFile;
LPCTSTR				pName;
int					iIcon;



		pFile = GetArchive();
	if(!pFile)return;

	   pName = pFile->Name((int)pInfo->item.lParam);
	   iIcon = GetSmallIcon(pName,SHGFI_USEFILEATTRIBUTES);
	if(iIcon<0)return;

	m_cTreeList.SetItemImage(pInfo->item.hItem,iIcon,iIcon);
	pInfo->item.iImage = iIcon;

	*pResult=1;

}

//*****************************************************************************
//*
//*		OnColumnClick
//*
//*****************************************************************************
void CAzArchiverView::OnColumnClick(NMHDR *pNmHdr,LRESULT *pResult)
{
NMHEADER	   *pHeader = (NMHEADER*)pNmHdr;
CArchiveFile   *pFile;
TVSORTEX		sSort;


	if(pHeader->iItem==m_iSortMode)
		{
		m_iSortDir = -m_iSortDir;
		}
	else{
		m_iSortMode = pHeader->iItem;
		}


		pFile = GetArchive();
	if(!pFile)return;

	switch(m_iSortMode)
		{
	default:sSort.lpfnCompare	= SortProc0;	m_iSortMode=0;	break;
	case 1:	sSort.lpfnCompare	= SortProc1;					break;
	case 2:	sSort.lpfnCompare	= SortProc2;					break;
	case 3:	sSort.lpfnCompare	= SortProc3;					break;
	case 4:	sSort.lpfnCompare	= SortProc4;					break;
	case 5:	sSort.lpfnCompare	= SortProc5;					break;
	case 6:	sSort.lpfnCompare	= SortProc6;					break;
		}


	sSort.hParent	= TVI_ROOT;
    sSort.lParam	= (LPARAM)pFile;

	m_cTreeList.SortChildrenEX(&sSort,1);


	if(m_iSortMode!=m_iColMark && GetArchive())
		{
		m_cTreeList.SetColumnMark(m_iColMark ,0);
		m_cTreeList.SetColumnMark(m_iSortMode,1);
		m_iColMark = m_iSortMode;
		}


}

//*****************************************************************************
//*
//*		OnDoubleClick
//*
//*****************************************************************************
void CAzArchiverView::OnDoubleClick(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTREEVIEW	   *pTree = (NMTREEVIEW*)pNmHdr;
LPCTSTR			pPtr;
int				iNum;



	iNum = pTree->itemNew.lParam;

	if(iNum>=0 && m_pPictureBox)
		{
		pPtr = m_cTreeList.GetItemText(pTree->itemNew.hItem);

		if(CmpFileType(pPtr,"bmp;jpeg;jpg;gif;paz;png;tiff;xpm;xwd;pnm"))
			{
			return;
			}
		}

	if(iNum!=-1 || m_iShowMode!=2)
		{
		if(iNum!=-1)StartShell(pTree->itemNew.hItem);
		return;
		}

	   pPtr = m_cTreeList.GetItemText(pTree->itemNew.hItem);
	if(pPtr[0]=='.' && 	pPtr[1]=='.' && pPtr[2]==0)
		{
		DelBackSlash(m_sCurrentPath);
		iNum = m_sCurrentPath.GetLength();
		while(iNum>0)
			{
			if(m_sCurrentPath[iNum-1]=='/')break;
			iNum--;
			}
		m_sCurrentPath=m_sCurrentPath.Left(iNum);
		}
	else{
		m_sCurrentPath += pPtr;
		m_sCurrentPath += _T("/");
		}

	OnUpdate(NULL,3,NULL);

}

//*****************************************************************************
//*
//*		OnReturn
//*
//*****************************************************************************
void CAzArchiverView::OnReturn(NMHDR *pNmHdr,LRESULT *pResult)
{
LPCTSTR			pPtr;
HTREEITEM		hItem;
int				iNum;


		hItem = m_cTreeList.GetFocusItem();
	if(!hItem)return;

	   iNum = m_cTreeList.GetItemData(hItem);
	if(iNum!=-1 || m_iShowMode!=2)
		{
		if(iNum!=-1)
			{
			StartShell(hItem);
			}
		else if(m_iShowMode==0)
			{
			m_cTreeList.Expand(hItem,TVE_TOGGLE);
			}

		return;
		}

	   pPtr = m_cTreeList.GetItemText(hItem);
	if(pPtr[0]=='.' && 	pPtr[1]=='.' && pPtr[2]==0)
		{
		DelBackSlash(m_sCurrentPath);
		iNum = m_sCurrentPath.GetLength();
		while(iNum>0)
			{
			if(m_sCurrentPath[iNum-1]=='/')break;
			iNum--;
			}
		m_sCurrentPath=m_sCurrentPath.Left(iNum);
		}
	else{
		m_sCurrentPath += pPtr;
		m_sCurrentPath += _T("/");
		}

	OnUpdate(NULL,3,NULL);

}

//*****************************************************************************
//*
//*		OnSelectAll
//*
//*****************************************************************************
void CAzArchiverView::OnSelectAll()
{

	m_iSelLock = 1;
	m_cTreeList.SelectChilds(TVI_ROOT);
	m_iSelLock = 0;

	SetSelText();

}

//*****************************************************************************
//*
//*		OnExtractUI
//*
//*****************************************************************************
void CAzArchiverView::OnExtractUI(CCmdUI *pCmdUI)
{
CArchiveFile   *pFile;

	pFile = GetArchive();
	pCmdUI->Enable(pFile!=0);
}


//*****************************************************************************
//*
//*		OnExtract
//*
//*****************************************************************************
//	Die gewhlten Dateien extrahieren
void CAzArchiverView::OnExtract()
{

	ExtractCmd(0,1);

}

//*****************************************************************************
//*
//*		ExtractCmd
//*
//*****************************************************************************
//	Extrahiere das Archiv
//	pPath	: Zielpfad, bei 0 kommt ein Dialog
//	iCmd	: Bestimmt die die Art des Extrahierens
//				0 = ohne selektierten Dateien
//				1 = mit  selektierten Dateien
void CAzArchiverView::ExtractCmd(LPCTSTR pPath,int iCmd)
{
CPathDlg		sDlg(this,_T("Extract"));
CRegKeys		sKey;
CString			sPath;
CString			sBody;
HTREEITEM		hItem;
LPCTSTR			pTemp;
LPCTSTR			pName;
CDocument	   *pDoc;
CArchiveFile   *pFile;
int			   *pItems;
int				iCount;
int				iMode;
int				iNum;
__int64			iSize;



		pFile = GetArchive();
	if(!pFile || pFile->Count()<=0)
		{
		MessageBox(_T("Es sind keine Dateien vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	iMode = 1;

	if(!pPath)
		{
		sKey.Open();
		sKey.Up(_T("Config"));
		sKey.Get(iMode,_T("ExtractMode"));

		if(iMode==2)									// Einen speziellen Ordner whlen
			{
			sKey.Get(sPath,_T("PathExtract"));
			if(sPath!=_T("") && ExistFile(sPath)>=2)
				{
				sDlg.SetPath(sPath);
				}
			}

		   pDoc = GetDocument();
		if(pDoc)										// Name frs Pfad-Erweiterungs-Men
			{
				sPath = pDoc->GetPathName();
			if(!sPath.IsEmpty())
				{
				GetFileBody(sBody,sPath);
				sDlg.SetExtension(sBody);
				}
			}

		if(iMode==0) 									// Pfad vom Archiv nehmen
			{
			if(pDoc && !sPath.IsEmpty())
				{
				GetFilePath(sPath,sPath);

				if(ExistFile(sPath)>=2)
					{
					sDlg.SetPath(sPath);
					}
				}
			}

														// Alte Dialog-Position
		if(sKey.Get(&sDlg.m_sOldPos,sizeof(RECT),_T("DlgExtractPos"),REG_BINARY))
			{
			sDlg.m_iOldScreenOn = 1;
			}

		   sDlg.SetTitle(_T("Zielverzeichnis whlen"));
		if(sDlg.DoModal(0,CPD_CREATEPATH)!=IDOK)		// Zielordner whlen
			{
			m_bUserBreak = TRUE;
			return;
			}

		sKey.Set(&sDlg.m_sOldPos,sizeof(RECT),_T("DlgExtractPos"),REG_BINARY);
		pPath = sDlg.GetPath(1);
		m_sExtractPath = pPath;
		}

	hItem	= m_cTreeList.GetFirstSelected();
	iCount	= pFile->Count();
	pItems	= new int[iCount];
	iSize	= 0;

	if(!pItems)
		{
		MessageBox(_T("Zu wenig Speicher !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}


	if(hItem && iCmd)									// Ausgewhlte Dateien extrahiern
		{
		m_iMarkValue++;

		for(iNum=0;iNum<iCount && hItem;)
			{
			   pItems[iNum] = m_cTreeList.GetItemData(hItem);
			if(pItems[iNum]<0)
				{
				pName  = m_cTreeList.GetItemText(hItem,0);
				pTemp  = m_cTreeList.GetItemText(hItem,6)+1;
				iNum  += ExtractPath(pFile,pTemp,pName,pItems+iNum,iCount-iNum,iSize);
				}
			else{
				iSize += pFile->Len(pItems[iNum]);
				pFile->SetUserData (pItems[iNum],m_iMarkValue);
				iNum  += 1;
				}

			hItem = m_cTreeList.GetNextSelected(hItem);
			}
		}
	else{												// Alles extrahieren
		for(iNum=0;iNum<iCount;iNum++)
			{
			pItems[iNum]    = iNum;
			iSize+=pFile->Len(iNum);
			}
		}


	CProgressDlg	sExtractDlg(this);

	m_iProgressLock	=  1;
	m_iProgressNow  =  0;
	m_iProgressMax  =  0;


	sExtractDlg.SetRange(iSize);
	sExtractDlg.SetTitle(_T("Extrahieren"));
	sExtractDlg.SetProc (ExtractProc,this,pFile,pPath,pItems,iNum);
	sExtractDlg.SetTime (ExtractTimeProc,250);
	sExtractDlg.SetDelay(EXTRACT_WAIT);
	sExtractDlg.DoModal ();

	delete pItems;

}


//*****************************************************************************
//*
//*		ExtractProc
//*
//*****************************************************************************
//	Thread-Funktion zum extrahieren der Dateien
//	Param[1]	= this
//	Param[2]	= Zeiger auf Archivdatei
//	Param[3]	= Zeiger auf Extrahierpfad
//	Param[4]	= Zeiger auf Array mit den zu extrahierenten Dateien
//	Param[5]	= Anzahl der zu extrahierenten Dateien (<0 fr immer berschreiben)
int _cdecl CAzArchiverView::ExtractProc(CProgressDlg *pDlg)
{
CAzArchiverView	   *pThis =(CAzArchiverView*)pDlg->GetVoid1();
CArchiveFile	   *pFile =(CArchiveFile   *)pDlg->GetVoid2();
LPCTSTR				pPath =	                 pDlg->GetChar3();
int 			   *pItems=(int            *)pDlg->GetVoid4();
int 				iCount=                  pDlg->GetInt5();
TCHAR				cTemp[MAX_PATH];
LPCTSTR				pText;
int					iItem;
int					iEver;
int					iError;
int					iNever;
__int64				iRange;
__int64				iNow;
__int64				iMax;
int					iPos;
int					iLen;
int					iRet;
int					iAdd;
int					iNum;
int					iOk;



	pFile->Flags(pFile->Flags()&~(CAF_FLAG_NOREADONLY|CAF_FLAG_NOEXIST));
	iLen	= _tcslen(pPath);
	iNever	= 0;
	iEver	= 0;
	iOk		= 0;


	if(iLen>=MAX_PATH-4)								// Ist der Pfad zu lange
		{
		return 0;
		}

	if(iLen>0 && pPath[iLen-1]!='/' && pPath[iLen-1]!='\\')
			iAdd = 1;
	else	iAdd = 0;


	if(iCount<0)										// Alles ins gleiche Verzeichnis
		{
		iCount = -iCount;
		iEver  =  1;
		}

	pThis->m_sFileMutex.Lock();

	for(iPos=0;iPos<iCount;iPos++)						// Hauptschleife
		{
		if(pDlg->IsStoped())
			{
			pThis->m_bUserBreak = TRUE;
			break;
			}

		iItem	= pItems[iPos];
		iNow	= pDlg->GetPos();

		   pText= pFile->Name(iItem);
		if(pText)
			{
			CommpressFileName(pText,cTemp,ENTRIES(cTemp),410,pThis->m_aFontSize);
			pDlg->SetText(cTemp);

			strlcpy(cTemp,pPath,ENTRIES(cTemp)-1,iLen);
			cTemp[iLen] = '\\';
			iNum=strlcpy(cTemp+iLen+iAdd,pText,ENTRIES(cTemp)-iLen-iAdd);
			DelBackSlash(cTemp+iLen+iAdd,iNum);
			PathConvert(cTemp+iLen);

														// Existiert die Datei bereits
			if(!iEver && !pFile->IsDir(iItem) && ExistFile(cTemp)==1)
				{
				CQuestionDlg	sDlg(pDlg);


				if(iNever)
					{
					iNow += pFile->Len(iItem);
					pDlg->SetPos(iNow);
					continue;
					}

				sDlg.m_sText.Format(_T("Die Datei '%s' existiert bereits !\nSoll sie berschriben werden ?"),cTemp);
				iRet = pDlg->Dialog(&sDlg);

				if(iRet==IDABORT)break;
				if(iRet==IDCANCEL)
					{
					iNow += pFile->Len(iItem);
					pDlg->SetPos(iNow);
					continue;
					}

				if(iRet==IDC_NEVER)
					{
					iNow += pFile->Len(iItem);
					pDlg->SetPos(iNow);
					iNever=1;
					continue;
					}

				if(iRet==IDC_EVER)
					{
					iEver=1;
					}
				}
			}


		pThis->m_iProgressStep   = pFile->Len(iItem);
		pThis->m_iProgressNow	 = iNow;
		pThis->m_iProgressMax	 = iNow;
		pThis->m_iProgressLock	 = 0;

		iError = pFile->Extract(iItem,cTemp);

		pThis->m_iProgressLock = 1;

		iMax  = pFile->Done();
		iNow += iMax;

		if(iMax>pThis->m_iProgressStep)					// Range vergrern
			{
			pDlg->GetRange(iRange);
			iRange += iMax-pThis->m_iProgressStep;
			pThis->m_iProgressStep = iMax;
			pDlg->SetRange(iRange);
			}


		pDlg->SetPos(iNow);


		if(iError!=CAF_ERROR_OK)
			{
			   iRet=pDlg->MessageBox(pFile->ErrorText(),_T("Fehler"),MB_ABORTRETRYIGNORE|MB_ICONERROR);
			if(iRet==IDABORT)break;
			if(iRet==IDRETRY)
				{
				if(iError==CAF_ERROR_PASSWD)			// Passwort eingeben
					{
					CPasswordDlg	sDlg;

					sDlg.SetRegPath(_T("PasswordDlg"));

					if(pDlg->Dialog(&sDlg)!=IDOK)
						{
						break;
						}
					
					pFile->SetPassword(sDlg.GetText());
					RemoveFile(cTemp);
					}

				iPos--;
				pDlg->SetPos(iNow);
				}
			}
		else{
			iOk++;
			}
		}

	pThis->m_sFileMutex.Unlock();



return iOk;
}



//*****************************************************************************
//*
//*		ExtractTimeProc
//*
//*****************************************************************************
void _cdecl CAzArchiverView::ExtractTimeProc(CProgressDlg *pDlg)
{
CAzArchiverView	   *pThis =(CAzArchiverView*)pDlg->GetVoid1();
CArchiveFile	   *pFile =(CArchiveFile   *)pDlg->GetVoid2();
__int64				iRange;
__int64				iPos;
__int64				iMax;


	if(pFile==0)return;
	if(pThis->m_iProgressLock!=0)return;


	iPos  = pFile->Done(&iMax);
	iPos += pThis->m_iProgressNow;


	if(iPos<pThis->m_iProgressMax)
		{
		return;
		}


	if(iMax>pThis->m_iProgressStep)					// Range vergrern
		{
		pDlg->GetRange(iRange);
		iRange += iMax-pThis->m_iProgressStep;
		pThis->m_iProgressStep = iMax;
		pDlg->SetRange(iRange);
		}

	pDlg->SetPos(iPos);

	if(iPos>pThis->m_iProgressMax)
		{
		pThis->m_iProgressMax = iPos;
		}

}

//*****************************************************************************
//*
//*		ExtractPath
//*
//*****************************************************************************
//	Fgt die Nummern aller Dateien aus einem Unterverzeichniss in eine Liste ein
//	pFile		: Zeiger auf das Archiv mit den Dateien
//	pPath		: Zeiger auf den Dateinpfad mit Slash am Ende
//	pName		: Zeiger auf den Dateinamen
//	pItems		: Zeiger auf die Liste
//	iSize		: Hier werden die Gren der Dateien addiert
//	Ergibt die Anzahl der eingefgten Dateien
int	CAzArchiverView::ExtractPath(CArchiveFile *pFile,LPCTSTR pPath,LPCTSTR pName,int *pItems,int iMax,__int64 &iSize)
{
TCHAR		cName[MAX_PATH];
LPCTSTR		pCmp;
int			iPos;
int			iLen;
int			iAdd;



	iLen  = strlcpy(cName     ,pPath,MAX_PATH);
	iLen += strlcpy(cName+iLen,pName,MAX_PATH-iLen);

	if(iLen>=MAX_PATH)return 0;

	cName[iLen] = '/';
	iLen += 1;
	iAdd  = 0;
	iPos  = pFile->Count();

	for(iPos--;iPos>=0;iPos--)
		{
		if(pFile->IsDir(iPos))continue;
		if(pFile->GetUserData(iPos)==m_iMarkValue)continue;

		pCmp = pFile->Name(iPos);

		if(_tcsnicmp(cName,pCmp,iLen))continue;

		if(iAdd>=iMax)break;

		iSize += pFile->Len(iPos);
		pFile->SetUserData(iPos,m_iMarkValue);
		pItems[iAdd] = iPos;
		iAdd++;
		}


return iAdd;
}

//*****************************************************************************
//*
//*		ExtractSingle
//*
//*****************************************************************************
//	Extrahiert eine einzelne Datei
//	hItem		: Ist das Handle der Eintrags in der Liste
//	pTarget		: Zeiger auf den Puffer fr den Dateinamen (0=keiner)
//	iMax		: Gre des Puffers in Zeichen
//	Ergibt 1 wenn die Datei Extrahiert wurde
int	CAzArchiverView::ExtractSingle(HTREEITEM hItem,LPTSTR pTarget,int iMax)
{
CArchiveFile   *pFile;
LPCTSTR		    pPath;
LPTSTR		    pTemp;
TCHAR			cPath[MAX_PATH];
int				iItem;


	if(pTarget && iMax>0)*pTarget=0;


		pFile = GetArchive();
	if(!pFile || pFile->Count()<=0)
		{
		MessageBox(_T("Es sind keine Dateien vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}

	if(!hItem)
		{
		MessageBox(_T("Es ist kein Eintrag ausgewhlt !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}

	   iItem = m_cTreeList.GetItemData(hItem);
	if(iItem<0 || pFile->IsDir(iItem))
		{
		MessageBox(_T("Verzeichnisse knnen nicht angezeigt werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}

		pPath = pFile->Name(iItem);
	if(!pPath)
		{
		MessageBox(_T("Interner Fehler !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}


	strlcpy(cPath,m_cTempDir,ENTRIES(cPath),m_iTempDirSize);
	strlcpy(cPath+m_iTempDirSize,pPath,MAX_PATH-m_iTempDirSize);

	if(pTarget)
		{
		strlcpy(pTarget,cPath,iMax);
		PathConvert(pTarget+m_iTempDirSize);
		}


	   pTemp = GetFileName(cPath);
	if(pTemp>cPath)
		{
		pTemp[-1]=0;
		CreatePath(cPath);
		pTemp[-1]='\\';
		}

	if(ExistFile(cPath))
		{
		if(!RemoveFile(cPath) || ExistFile(cPath))
			{
			MessageBox(_T("Es konnte keine temporre Datei erzeugt werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
			return 0;
			}
		}


	CProgressDlg	sExtractDlg(this);

	m_iProgressLock	=  1;
	m_iProgressNow  =  0;
	m_iProgressMax  =  0;

	sExtractDlg.SetRange(pFile->Len(iItem));				// Die Datei extrahieren
	sExtractDlg.SetTitle(_T("Extrahieren"));
	sExtractDlg.SetProc (ExtractProc,this,pFile,m_cTempDir,&iItem,1);
	sExtractDlg.SetTime (ExtractTimeProc,250);
	sExtractDlg.SetDelay(EXTRACT_WAIT);
	sExtractDlg.DoModal ();

	if(sExtractDlg.GetExitCode()!=1)return 0;
	if(sExtractDlg.IsStoped	  ()!=0)return 0;
	if(ExistFile(cPath)!=1)
		{
		MessageBox(_T("Es konnte keine temporre Datei erzeugt werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}


return 1;
}


//*****************************************************************************
//*
//*		OnSaveCopyUI
//*
//*****************************************************************************
void CAzArchiverView::OnSaveCopyUI(CCmdUI *pCmdUI)
{
CArchiveFile   *pFile;

	pFile = GetArchive();
	pCmdUI->Enable(pFile!=0);
}


//*****************************************************************************
//*
//*		OnSaveCopy
//*
//*****************************************************************************
//	Eine Kopie des aktellen Arichives erstellen
void CAzArchiverView::OnSaveCopy()
{
CDocument	   *pDoc;
CArchiveFile   *pFile;
CProgressDlg	sDlg;
CString			sText;
CString			sName;
LPCSTR			pPath;
LPCSTR			pType;
unsigned		uSize;



		pFile = GetArchive();
	if(!pFile || pFile->Count()<=0)
		{
		MessageBox(_T("Es sind keine Dateien vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	pDoc	= GetDocument();
	pPath	= pDoc->GetPathName();
	pType	= GetFileType(pPath);


	sText.Format(_T("Archiv|*.%s|Alle Dateien|*.*|"),pType);

	CFileDialog	sFile(FALSE,pType,NULL,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY,sText);

	if(sFile.DoModal()!=IDOK)return;						// Zeilordner whlen


	if(pFile->GetMode()!=CAF_READ)
		{
		if(!pDoc->OnSaveDocument(pPath))
			{
			return;
			}
		}


	sName	= sFile.GetPathName();
	uSize	= LengthFile(pPath);

	if(uSize==0xFFFFFFFF)
		{
		MessageBox(_T("Die Archivdatei konnte nicht gefunden werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	sText.Format(_T("Erstelle %s."),(LPCTSTR)sName);

	sDlg.SetText (sText);
	sDlg.SetRange(uSize);
	sDlg.SetTitle(_T("Kopieren"));
	sDlg.SetProc (SaveCopyProc,this,pPath,(LPVOID)(LPCTSTR)sName);
	sDlg.SetDelay(EXTRACT_WAIT);
	sDlg.DoModal ();

	if(sDlg.GetExitCode())
		{
		MessageBox(_T("Die Kopie konnte nicht erstellt werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

}


//*****************************************************************************
//*
//*		SaveCopyProc
//*
//*****************************************************************************
//	Thread-Funktion zum kopieren eines Archives
//	Param[1]	= this
//	Param[2]	= Zeiger auf Quellpfad
//	Param[3]	= Zeiger auf Zielpfad
int _cdecl CAzArchiverView::SaveCopyProc(CProgressDlg *pDlg)
{
FILE			   *pFrom;
FILE			   *pFile;
CAzArchiverView	   *pThis   =(CAzArchiverView*)pDlg->GetVoid1();
LPCTSTR				pPath   =                  pDlg->GetChar2();
LPCTSTR				pTarget =	               pDlg->GetChar3();
unsigned char		ucBuffer[1024];
unsigned			uSize;
unsigned			uPos;



		pFrom = _tfopen(pPath,_T("rb"));
	if(!pFrom)return 1;

		pFile = _tfopen(pTarget,_T("wb"));
 	if(!pFile)
		{
		fclose(pFrom);
		return 1;
		}



	for(uPos=0;;uPos+=uSize)						// Hauptschleife
		{
		pDlg->SetPos(uPos);

		if(pDlg->IsStoped())
			{
			fclose(pFile);
			fclose(pFrom);
			RemoveFile(pTarget);
			return 0;
			}

			uSize = fread(ucBuffer,1,sizeof(ucBuffer),pFrom);
		if(!uSize)
			{
			fclose(pFile);
			fclose(pFrom);
			return 0;
			}

		if(fwrite(ucBuffer,1,uSize,pFile)!=uSize)
			{
			break;
			}

		}



	fclose(pFile);
	fclose(pFrom);


return 2;
}


//*****************************************************************************
//*
//*		OnEditorUI
//*
//*****************************************************************************
void CAzArchiverView::OnEditorUI(CCmdUI *pCmdUI)
{
CArchiveFile   *pFile;
HTREEITEM		hItem;


	pFile = GetArchive();
	hItem = m_cTreeList.GetSelectedItem();
	pCmdUI->Enable(hItem && pFile);
}


//*****************************************************************************
//*
//*		OnEditor
//*
//*****************************************************************************
//	Die Datei in einem Editor anzeigen
void CAzArchiverView::OnEditor()
{
	StartEditor(m_cTreeList.GetSelectedItem());
}

//*****************************************************************************
//*
//*		StartEditor
//*
//*****************************************************************************
//	Die Datei in einem Editor anzeigen
int CAzArchiverView::StartEditor(HTREEITEM hItem)
{
LPTSTR		    pTemp;


	pTemp = new TCHAR[MAX_PATH];

	if(!ExtractSingle(hItem,pTemp,MAX_PATH))
		{
		delete pTemp;
		return 0;
		}

	AfxBeginThread(EditorProc,pTemp,THREAD_PRIORITY_NORMAL,0x1000);


return 1;
}

//*****************************************************************************
//*
//*		EditorProc
//*
//*****************************************************************************
//	Diese Funktion startet den Editor und lscht anschlieen die temporre Datei
UINT _cdecl CAzArchiverView::EditorProc(void *pParam)
{
TCHAR			cDir[MAX_PATH];
CRegKeys		sKey;
CStartProg		sStart;
CString			sEditor;
LPTSTR			pPath;


	pPath = (LPTSTR)pParam;


	for(;;)
		{
		if(sKey.Open())
		if(sKey.Up(_T("Config")))
		if(sKey.Get(cDir,_T("PathEditor")))
			{
			sEditor=cDir;
			if(ExistFile(sEditor)==1)break;
			}

		GetExePath(cDir);
		AddFileName(cDir,_T("..\\Editor\\Editor.exe"),ENTRIES(cDir));
		sEditor=cDir;
		if(ExistFile(sEditor)==1)break;

		GetExePath(cDir);
		AddFileName(cDir,_T("Editor.exe"),ENTRIES(cDir));
		sEditor=cDir;
		if(ExistFile(sEditor)==1)break;

		sEditor=_T("D:\\MyProjects\\Editor\\Release\\Editor.exe");
		if(ExistFile(sEditor)==1)break;

		GetWindowsDirectory(cDir,ENTRIES(cDir));
		AddFileName(cDir,_T("Notepad.exe"),ENTRIES(cDir));
		sEditor=cDir;
		if(ExistFile(sEditor)==1)break;

		delete pParam;

		return 0;
		}


	sStart.SetFilename(sEditor);
	sStart.SetParam(pPath);
	sStart.Start();
	sStart.WaitForInit();

	while(m_iRunning)
		{
		if(sStart.Wait(5000))break;
		}


	RemoveFile(pPath);

	delete pParam;


return 0;
}


//*****************************************************************************
//*
//*		OnHexEditorUI
//*
//*****************************************************************************
void CAzArchiverView::OnHexEditorUI(CCmdUI *pCmdUI)
{
CArchiveFile   *pFile;
HTREEITEM		hItem;


	pFile = GetArchive();
	hItem = m_cTreeList.GetSelectedItem();
	pCmdUI->Enable(hItem && pFile);

}


//*****************************************************************************
//*
//*		OnHexEditor
//*
//*****************************************************************************
//	Die Datei in einem HexEditor anzeigen
void CAzArchiverView::OnHexEditor()
{
	StartHexEditor(m_cTreeList.GetSelectedItem());
}

//*****************************************************************************
//*
//*		StartHexEditor
//*
//*****************************************************************************
//	Die Datei in einem HexEditor anzeigen
int CAzArchiverView::StartHexEditor(HTREEITEM hItem)
{
LPTSTR		    pTemp;


	pTemp = new TCHAR[MAX_PATH];

	if(!ExtractSingle(hItem,pTemp,MAX_PATH))
		{
		delete pTemp;
		return 0;
		}

	AfxBeginThread(HexEditorProc,pTemp,THREAD_PRIORITY_NORMAL,0x1000);


return 1;
}

//*****************************************************************************
//*
//*		HexEditorProc
//*
//*****************************************************************************
//	Diese Funktion startet den HexEditor und lscht anschlieen die temporre Datei
UINT _cdecl CAzArchiverView::HexEditorProc(void *pParam)
{
TCHAR			cDir[MAX_PATH];
CRegKeys		sKey;
CStartProg		sStart;
CString			sHexEditor;
LPTSTR			pPath;


	pPath = (LPTSTR)pParam;


	for(;;)
		{
		if(sKey.Open())
		if(sKey.Up(_T("Config")))
		if(sKey.Get(cDir,_T("PathHexEditor")))
			{
			sHexEditor=cDir;
			if(ExistFile(sHexEditor)==1)break;
			}

		GetExePath(cDir);
		AddFileName(cDir,_T("..\\CrackTools\\HexEditor.exe"),ENTRIES(cDir));
		sHexEditor=cDir;
		if(ExistFile(sHexEditor)==1)break;

		GetExePath(cDir);
		AddFileName(cDir,_T("HexEditor.exe"),ENTRIES(cDir));
		sHexEditor=cDir;
		if(ExistFile(sHexEditor)==1)break;

		sHexEditor=_T("D:\\MyProjects\\HexEditor\\Release\\HexEditor.exe");
		if(ExistFile(sHexEditor)==1)break;

		GetWindowsDirectory(cDir,ENTRIES(cDir));
		AddFileName(cDir,_T("HexEditor.exe"),ENTRIES(cDir));
		sHexEditor=cDir;
		if(ExistFile(sHexEditor)==1)break;

		delete pParam;

		return 0;
		}


	sStart.SetFilename(sHexEditor);
	sStart.SetParam(pPath);
	sStart.Start();
	sStart.WaitForInit();

	while(m_iRunning)
		{
		if(sStart.Wait(5000))break;
		}


	RemoveFile(pPath);
	delete pParam;


return 0;
}

//*****************************************************************************
//*
//*		StartShell
//*
//*****************************************************************************
//	Die Datei mit dem original Programm ffnen
int CAzArchiverView::StartShell(HTREEITEM hItem)
{
char		cText[MAX_PATH+128];
LPTSTR		pTemp;


	pTemp = new TCHAR[MAX_PATH];

	if(!ExtractSingle(hItem,pTemp,MAX_PATH))
		{
		delete pTemp;
		return 0;
		}

	if(CmpFileType(pTemp,"exe;com;bat;js;vbs"))
		{
		sprintf(cText,"Bist du dir sicher das du %s starten mchstest ?",GetFileName(pTemp));

		if(MessageBox(cText,"Warnung",MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2)!=IDYES)
			{
			return 1;
			}
		}


	AfxBeginThread(ShellProc,pTemp,THREAD_PRIORITY_NORMAL,0x1000);



return 1;
}

//*****************************************************************************
//*
//*		ShellProc
//*
//*****************************************************************************
//	Diese Funktion startet das original Programm.
UINT _cdecl CAzArchiverView::ShellProc(void *pParam)
{
LPTSTR			pPath;


	pPath = (LPTSTR)pParam;

	ShellExecute(0,_T("open"),pPath,NULL,NULL,SW_SHOW);


return 0;
}

//*****************************************************************************
//*
//*		PictureProc
//*
//*****************************************************************************
//	Thread fr die Bildvorschau
UINT _cdecl CAzArchiverView::PictureProc(void *pParam)
{
TCHAR				cPath[MAX_PATH];
CAzArchiverView	   *pThis=(CAzArchiverView*)pParam;
CArchiveFile	   *pArchive;
LPCTSTR				pPath;
LPCTSTR				pName;
UINT				uLast;
UINT				uTick;
UINT				uDiff;
int					iFile;
int					iData;
int					iLen;
int					iRet;



	iData = 0;
	uLast = 0;

	while(!pThis->m_pPictureStop)
		{
		pThis->m_sPictureSem.Lock(500);
		iFile = pThis->m_iPictureSel;
		if(iFile<0)continue;

		for(;;)											// Nur alle 200ms eine nderung zulassen
			{
			uTick = GetTickCount();
			uDiff = uTick-uLast;
			uLast = uTick;

			if(uDiff>200)break;

			Sleep(200);

			if(iFile==pThis->m_iPictureSel)break;

			iFile = pThis->m_iPictureSel;
			uLast = GetTickCount();
			}

		pThis->m_iPictureSel = -1;

			pArchive = pThis->GetArchive();
		if(!pArchive)continue;							// Ist das Archiv gltig

		if(iFile>=pArchive->Count())continue;

		pThis->m_sFileMutex.Lock();

		if(pArchive->IsFail(iFile) ||					// Ist die Datei ok
		   pArchive->IsDir (iFile) ||
		   pArchive->IsDel (iFile))
			{
			pThis->m_sFileMutex.Unlock();
			continue;
			}

			pPath = pArchive->Name(iFile);				// Dateinamen holen
		if(!pPath)
			{
			pThis->m_sFileMutex.Unlock();
			continue;
			}

		pName = GetFileName(pPath);
														// Ist es ein Bild
		if(!CmpFileType(pName,"bmp;jpeg;jpg;gif;paz;png;tiff;xpm;xwd;pnm"))
			{
			pThis->m_sFileMutex.Unlock();
			continue;
			}

		for(iLen=0,iData=0;pName[iLen];iLen++)			// Checksumme erzeugen
			{
			bit_rol(iData,7);

			if(pName[iLen]>='A' && pName[iLen]<='Z')
					iData += pName[iLen]+32;
			else	iData += pName[iLen];
			}

		iLen = strlcpy(cPath,pThis->m_cTempBase,MAX_PATH-24);
		_stprintf(cPath+iLen,_T("AZ_%08X_%08X_%08X.tmp"),iFile,m_iAchiveId,iData);

		if(!ExistFile(cPath))							// Eine temorre Datei erzeugen
			{
			   iRet = pArchive->Extract(iFile,cPath);
			if(iRet!=CAF_ERROR_OK)
				{
				RemoveFile(cPath);
				pArchive->SetFail(iFile,1);
				pThis->m_sFileMutex.Unlock();
				continue;
				}

			pThis->m_sTempFiles.Add(cPath,CSC_END,&iData);
			}

		if(pThis->m_pPictureBox)						// Das Bild anzeigen
		if(pThis->m_pPictureBox->GetState()>=4)
			{
			pThis->m_pPictureBox->SetPicture(cPath,pName,FALSE);
			}

		pThis->m_sFileMutex.Unlock();
		}


	pThis->m_pPictureOn = 0;



return 0;
}

//*****************************************************************************
//*
//*		OnConfig
//*
//*****************************************************************************
//	AzArchiver konfigurieren
void CAzArchiverView::OnConfig()
{
CConfigDlg	sDlg;


	sDlg.DoModal();

}

//*****************************************************************************
//*
//*		OnBeginDrag
//*
//*****************************************************************************
//	Startet Drag aus TreeView
void CAzArchiverView::OnBeginDrag(NMHDR *pNmHdr, LRESULT *pResult)
{
CDropDataCAzArchiverView	sDragData(this);
NM_TREEVIEW				   *pTreeNm;



	pTreeNm		= (NM_TREEVIEW*)pNmHdr;
	m_iDragMode = 1;
	m_iDropDone	= 0;


	sDragData.DelayRenderData(CF_HDROP);
	sDragData.DoDragDrop(DROPEFFECT_COPY);
	sDragData.Empty();

	m_iDragMode = 0;
	*pResult    = 0;

}

//*****************************************************************************
//*
//*		OnDragScroll
//*
//*****************************************************************************
/*
DROPEFFECT CAzArchiverView::OnDragScroll(CWnd *pWnd,DWORD dwKeyState,CPoint sPoint)
{
CAzArchiverView	   *pView;
CArchiveFile	   *pFile;



	if(!pWnd)
		{
		return DROPEFFECT_NONE;
		}

		pView=(CAzArchiverView*)pWnd->GetParent();
	if(!pView)
		{
		return DROPEFFECT_NONE;
		}

	if(pView->m_iDragMode)
		{
		return DROPEFFECT_NONE;
		}

	if(pView->m_iWriteAllow==0)
		{
		pView->m_iDropMode = DROPEFFECT_NONE;
		return DROPEFFECT_NONE;
		}

	   pFile  =  pView->GetArchive();
	if(pFile && !pFile->HasCommpress())
		{
		pView->m_iDropMode = DROPEFFECT_NONE;
		return DROPEFFECT_NONE;
		}



return pView->m_iDropMode;
}
*/


//*****************************************************************************
//*
//*		OnDragOver
//*
//*****************************************************************************
//	Wird aufgerufen wenn sich die Maus im Fenster bewegt.
DROPEFFECT CAzArchiverView::OnDragOver(COleDataObject *pDataObject,DWORD dwKeyState,CPoint sPoint)
{
TCHAR			   cBuffer[MAX_PATH];
STGMEDIUM		   sData;
CArchiveFile	  *pFile;
int				   iCnt;



	if(m_iDragMode)
		{
		m_iDropMode = DROPEFFECT_NONE;
		return DROPEFFECT_NONE;
		}

	if(!pDataObject->IsDataAvailable(CF_HDROP))
		{
		m_iDropMode = DROPEFFECT_NONE;
		return DROPEFFECT_NONE;
		}

	if(m_iWriteAllow==0)
		{
		goto CheckArchive;
		}

	   pFile  =  GetArchive();
	if(pFile && !pFile->HasCommpress())
		{
		goto CheckArchive;
		}


	m_iDropMode = DROPEFFECT_COPY;


	return DROPEFFECT_COPY;


CheckArchive:


	m_iDropMode = DROPEFFECT_NONE;


	if(GetAsyncKeyState(VK_CONTROL)&0x8000)
		{
		return DROPEFFECT_NONE;
		}

	if(GetAsyncKeyState(VK_SHIFT  )&0x8000)
		{
		return DROPEFFECT_NONE;
		}

	if(!pDataObject->GetData(CF_HDROP,&sData))
		{
		return DROPEFFECT_NONE;
		}

	iCnt = DragQueryFile((HDROP)sData.hGlobal,-1,cBuffer,ENTRIES(cBuffer));

	if(iCnt!=1)
		{
		return DROPEFFECT_NONE;
		}

	DragQueryFile((HDROP)sData.hGlobal,0,cBuffer,ENTRIES(cBuffer));

	if(!CmpFileType(cBuffer,FILTER_LIST))
		{
		return DROPEFFECT_NONE;
		}

	m_iDropMode = DROPEFFECT_COPY;



return DROPEFFECT_COPY;
}

//*****************************************************************************
//*
//*		OnDrop
//*
//*****************************************************************************
//	Wird aufgerufen wenn Dateien aufs Fenster gedropt werden.
BOOL CAzArchiverView::OnDrop(COleDataObject *pDataObject,DROPEFFECT uDropEffect,CPoint sPoint)
{
TCHAR				cBuffer[MAX_PATH];
STGMEDIUM			sData;
int					iCnt;
int					i;



	if(!pDataObject->GetData(CF_HDROP,&sData))
		{
		return FALSE;
		}


	m_sDropList.Del();

	iCnt = DragQueryFile((HDROP)sData.hGlobal,-1,cBuffer,ENTRIES(cBuffer));

	for(i=0;i<iCnt;i++)
		{
		DragQueryFile((HDROP)sData.hGlobal,i,cBuffer,ENTRIES(cBuffer));
		m_sDropList.Add(cBuffer);
		}


	OnDragLeave();

	PostMessage(WM_COMMAND,ID_DROPDONE);



return TRUE;
}



//*****************************************************************************
//*
//*		OnRenderData
//*
//*****************************************************************************
//	Wird aufgerufen wenn das Drop-Ziel die Daten anfordert
BOOL CAzArchiverView::OnRenderData(LPFORMATETC pFormatEtc,LPSTGMEDIUM pStgMedium)
{
TCHAR			cTemp[MAX_PATH];
HTREEITEM		hItem;
LPCTSTR			pPath;
LPCTSTR			pName;
HGLOBAL			hGlobal;
CStringChain	sDirs;
CArchiveFile   *pFile;
TCHAR		   *pMem;
int			   *pItems;
int				iCount;
int				iBytes;
int				iItem;
int				iNum;
int				iPos;
int				iLen;
int				iAdd;
__int64			iSize;




	memset(pStgMedium,0,sizeof(LPSTGMEDIUM));


		pFile = GetArchive();
	if(!pFile || pFile->Count()<=0)
		{
		MessageBox(_T("Es sind keine Dateien vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return FALSE;
		}


	hItem	= m_cTreeList.GetNextSelected(TVI_ROOT);
	iCount	= pFile->Count();
	pItems	= new int[iCount];
	iSize	= 0;


	if(!pItems)
		{
		MessageBox(_T("Zu wenig Speicher !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return FALSE;
		}


	if(!hItem)											// Sind Dateien gewhlt
		{
		MessageBox(_T("Es sind keine Eintrge ausgewhlt !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return FALSE;
		}


	iBytes = 0;
	m_iMarkValue++;

	for(iNum=0;iNum<iCount;)							// Suche alle selektierten Daten
		{
		   iItem = m_cTreeList.GetItemData(hItem);
		if(iItem>=0 && !pFile->IsDir(iItem))
			{
			pItems[iNum] = iItem;
			pFile->SetUserData(iItem,m_iMarkValue);
			iSize  += pFile->Len (iItem);
			pPath   = pFile->Name(iItem);
			iBytes += _tcslen(pPath)+1;
			iBytes += m_iTempDirSize;
			iNum   += 1;
			}
		else{
			pName   = m_cTreeList.GetItemText(hItem,0);
			pPath   = m_cTreeList.GetItemText(hItem,6)+1;
			iAdd    = ExtractPath(pFile,pPath,pName,pItems+iNum,iCount-iNum,iSize);
			iLen	= strlcpy(cTemp     ,pPath,MAX_PATH     );
			iLen   += strlcpy(cTemp+iLen,pName,MAX_PATH-iLen);
			iBytes += m_iTempDirSize;
			iBytes += iLen+1;

			sDirs.Add(iLen,cTemp);

			for(;iAdd>0;iAdd--,iNum++)
				{
				pItems[iNum] |= 0x80000000;
				}
			}

			hItem = m_cTreeList.GetNextSelected(hItem);
		if(!hItem)break;
		}

	hGlobal = GlobalAlloc(GMEM_ZEROINIT|GMEM_MOVEABLE|GMEM_DDESHARE,iBytes*sizeof(TCHAR)+24);
	pMem    = (TCHAR*)GlobalLock(hGlobal);
	pMem[0] = 20;
	#ifdef UNICODE
	pMem[8] = 1;
	#endif
	pMem   += 20/sizeof(TCHAR);


	for(iPos=0;iPos<iNum;iPos++)						// Dateinamen zusammenbauen
		{
		   iItem=pItems[iPos];
		if(iItem&0x80000000)
			{
			pItems[iPos]&=0x7FFFFFFF;
			continue;
			}

		pPath  = pFile->Name(iItem);
		iLen   = _tcslen(pPath)+1;

		memcpy(pMem,m_cTempDir,m_iTempDirSize*sizeof(TCHAR));	pMem+=m_iTempDirSize;
		memcpy(pMem,pPath     ,iLen          *sizeof(TCHAR));
		PathConvert(pMem								   );	pMem+=iLen;
		}

	for(iPos=0;iPos<sDirs.Count();iPos++)				// Verzeichnisse anhngen
		{
		pPath  = sDirs.Get(iPos);
		iLen   = sDirs.Len(iPos)+1;

		memcpy(pMem,m_cTempDir,m_iTempDirSize*sizeof(TCHAR));	pMem+=m_iTempDirSize;
		memcpy(pMem,pPath     ,iLen          *sizeof(TCHAR));
		PathConvert(pMem                                   );	pMem+=iLen;
		}

	pMem[0]=0;

	GlobalUnlock(hGlobal);

														// Die Dateien umkopieren
	if(!m_iDropDone && !(GetAsyncKeyState(VK_LBUTTON)&0x8000))
		{
		CProgressDlg	sDlg(this);

		m_iProgressLock	=  1;
		m_iProgressNow  =  0;
		m_iProgressMax  =  0;

		sDlg.SetRange(iSize);
		sDlg.SetTitle(_T("Extrahieren"));
		sDlg.SetProc (ExtractProc,this,pFile,m_cTempDir,pItems,-iNum);
		sDlg.SetTime (ExtractTimeProc,250);
		sDlg.SetDelay(EXTRACT_WAIT);


		if(sDlg.DoModal()!=IDOK)
			{
			GlobalFree(hGlobal);
			delete pItems;
			return FALSE;
			}

		m_iDropDone = 1;
		}

	delete pItems;


	pStgMedium->tymed			= TYMED_HGLOBAL;
	pStgMedium->hGlobal			= hGlobal;
	pStgMedium->pUnkForRelease	= NULL;



return TRUE;
}

//*****************************************************************************
//*
//*		OnFileSaveUI
//*
//*****************************************************************************
void CAzArchiverView::OnFileSaveUI(CCmdUI *pCmdUI)
{
CArchiveFile   *pFile;

	pFile = GetArchive();
	pCmdUI->Enable(pFile && pFile->HasCommpress() && pFile->GetMode()>CAF_READ);
}


//*****************************************************************************
//*
//*		ExecuteCb
//*
//*****************************************************************************
//	Callback fr Shell-Menaufruf.
int	CALLBACK CAzArchiverView::ExecuteCb(HWND hWnd,LPVOID pParam,UINT uCommand)
{
CAzArchiverView	*pThis=(CAzArchiverView*)pParam;


	SetCursor(IDC_WAIT);

	return pThis->ExtractSingle(pThis->m_hExecuteItem);

}

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CAzArchiverView::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
TCHAR				cName[MAX_PATH];
FILE			   *pTemp;
CMenu			   *pMenu;
CArchiveFile	   *pFile;
CStringArray        sArray;
CShellContextMenu	cMenu;
HTREEITEM			hItem;
LPCTSTR				pPath;
LPCTSTR				pText;
LPTSTR				pName;
UINT				uBits;
int					iItem;
int					iLen;
int					iCmd;



	if(!pWnd || pWnd->m_hWnd!=m_cTreeList.m_hWnd)
		{
		return;
		}

		hItem = m_cTreeList.GetFocusItem();
	if(!hItem)return;

		pFile = GetArchive();
	if(!pFile || pFile->Count()<=0)
		{
		return;
		}


	iItem = m_cTreeList.GetItemData(hItem);

	if(iItem<0 || pFile->IsDir(iItem))
		{
		return;
		}
	else{
		pPath  = pFile->Name(iItem);

		iLen  = strlcpy(cName,m_cTempDir,MAX_PATH,m_iTempDirSize);
		iLen += strlcpy(cName+iLen,pPath,MAX_PATH-iLen);

		PathConvert(cName);

		if(!ExistFile(cName))
			{
				pTemp = _tfopen(cName,_T("wb"));
			if(!pTemp)
				{
				   pName = GetFileName(cName);
				if(pName<=cName)
					{
					return;
					}

				pName[-1] = 0;
				CreatePath(cName);
				pName[-1] = '\\';
				pTemp     = _tfopen(cName,_T("wb"));

				if(!pTemp)return;
				}

			fclose(pTemp);
			}

		m_hExecuteItem = hItem;

		sArray.Add(cName);

		cMenu.SetObjects(sArray);
		cMenu.SetCallback(this,ExecuteCb);
		pMenu = cMenu.GetMenu();
		pMenu->InsertMenu(0,MF_SEPARATOR);
		pMenu->InsertMenu(0,MF_STRING,0xF000,_T("Editor"       ));
		pMenu->InsertMenu(0,MF_STRING,0xF001,_T("HexEditor"    ));
		pMenu->InsertMenu(0,MF_STRING,0xF002,_T("Extrahieren"  ));
		pMenu->InsertMenu(0,MF_STRING,0xF003,_T("Feld kopieren"));

		AddMenuBitmap(pMenu,0xF000,IDB_TOOLICONS,4);
		AddMenuBitmap(pMenu,0xF001,IDB_TOOLICONS,5);

		iCmd = cMenu.ShowContextMenu(this,sPoint);

		SetCursor(IDC_ARROW);

		if(iCmd==0xF000)StartEditor   (hItem);
		if(iCmd==0xF001)StartHexEditor(hItem);
		if(iCmd==0xF002)OnExtract();
		if(iCmd==0xF003)
			{
			m_cTreeList.ScreenToClient(&sPoint);
			m_cTreeList.HitTest(sPoint,&uBits);

			   pText = m_cTreeList.GetItemText(hItem,uBits>>24);
			if(pText)
				{
				if((uBits>>24)==6 && *pText==' ')pText++;
				SetClipboardText(pText);
				}
			}
		}



}

//*****************************************************************************
//*
//*		SortPath
//*
//*****************************************************************************
//	Sortierfunktion fr Droplisten
int _cdecl CAzArchiverView:: SortPath(CStringChain *pChain,int iPos1,int iPos2)
{
return strpicmp(pChain->Get(iPos1),pChain->Get(iPos2));
}

//*****************************************************************************
//*
//*		InsertProc
//*
//*****************************************************************************
//	Thread-Funktion zum Hinzufgen der von Dateien
//	Param[1]	= this
//	Param[2]	= Zeiger auf Archivdatei
//	Param[3]	= Zeiger auf CInsertDlg
//	Param[4]	= Einfgen mit Art
//					0 = Direkt aus Dropliste
//					1 = Dateien	aus CFileDialg
//					2 = Mit Filter aus aus dem Pfad von CFileDialg
//					Bit 2 (0x04) ->	Direkt aus Dropliste (ohne Filter und Subpfad)
int _cdecl CAzArchiverView::InsertProc(CProgressDlg *pDlg)
{
CAzArchiverDoc	   *pDoc;
CAzArchiverView	   *pThis =(CAzArchiverView*)pDlg->GetVoid1();
CArchiveFile	   *pFile =(CArchiveFile   *)pDlg->GetVoid2();
CInsertDlg		   *pDlgF =(CInsertDlg     *)pDlg->GetVoid3();
int 				iMode =                  pDlg->GetInt4();
CFileFinder			sFind;
CString				sPath;
TCHAR				cName[MAX_PATH];
TCHAR				cTemp[MAX_PATH];
POSITION			hNext;
LPCTSTR				pPath;
LPCTSTR				pName;
LPCTSTR				pPtr;
int					iPos;
int					iOff;
int					iAdd;
int					iVal;
int					iNum;
int					iNot;
int					iOk;



	pFile->Flags(pFile->Flags()&~(CAF_FLAG_NOREADONLY|CAF_FLAG_NOEXIST));
	iOff	= strlcpy(cName,pDlgF->m_sSubPath,ENTRIES(cName));
	iOff	= AddBackSlash(cName,iOff);
	iAdd    = 0;
	iNot	= 0;
	iOk		= 0;

	if(iOff==1)iOff=0;


	if(iMode==4)										// Keine Subpfade
		{
		cName[0] = 0;
		iOff     = 0;
		}


	if(iMode==2)
		{
		sFind.Set(pDlgF->m_sStartPath,(pDlgF->m_bSubSearch)? CFF_FIND_SUBDIR:0,pDlgF->m_sPlusFilter,pDlgF->m_sMinusFilter);
		}
	else if(iMode==1)
		{
		hNext = pDlgF->GetStartPosition();
		}
	else{												// Gibt es einen Basis Pfad
		pThis->m_sDropList.Sort(0,-1,SortPath);
		pPath = pThis->m_sDropList[0];
		iNum  = GetFilePathR(cTemp,pPath,ENTRIES(cTemp));

		for(iPos=1;iPos<pThis->m_sDropList.Count();iPos++)
			{
			pPath = pThis->m_sDropList[iPos];
			if(strpicmp(pPath,cTemp,iNum))break;
			}

		if(iPos>=pThis->m_sDropList.Count())
			{
			iAdd = iNum;
			}
		}


	pThis->m_sFileMutex.Lock();

	for(iPos=0;;iPos++)									// Hauptschleife
		{
		if(pDlg->IsStoped())break;

		if(iMode&0x80)									// Suche in Verzeichnis
			{
			iPos--;

				pPath = sFind.Next(1);
			if(!pPath)
				{
				iMode&=0x7F;
				continue;
				}
			pName = (iAdd)? pPath+iAdd:sFind.Name(-1,2);
			}
		else if(iMode==2)								// Suche in Verzeichnis
			{
				pPath = sFind.Next(1);
			if(!pPath)break;

			pName = sFind.Name(-1,2);
			}
		else if(iMode==1)								// Auswahl aus Dialog
			{
			if(!hNext)break;
			sPath = pDlgF->GetNextPathName(hNext);
			pPath = sPath;
			pName = GetFileName(pPath);
			}
		else{											// Direkte Liste
			if(iPos>=pThis->m_sDropList.Count())break;
			pPath =  pThis->m_sDropList[iPos];
			pName = (iAdd)? pPath+iAdd:GetFileName(pPath);

			if(ExistFile(pPath)>=2)
				{
				if(iNot==0)								// Ist das Verzeichnis alleine in der Liste
					{
					iVal = pThis->m_sDropList.Len(iPos);
					pPtr = pThis->m_sDropList[iPos+1];

					if(pPtr && strpicmp(pPath,pPtr,iVal)==0 && pPtr[iVal]=='\\')
						{
						iNot = 1;
						}
					}

				if(iNot)								// Nur Verzeichnis erzeugen
					{
					strlcpy(cName+iOff,pName,ENTRIES(cName)-iOff);

					if(pFile->AddPath(cName)==CAF_ERROR_OK)
						{
						iOk++;
						}
					}
				else{									// Im Verzeichnis suchen
					if(iMode&4)
							sFind.Set(pPath,CFF_FIND_SUBDIR);
					else	sFind.Set(pPath,CFF_FIND_SUBDIR,pDlgF->m_sPlusFilter,pDlgF->m_sMinusFilter);

					iMode  |= 0x80;
					}

				continue;
				}
			}


		CommpressFileName(pName,cTemp,ENTRIES(cTemp),410,pThis->m_aFontSize);
		pDlg->SetText(cTemp);


		if(pFile->GetMode()==CAF_READ)
		if(pFile->Change ()!=CAF_ERROR_OK)
			{
			pDlg->MessageBox(_T("Es kann nicht in das Arichv geschrieben werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
			break;
			}


		strlcpy(cName+iOff,pName,ENTRIES(cName)-iOff);
		if(pFile->AddFile(pPath,cName)==CAF_ERROR_OK)
			{
			iOk++;
			}
		}

	pThis->m_sFileMutex.Unlock();


	if(iOk>0)											// Gab es nderungen
		{
		   pDoc = pThis->GetDocument();
		if(pDoc)pDoc->SetModifiedFlag();
		}


	pThis->m_sDropList.Del();


return iOk;
}


//*****************************************************************************
//*
//*		OnInsertUI
//*
//*****************************************************************************
void CAzArchiverView::OnInsertUI(CCmdUI *pCmdUI)
{
CArchiveFile   *pFile;

	pFile = GetArchive();
	pCmdUI->Enable(pFile && pFile->HasCommpress());
}

//*****************************************************************************
//*
//*		OnInsert
//*
//*****************************************************************************
void CAzArchiverView::OnInsert()
{
CArchiveFile   *pFile;
CInsertDlg		sFile;
CProgressDlg	sDlg;
int				iRet;


		pFile = GetArchive();
	if(!pFile || pFile->GetMode()==CAF_CLOSED)
		{
		MessageBox(_T("Es ist kein Arichv geffnet !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	if(!pFile->HasCommpress())
		{
		MessageBox(_T("Bei diesem Arichv-Typ untersttzt kein Hinzfgen von Dateien !"),_T("Information"),MB_OK|MB_ICONINFORMATION);
		return;
		}

	   iRet = sFile.DoModal();
	if(iRet==IDCANCEL)
		{
		return;
		}


	sDlg.SetTitle(_T("Hinzfgen"));
	sDlg.SetProc (InsertProc,this,pFile,&sFile,(iRet==IDOK)? 1:2);
	sDlg.SetProgressMode(350);
	sDlg.DoModal();

	if(sDlg.GetExitCode()>0)							// Wurden Dateien eingefgt
		{
		OnUpdate(NULL,3,NULL);
		}

}

//*****************************************************************************
//*
//*		OnDropDone
//*
//*****************************************************************************
void CAzArchiverView::OnDropDone()
{
CDocument	*pDoc;


	if(m_sDropList.Count()==1)
	if(CmpFileType(m_sDropList[0],FILTER_LIST))
	if(!(GetAsyncKeyState(VK_CONTROL)&0x8000))
	if(!(GetAsyncKeyState(VK_SHIFT  )&0x8000))
		{
			pDoc = GetDocument();
		if(!pDoc)return;

		pDoc->OnOpenDocument(m_sDropList[0]);
		return;
		}

	InsertCmd(0,1);
}

//*****************************************************************************
//*
//*		InsertCmd
//*
//*****************************************************************************
//	Einfgen von Dateien aus einer Liste
//	pPath		: Ist der einzufgende Pfad oder die Dateiliste. (0=Dorp-Liste)
//	iCmd		: Bestimmt die Art des einfgen der Dateien
//					Bit0 = Einfgedialog benutzen.
//					Bit1 = Pfad ist eine Dateiliste
//					Bit2 = Dateiliste lschen
//				  	Bit3 = Filter und Unterpfade ignorieren
//				  	Bit4 = Filter und Unterpfade bernehmen
void CAzArchiverView::InsertCmd(LPCTSTR	pPath,int iCmd)
{
char 			cLine[512];
TCHAR			cName[512];
LPCTSTR			pName;
FILE		   *pList;
CArchiveFile   *pFile;
CInsertExDlg	sInsert;
CInsertDlg		sFile;
CProgressDlg	sDlg;
int				iLen;
int				iPos;
int				iTyp;



		pFile = GetArchive();
	if(!pFile || pFile->GetMode()==CAF_CLOSED)
		{
		MessageBox(_T("Es ist kein Arichv geffnet !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	if(!pFile->HasCommpress())
		{
		MessageBox(_T("Bei diesem Arichv-Typ untersttzt kein Hinzfgen von Dateien !"),_T("Information"),MB_OK|MB_ICONINFORMATION);
		return;
		}


	iTyp = 0;

	if(pPath)											// Neue Liste aufbauen
		{
		if(iCmd&2)
			{
				pList = _tfopen(pPath,_T("rb"));
			if(!pList)
				{
				MessageBox(_T("Die Dateiliste konnte nicht geladen werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
				return;
				}

			m_sDropList.Del();
			cLine[511]=0;

			while(fgets(cLine,511,pList))				// Pfade aus einer Dateiliste holen
				{
				strcut(cLine);
				if(!cLine[0])continue;
				iLen=strfromutf8(cName,cLine,ENTRIES(cName));
				m_sDropList.Add(iLen,cName);
				}

			fclose(pList);

			if(iCmd&4)RemoveFile(pPath);
			}
		else{											// Einzelner Pfad
			pName = GetFileName(pPath);
			iPos  = strcwlen(pName,0x01800000);

			m_sDropList.Del();

			if(pName[iPos])								// Gibt es Wildcards (*/?)
				{
				strlcpy(cLine,pPath,ENTRIES(cLine),pName-pPath);
				pPath = cLine;
				iLen  = strchar(pName,'|');

				sFile.m_sPlusFilter = pName;
				sFile.m_sStartPath  = pPath;

				if(pName[iLen])
					{
					sFile.m_sMinusFilter = pName+1;
					sFile.m_sPlusFilter  = sFile.m_sPlusFilter.Left(iLen);
					}

				if(m_iHasSub)
					{
					sFile.m_sSubPath = m_sSubInsert;
					}

				iTyp  =  2;
				iCmd &= ~8;
				}

			m_sDropList.Add(pPath);
			}
		}


	if(m_sDropList.Count()<=0)return;

	if(iCmd&1)											// Einfgen ber CFileDialog
		{
		if(sInsert.DoModal()!=IDOK)return;
		}


	sDlg.SetTitle(_T("Hinzfgen"));
	sDlg.SetProc (InsertProc,this,pFile,&sFile,(iCmd&8)? 4:iTyp);
	sDlg.SetProgressMode(350);
	sDlg.DoModal();

	if(sDlg.GetExitCode()>0)							// Wurden Dateien eingefgt
		{
		OnUpdate(NULL,3,NULL);
		}

}
//*****************************************************************************
//*
//*		OnPictureBox
//*
//*****************************************************************************
//	PictureBox Status abfragen
LRESULT CAzArchiverView::OnPictureBox(WPARAM wParam,LPARAM lParam)
{
return PictureBoxMode();
}

//*****************************************************************************
//*
//*		OnStartCommand
//*
//*****************************************************************************
//	Kommandos von der Kommandozeile ausfhren.
LRESULT CAzArchiverView::OnStartCommand(WPARAM wParam,LPARAM lParam)
{
LPCTSTR			pPath=(LPCTSTR)lParam;
char			cLine[512];
TCHAR			cName[512];
CString			sPath;
FILE		   *pFile;
CAzArchiverDoc *pDoc;
CInsertNewDlg	sNew;
static CString	sTmp;
static CString	sLst;
CString			sTxt;
LPCTSTR			pTxt;



	switch(wParam)
		{
	case 1:													// Extrahiere nach
				ExtractCmd((*pPath!='*')? pPath:0,1);
				AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_APP_EXIT);
				break;

	case 2:													// Erzeuge neues Archiv
	case 3:		pDoc  = GetDocument();
				sNew.m_sArchivPath = sTmp;

				if(m_iHasSub)
					{
					sNew.m_sSubPath  = m_sSubInsert;
					sNew.m_iNoLast  |= 0x02;
					}

				sNew.m_bCreateNew = TRUE;
				sNew.m_iNoLast   |= 0x10;

				if(pDoc!=NULL)
				if(sNew.DoModal()==IDOK)
					{
					pTxt  = sNew.m_sArchivPath;
					pTxt += strcwlen(pTxt,0x00700000);

					if(*pTxt==0)							// Kein Pfad
						{
						if(wParam==3)
								BasePathOfList(sTxt,pPath);
						else	GetFilePath   (sTxt,pPath);

						sTxt += sNew.m_sArchivPath;
						sNew.m_sArchivPath = sTxt;
						}
															// Kein Suffix
					if(CmpFileType(sNew.m_sArchivPath,_T("")))
						{
						sNew.m_sArchivPath += _T(".zip");
						}

					if(pDoc->OnCreateDocument(sNew.m_sArchivPath))
						{
						InsertCmd(pPath,(wParam==3)? 0x06:0x00);
						}
					}

				AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_APP_EXIT);
				break;

	case 4:													// Erzeuge neues Archiv (ohne Dialog)
	case 5:		   pDoc = GetDocument();
				if(pDoc!=NULL)
				if(pDoc->OnCreateDocument(sTmp))
					{
					InsertCmd(pPath,(wParam==5)? 0x0E:0x08);
					}

				AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_APP_EXIT);
				break;

	case 6:													// Fge in Archiv ein
	case 7:		InsertCmd(pPath,(wParam==7)? 0x07:0x01);
				AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_APP_EXIT);
				break;

	case 8:													// Fge in Archiv ein (ohne Dialog)
	case 9:		InsertCmd(pPath,(wParam==9)? 0x0E:0x08);
				AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_APP_EXIT);
				break;


	case 10:
	case 11:	pDoc = GetDocument();						// Fge in Archiv ein (mit Dialog-Archiv-Auswahl)
				sNew.m_sArchivPath = sTmp;

				if(m_iHasSub)
					{
					sNew.m_sSubPath  = m_sSubInsert;
					sNew.m_iNoLast  |= 0x02;
					}

				sNew.m_bCreateNew = FALSE;
				sNew.m_iNoLast   |= 0x10;

				if(pDoc!=NULL)
				if(sNew.DoModal()==IDOK)
					{
					if(sNew.m_bCreateNew || ExistFile(sNew.m_sArchivPath)==0)
						{
						pTxt  = sNew.m_sArchivPath;
						pTxt += strcwlen(pTxt,0x00700000);

						if(*pTxt==0)						// Kein Pfad
							{
							if(wParam==11)
									BasePathOfList(sTxt,pPath);
							else	GetFilePath   (sTxt,pPath);

							sTxt += sNew.m_sArchivPath;
							sNew.m_sArchivPath = sTxt;
							}
						}
				 											// Kein Suffix
					if(CmpFileType(sNew.m_sArchivPath,_T("")))
						{
						sNew.m_sArchivPath += _T(".zip");
						}

					if(sNew.m_bCreateNew || ExistFile(sNew.m_sArchivPath)==0)
						{
						if(pDoc->OnCreateDocument(sNew.m_sArchivPath))
							{
							InsertCmd(pPath,(wParam==11)? 0x06:0x00);
							}
						}
					else{
						if(pDoc->OnOpenDocument(sNew.m_sArchivPath))
							{
							InsertCmd(pPath,(wParam==11)? 0x06:0x00);
							}
						}
					}

				AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_APP_EXIT);
				break;
	case 12:												// Entpacke eine List von Zip-Dateien
					pFile = _tfopen(sLst,"rb");
				if(!pFile)break;

				cLine[511]=0;
				m_bUserBreak=0;

				while(fgets(cLine,511,pFile))				// Pfade aus einer Dateiliste holen
					{
					strcut(cLine);
					if(!cLine[0])continue;
					strfromutf8(cName,cLine,ENTRIES(cName));

						pDoc = GetDocument();				// ffne ZIP-Datei
					if(!pDoc || !pDoc->OnOpenDocument(cName))
						{
						sTxt.Format(_T("Die Datei '%s' konnte nicht geffnet werden !"),cName);
						if(AfxGetMainWnd()->MessageBox(sTxt,_T("Fehler"),MB_OKCANCEL|MB_ICONERROR)!=IDCANCEL)
								continue;
						else	break;
						}

					ExtractCmd((*pPath!='*')? pPath:0,1);
					if(*pPath=='*')pPath=m_sExtractPath;
					if(m_bUserBreak)break;
					}

				fclose(pFile);
				RemoveFile(sLst);
				AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_APP_EXIT);
				break;

	case 252:	pDoc = GetDocument();						// Lschen und Schliesen
				sPath = pDoc->GetPathName();
				pDoc->CloseArchiv();
				if(!sPath.IsEmpty())ClearFile(sPath);
				AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_APP_EXIT);
				break;

	case 253:	CConfigDlg::Uninstall();					// Konfiguration lschen
				AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_APP_EXIT);
				break;

	case 254:	OnConfig();									// Konfigurieren mit Beenden
				AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_APP_EXIT);
				break;

	case 255:	OnConfig();									// Konfigurieren
				break;

	case 256:	sTmp = pPath;								// Temporren Namen bergeben
				break;

	case 257:	pDoc = GetDocument();						// Setze NotOverWrite Flag
				pDoc->SetNotOverWrite();
				break;
	case 258:	sLst = pPath;								// Liste mit Zip-Dateien bergeben
				break;

	case 259:	m_sSubInsert = pPath;						// Add-Pfad fr Einfgen
				m_iHasSub    = 1;
				break;

		}


return 0;
}

//*****************************************************************************
//*
//*		OnSelChanged
//*
//*****************************************************************************
void CAzArchiverView::OnSelChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTREEVIEW	   *pTree = (NMTREEVIEW*)pNmHdr;
CArchiveFile   *pFile;



		pFile = GetArchive();
	if(!pFile)
		{
		m_iSelCount = 0;
		m_iSelBytes = 0;
		return;
		}

	if(!(pTree->action&TVIF_ONLYFOCUS))
		{
		if(pTree->itemNew.hItem)
			{
			if(pTree->itemNew.state&TVIS_SELECTED)
				{
				m_iSelCount += 1;
				m_iSelBytes	+= pFile->Len(pTree->itemNew.lParam);

				if(m_pPictureBox && m_pPictureBox->GetState()>=4)
					{
					m_iPictureSel = pTree->itemNew.lParam;
					m_hItemSelect = pTree->itemNew.hItem;

					if(!m_pPictureOn)
						{
						m_pPictureOn = TRUE;
						AfxBeginThread(PictureProc,this,THREAD_PRIORITY_NORMAL,0x4000);
						}

					m_sPictureSem.Unlock();
					}
				}
			else{
				if(m_iSelCount>0)
					{
					m_iSelCount -= 1;
					m_iSelBytes	-= pFile->Len(pTree->itemNew.lParam);
					}

				if(m_hItemSelect==pTree->itemNew.hItem && m_hLastSelect)
					{
					if(m_cTreeList.GetItemState(m_hLastSelect,TVIS_SELECTED)&TVIS_SELECTED)
						{
						m_iPictureSel = m_cTreeList.GetItemData(m_hLastSelect);
						m_hItemSelect = m_hLastSelect;

						if(!m_pPictureOn)
							{
							m_pPictureOn = TRUE;
							AfxBeginThread(PictureProc,this,THREAD_PRIORITY_NORMAL,0x4000);
							}

						m_sPictureSem.Unlock();
						}
					}
				}
			}

		if(pTree->itemOld.hItem)
			{
			if(pTree->itemOld.state&TVIS_SELECTED)
				{
				m_iSelCount += 1;
				m_iSelBytes	+= pFile->Len(pTree->itemOld.lParam);
				}
			else{
				if(m_iSelCount>0)
					{
					m_iSelCount -= 1;
					m_iSelBytes	-= pFile->Len(pTree->itemOld.lParam);
					}
				}
			}

		m_hLastSelect = NULL;
		}
	else{
		m_hLastSelect = pTree->itemNew.hItem;
		}


	if(!m_iSelLock)
		{
		if(!m_iSelTimer)SetTimer(ID_SELTEXT,100,NULL);
		m_iSelTimer = 3;
		}

}

//*****************************************************************************
//*
//*		SetSelText
//*
//*****************************************************************************
void CAzArchiverView::SetSelText()
{
CWnd   *pWnd;
int		iLen;




	if(m_iSelCount==1)
		{
		iLen = _stprintf(m_cSelText,_T("1 Datei ausgewhlt  ("));
		}
	else{
		iLen = _stprintf(m_cSelText,_T("%i Dateien ausgewhlt  ("),m_iSelCount);
		}

	iLen += vtostr(m_iSelBytes,m_cSelText+iLen,VTS_SIGNED|VTS_SHRINKCOMMA|VTS_ADDSUFFIX|VTS_ADDSPACE|VTS_BIN10|(' '<<24)|0x8320,VTS_BYTESUFFIX);
	_tcscpy(m_cSelText+iLen,_T(")"));

	pWnd = AfxGetMainWnd();

	if(pWnd && IsWindow(pWnd->m_hWnd))
		{
		pWnd->PostMessage(WM_SETSTATUSTEXT,0,(LPARAM)m_cSelText);
		}

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CAzArchiverView::OnTimer(UINT_PTR nIdEvent)
{

	if(nIdEvent==ID_SELTEXT)
		{
		m_iSelTimer--;

		if(!m_iSelTimer)
			{
			KillTimer(ID_SELTEXT);
			}

		SetSelText();
		return;
		}

	CView::OnTimer(nIdEvent);

}

//*****************************************************************************
//*
//*		OnTest
//*
//*****************************************************************************
void CAzArchiverView::OnTest()
{
	if(m_pPictureBox && m_pPictureBox->GetState()>=4)
		{
		m_pPictureBox->SetPicture("D:\\ZumKulm.bmp");
		}
}

//*****************************************************************************
//*
//*		OnPictureBoxUI
//*
//*****************************************************************************
void CAzArchiverView::OnPictureBoxUI(CCmdUI *pCmdUI)
{

	if(m_pPictureBox->GetState()<4)
		{
		pCmdUI->SetCheck(FALSE);
		}
	else{
		pCmdUI->SetCheck(TRUE);
		}

}

//*****************************************************************************
//*
//*		PictureBoxMode
//*
//*****************************************************************************
int	CAzArchiverView::PictureBoxMode()
{
return m_pPictureBox->GetState();
}

//*****************************************************************************
//*
//*		OnPictureBox
//*
//*****************************************************************************
void CAzArchiverView::OnPictureBox()
{
HTREEITEM	hItem;
int			iState;


	iState = m_pPictureBox->GetState();

	switch(iState)
		{

	case 0:		m_pPictureBox = new CPictureBoxFrame;
				m_pPictureBox->SetThisPtr(&m_pPictureBox);
	case 1:
	case 2:		m_pPictureBox->Create(NULL,"Bildvorschau");
	case 3:
				if(m_pPictureBox->IsIconic())
					{
					m_pPictureBox->ShowWindow(SW_SHOWNORMAL);
					}
				else{
					m_pPictureBox->ShowWindow(SW_SHOW);
					}

					hItem = m_cTreeList.GetFirstSelected();
				if(!hItem)break;

				m_iPictureSel = m_cTreeList.GetItemData(hItem);

				if(!m_pPictureOn)
					{
					m_pPictureOn = TRUE;
					AfxBeginThread(PictureProc,this,THREAD_PRIORITY_NORMAL,0x4000);
					}

				m_sPictureSem.Unlock();

				break;

	default:	m_pPictureBox->ShowWindow(SW_HIDE);
				break;
		}

}

//*****************************************************************************
//*
//*		BasePathOfList
//*
//*****************************************************************************
//	Holt den Basispfad aus einer Liste
int	CAzArchiverView::BasePathOfList(CString &sPath,LPCTSTR pList)
{
char		cLine[512];
TCHAR		cName[512];
FILE	   *pFile;
CString		sBase;
int			iNum;


		pFile = _tfopen(pList,_T("rb"));
	if(!pFile)
		{
		sPath = _T("");
		return 0;
		}


	cLine[511]	= 0;
	iNum		= 0;


	while(fgets(cLine,511,pFile))				// Pfade aus einer Dateiliste holen
		{
		strcut(cLine);
		if(!cLine[0])continue;
		strfromutf8(cName,cLine,ENTRIES(cName));
		PathConvert(cName);

		if(iNum==0)
			{
			GetFilePath(sPath,cName);
			iNum=1;
			continue;
			}

		GetFilePath(sBase,cName);


		for(;;)
			{
			if(!stricmp(sBase,sPath))break;

			if(sBase.GetLength()==0 && sPath.GetLength()==0)
				{
				break;
				}

			if(sBase.GetLength()>sPath.GetLength())
				{
				DelBackSlash(sBase);
				SubFileName (sBase);
				}
			else if(sBase.GetLength()<sPath.GetLength())
				{
				DelBackSlash(sPath);
				SubFileName (sPath);
				}
			else if(sBase.GetLength()<sPath.GetLength())
				{
				DelBackSlash(sBase);
				DelBackSlash(sPath);
				SubFileName (sBase);
				SubFileName (sPath);
				}
			}
		}

	fclose(pFile);


return iNum;
}

//*****************************************************************************
//*
//*		SelectFirstItem
//*
//*****************************************************************************
//	Das erste Element im Fenster auswhlen
void CAzArchiverView::SelectFirstItem()
{
	PostMessage(WM_COMMAND,ID_SELECTFIRST);
}

//*****************************************************************************
//*
//*		OnSelectFirst
//*
//*****************************************************************************
//	Das erste Element im Fenster auswhlen (Nachricht)
void CAzArchiverView::OnSelectFirst()
{
LRESULT			lResult=0;
NMTREEVIEW		sTree;




	memset(&sTree,0,sizeof(sTree));


	sTree.action		= TVIF_ONLYFOCUS;
	sTree.itemNew.hItem	= m_cTreeList.GetFirstVisibleItem();

	m_cTreeList.SelectItem(sTree.itemNew.hItem);

	OnSelChanged(&sTree.hdr,&lResult);

}
