//*****************************************************************************
//*
//*
//*		AzArchiverView.h
//*
//*
//*****************************************************************************
#ifndef		AFX_AZARCHIVERVIEW_H__D9B2B788_CA34_44A5_B5B5_1FCB3235D787__INCLUDED_
#define		AFX_AZARCHIVERVIEW_H__D9B2B788_CA34_44A5_B5B5_1FCB3235D787__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif

#include	<AfxOle.h>
#include	<AfxMacros.h>
#include	"SemaphoreEx.h"
#include	"ProgressDlg.h"
#include	"TreeListCtrlEx.h"

class		CAzArchiverDoc;
class		CAzArchiverView;
class		CPictureBoxFrame;

DECLARE_DROP_FUNC_MAIN(CAzArchiverView);

//*****************************************************************************
//*
//*		Klasse CAzArchiverView
//*
//*****************************************************************************
class CAzArchiverView : public CView
{
protected:

	CAzArchiverView();
	DECLARE_DYNCREATE(CAzArchiverView)

public:

	CAzArchiverDoc *GetDocument();
	int				PictureBoxMode();
	void 			SelectFirstItem();

	//{{AFX_VIRTUAL(CAzArchiverView)
public:

	virtual void OnDraw(CDC *pDC);								// berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

protected:
	//}}AFX_VIRTUAL


public:
	virtual ~CAzArchiverView();
	#ifdef		_DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
	#endif

protected:

	CArchiveFile *GetArchive     ();
	void		  SetSelText     ();
	void		  SaveExpands    ();
	int			  StartShell     (HTREEITEM     hItem);
	int			  StartEditor    (HTREEITEM     hItem);
	int			  StartHexEditor (HTREEITEM     hItem);
	void 		  InsertCmd		 (LPCTSTR	   pPath,int iCmd);
	void 		  ExtractCmd	 (LPCTSTR	   pPath,int iCmd);
	int			  ExtractSingle  (HTREEITEM     hItem,LPTSTR pTarget=NULL,int iMax=0);
	int			  ExtractPath    (CArchiveFile *pFile,LPCTSTR pPath,LPCTSTR pName,int *pItems,int iMax,__int64 &iSize);
	void		  UpdateItems    (CArchiveFile *pFile,CProgressDlg *pDlg=NULL);
	virtual void  OnUpdate       (CView        *pSender,LPARAM lHint,CObject *pHint);
	int			  BasePathOfList (CString	  &sPath,LPCTSTR pList);

	static	int	  CALLBACK ExecuteCb(HWND hWnd,LPVOID pParam,UINT uCommand);
	static	int   CALLBACK SortProc0(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort);
	static	int   CALLBACK SortProc1(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort);
	static	int   CALLBACK SortProc2(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort);
	static	int   CALLBACK SortProc3(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort);
	static	int   CALLBACK SortProc4(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort);
	static	int   CALLBACK SortProc5(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort);
	static	int   CALLBACK SortProc6(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort);
	static  int   _cdecl   SortPath	(CStringChain *pChain,int iPos1,int iPos2);

	//{{AFX_MSG(CAzArchiverView)
	afx_msg LRESULT OnStartCommand(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnPictureBox(WPARAM wParam,LPARAM lParam);
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnContextMenu(CWnd *pWnd,CPoint sPoint);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT_PTR nIdEvent);
	afx_msg void OnSetFocus(CWnd *pWnd);
	afx_msg void OnSelectFirst();
	afx_msg void OnTest();
	afx_msg void OnInsert();
	afx_msg void OnDelete();
	afx_msg void OnConfig();
	afx_msg void OnEditor();
	afx_msg void OnHexEditor();
	afx_msg void OnPictureBox();
	afx_msg void OnSelectAll();
	afx_msg void OnSaveCopy();
	afx_msg void OnDropDone();
	afx_msg void OnExtract();
	afx_msg	void OnModeDir();
	afx_msg	void OnModeTree();
	afx_msg	void OnModeList();
	afx_msg	void OnModeFullRow();
	afx_msg	void OnModeAlternate();
	afx_msg void OnModeDirUI(CCmdUI *pCmdUI);
	afx_msg void OnModeTreeUI(CCmdUI *pCmdUI);
	afx_msg void OnModeListUI(CCmdUI *pCmdUI);
	afx_msg void OnModeFullRowUI(CCmdUI *pCmdUI);
	afx_msg	void OnModeAlternateUI(CCmdUI *pCmdUI);
	afx_msg void OnPictureBoxUI(CCmdUI *pCmdUI);
	afx_msg void OnHexEditorUI(CCmdUI *pCmdUI);
	afx_msg void OnSaveCopyUI(CCmdUI *pCmdUI);
	afx_msg void OnFileSaveUI(CCmdUI *pCmdUI);
	afx_msg void OnExtractUI(CCmdUI *pCmdUI);
	afx_msg void OnDeleteUI(CCmdUI *pCmdUI);
	afx_msg void OnInsertUI(CCmdUI *pCmdUI);
	afx_msg void OnEditorUI(CCmdUI *pCmdUI);
	//}}AFX_MSG

	afx_msg void OnGetDispInfo(NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnColumnClick(NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnDoubleClick(NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnSelChanged (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnBeginDrag  (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnReturn     (NMHDR *pNmHdr,LRESULT *pResult);


	DECLARE_MESSAGE_MAP()

	TCHAR				m_cTempDir   [MAX_PATH];	// Ist der tempore Pfad samt Backslash und ProzessID
	TCHAR				m_cTempBase  [MAX_PATH];	// Ist der tempore Pfad samt Backslash
	int					m_iTempDirSize;				// Gre des Temorren Pfades
	BYTE				m_aFontSize[256];			// Buchstabennreiten fr den ProgressDlg
	int  volatile		m_iPictureSel;				// Ist das ausgewhlte Bild fr die PictureBox (-1=keines)
	BOOL volatile		m_pPictureOn;				// Ist der Thread fr die Bildvorschau ein
	BOOL volatile		m_pPictureStop;				// Den Thread fr die Bildvorschau stoppen
	CSemaphoreEx		m_sPictureSem;				// Signal fr den Bildvorschau Thread
	CPictureBoxFrame   *m_pPictureBox;				// Fenster fr die Bildvorschau
	CArchiveFile	   *m_pSortFile;				// Zeiger aus das Archive fr's Sortieren
	CTreeListCtrlEx		m_cTreeList;				// Fenster in das Archive angezeigt wird
	CStringChain		m_sTempFiles;				// Sind Temporre Dateien die gelscht werden mssen
	CStringChain		m_sOldExpand;				// Waren die Eintrge zuvor expandiert
	CString				m_sCurrentPath;				// Aktueller Pfad fr RootListe
	CString				m_sExtractPath;				// Pfad der beim Extrahieren gewhlt wurde
	CString				m_sSubInsert;				// Sub-Pfad beim Einfgen
	CMutex				m_sFileMutex;				// Mutex fr den Archivzugriff
	BOOL				m_bUserBreak;				// Gab es einen User-Abbruch beim Extrahieren
	int					m_iAlterante;				// Alternierente Farben in der Liste
	int					m_iShowMode;				// Anzeige Modus = 0=List 1=Tree 2=RootListe
	int					m_iSortMode;				// 0=Name 1=Typ 2=Datum 3=Gre 4=Kompr 5=Komp.Gr. 6=Pfad
	int					m_iFullRow;					// Die ganze Zeile auswhlen
	int					m_iColMark;					// Welche Spalte ist markiert
	int					m_iHasSub;					// Gibt es eine Sub-Pfad beim Einfgen
	static				m_iAchiveId;				// Fortlaufente ID fr die Archivdatei
	static int			m_iSortDir;					// Aufwrts=1 oder Abwrtssortieren=-1
	static int volatile	m_iRunning;					// Ist 1 sollange das Programm luft
	__int64				m_iProgressTemp;			// Temporrer Wert fr die Progress-Funktion
	__int64				m_iProgressStep;			// Gre der aktuellen Datei
	__int64				m_iProgressNow;				// Startwert fr die Progress-Funktion
	__int64				m_iProgressMax;				// Maximal Wert fr die Progress-Funktion
	int					m_iProgressLock;			// Ist die Progress-Funktion gesperrt
	HTREEITEM			m_hExecuteItem;				// Eintrag fr ExecuteCb
	HTREEITEM			m_hLastSelect;				// Vorher selektierter Eintrag
	HTREEITEM			m_hItemSelect;				// Gerade selektierter Eintrag

	int					m_iDragMode;				// 1=von Tree-Fenster 0=von auen
	int			 		m_iDropMode;				// Letzter Modus
	int			 		m_iDropDone;				// Letzter Modus
	int					m_iWriteAllow;				// Ist das verndern des Arives erlaubt
	int					m_iMarkValue;				// Warkierungswert fr Dateien

	CPoint		 		m_sDropPoint;				// Letzter Punkt
	CStringChain		m_sDropList;				// Liste mit den Dateinamen

	int					m_iSelTimer;				// Ist der Aktualisierungs-Timmer ein
	int					m_iSelLock;					// Ausgewhlten Dateien nicht ausgeben
	int					m_iSelCount;				// Anzahl der ausgewhlten Dateien
	__int64				m_iSelBytes;				// Anzahl der ausgewhlten Byte
	static TCHAR		m_cSelText[128];			// Text fr die ausgewhlten Dateien

	static	void		SizeString		(char *pText,__int64 iSize);
	static	void		PercentString	(char *pText,__int64 iFull,__int64 iComp);

	static	int  _cdecl	UpdateProc		(CProgressDlg *pDlg);
	static	int  _cdecl	InsertProc		(CProgressDlg *pDlg);
	static	int  _cdecl	SaveCopyProc	(CProgressDlg *pDlg);
	static	int  _cdecl	ExtractProc		(CProgressDlg *pDlg);
	static	void _cdecl	ExtractTimeProc	(CProgressDlg *pDlg);

	static  UINT _cdecl ShellProc		(void *pParam);
	static  UINT _cdecl EditorProc		(void *pParam);
	static  UINT _cdecl PictureProc		(void *pParam);
	static  UINT _cdecl HexEditorProc	(void *pParam);


	DECLARE_DROP_FUNC(CAzArchiverView);

};



#ifndef		_DEBUG												// Testversion in AzArchiverView.cpp
inline CAzArchiverDoc* CAzArchiverView::GetDocument(){ return (CAzArchiverDoc*)m_pDocument; }
#endif


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline CArchiveFile	*CAzArchiverView::GetArchive(){CAzArchiverDoc *pDoc=GetDocument();return pDoc->GetArchive();}
//{{AFX_INSERT_LOCATION}}

#endif
