//*****************************************************************************
//*
//*
//*		ConfigDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"AzArchiver.h"
#include	"ConfigDlg.h"
#include	"RegConfig.h"
#include	"PathDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CConfigDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnPathEditor)
	ON_BN_CLICKED(IDC_BUTTON2, OnPathHexEditor)
	ON_BN_CLICKED(IDC_BUTTON3, OnPathTemp)
	ON_BN_CLICKED(IDC_BUTTON4, OnPathExtract)
	ON_BN_CLICKED(IDC_BUTTON5, OnPathCompress)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO1, OnUpdate)
	ON_BN_CLICKED(IDC_RADIO2, OnUpdate)
	ON_BN_CLICKED(IDC_RADIO3, OnUpdate)
	ON_BN_CLICKED(IDC_RADIO4, OnUpdate)
	ON_BN_CLICKED(IDC_RADIO5, OnUpdate)
	ON_BN_CLICKED(IDC_RADIO6, OnUpdate)
END_MESSAGE_MAP()

typedef	struct
	{
	USHORT		uCheckId;
	USHORT		uTextId;
	LPCTSTR		pSuffix;
	LPCTSTR		pInfo;
	UINT		uBoolOff;
	UINT		uInitOff;
	INT			iIcon;
	}FileTypeItem;


static FileTypeItem		aTypes[] =
	{
	IDC_CHECK1	,IDC_TEXT1	,_T(".zip" ),_T("WinZip-Datei"),offsetof(CConfigDlg,m_bTypeZip),offsetof(CConfigDlg,m_bTypeInitZip),IDI_TYPEZIP  ,
	IDC_CHECK2	,IDC_TEXT2	,_T(".tar" ),_T("WinZip-Datei"),offsetof(CConfigDlg,m_bTypeTar),offsetof(CConfigDlg,m_bTypeInitTar),IDI_TYPEZIP  ,
	IDC_CHECK3	,IDC_TEXT3	,_T(".gz"  ),_T("WinZip-Datei"),offsetof(CConfigDlg,m_bTypeGz ),offsetof(CConfigDlg,m_bTypeInitGz ),IDI_TYPEZIP  ,
	IDC_CHECK4	,IDC_TEXT4	,_T(".tgz" ),_T("WinZip-Datei"),offsetof(CConfigDlg,m_bTypeTgz),offsetof(CConfigDlg,m_bTypeInitTgz),IDI_TYPEZIP  ,
	IDC_CHECK5	,IDC_TEXT5	,_T(".bz2" ),_T("WinRar-Datei"),offsetof(CConfigDlg,m_bTypeBz2),offsetof(CConfigDlg,m_bTypeInitBz2),IDI_TYPERAR  ,
	IDC_CHECK6	,IDC_TEXT6	,_T(".cab" ),_T("Archiv-Datei"),offsetof(CConfigDlg,m_bTypeCab),offsetof(CConfigDlg,m_bTypeInitCab),IDR_MAINFRAME,
	IDC_CHECK7	,IDC_TEXT7	,_T(".rar" ),_T("WinRar-Datei"),offsetof(CConfigDlg,m_bTypeRar),offsetof(CConfigDlg,m_bTypeInitRar),IDI_TYPERAR  ,
	IDC_CHECK8	,IDC_TEXT8	,_T(".rpm" ),_T("Archiv-Datei"),offsetof(CConfigDlg,m_bTypeRpm),offsetof(CConfigDlg,m_bTypeInitRpm),IDR_MAINFRAME,
	IDC_CHECK9	,IDC_TEXT9	,_T(".iso" ),_T("CD-Image"    ),offsetof(CConfigDlg,m_bTypeIso),offsetof(CConfigDlg,m_bTypeInitIso),IDI_TYPECD   ,
	IDC_CHECK10	,IDC_TEXT10	,_T(".7z"  ),_T("7Zip-Datei"  ),offsetof(CConfigDlg,m_bType7z ),offsetof(CConfigDlg,m_bTypeInit7z ),IDI_TYPE7ZIP ,
	IDC_CHECK20	,IDC_TEXT20	,_T(".jar" ),_T("Java-Archiv" ),offsetof(CConfigDlg,m_bTypeJar),offsetof(CConfigDlg,m_bTypeInitJar),IDI_TYPEZIP  ,
	IDC_CHECK21	,IDC_TEXT21	,_T(".uue" ),_T("Archiv-Datei"),offsetof(CConfigDlg,m_bTypeUue),offsetof(CConfigDlg,m_bTypeInitUue),IDR_MAINFRAME,
	IDC_CHECK22	,IDC_TEXT22	,_T(".cpio"),_T("Archiv-Datei"),offsetof(CConfigDlg,m_bTypePio),offsetof(CConfigDlg,m_bTypeInitPio),IDR_MAINFRAME,
	IDC_CHECK23	,IDC_TEXT23	,_T(".udf" ),_T("CD-Image"    ),offsetof(CConfigDlg,m_bTypeUdf),offsetof(CConfigDlg,m_bTypeInitUdf),IDI_TYPECD   ,
	IDC_CHECK24	,IDC_TEXT24	,_T(".xz"  ),_T("Archiv-Datei"),offsetof(CConfigDlg,m_bTypeXz ),offsetof(CConfigDlg,m_bTypeInitXz ),IDI_TYPEZIP  ,
	IDC_CHECK25	,IDC_TEXT25	,_T(".lzw" ),_T("Archiv-Datei"),offsetof(CConfigDlg,m_bTypeLwz),offsetof(CConfigDlg,m_bTypeInitLwz),IDI_TYPEZIP  ,
	IDC_CHECK26	,IDC_TEXT26	,_T(".lzma"),_T("Archiv-Datei"),offsetof(CConfigDlg,m_bTypeLzm),offsetof(CConfigDlg,m_bTypeInitLzm),IDI_TYPEZIP  ,
	IDC_CHECK27	,IDC_TEXT27	,_T(".zipx"),_T("WinZip-Datei"),offsetof(CConfigDlg,m_bTypeZix),offsetof(CConfigDlg,m_bTypeInitZix),IDI_TYPEZIP  ,
	};

int		CConfigDlg::m_iCreateType	  = -1;				// Aktuelle gewhler Typ fr's Dateierzeugen
LPCTSTR	CConfigDlg::m_aCreateSuffix[] =					// Aktuelle gewhler Typ fr's Dateierzeugen
	{
	_T("zip" ),
	_T("tar" ),
	_T("gz"  ),
	_T("bz2" ),
	_T("cab" ),
	_T("uue" ),
	_T("cpio"),
	_T("xz"  ),
	_T("lzw" ),
	_T("lzma"),
	};

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  Dialogfeld CConfigDlg
CConfigDlg::CConfigDlg(CWnd *pParent): CDialog(CConfigDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CConfigDlg)
	m_bTypeZip				=  TRUE;
	m_bTypeZix				=  TRUE;
	m_bTypeTar				=  TRUE;
	m_bTypeGz				=  TRUE;
	m_bTypeTgz				=  TRUE;
	m_bTypeBz2				=  TRUE;
	m_bTypeCab				=  TRUE;
	m_bTypeRar				=  TRUE;
	m_bTypeRpm				=  TRUE;
	m_bTypeIso				=  TRUE;
	m_bType7z				=  TRUE;
	m_bTypeJar				=  TRUE;
	m_bTypeUdf				=  FALSE;
	m_bTypeXz				=  TRUE;
	m_bTypeLwz				=  TRUE;
	m_bTypeLzm				=  TRUE;
	m_iCompressType 		=  0;
	m_sPathEditor			=  _T("");
	m_sPathHexEditor		=  _T("");
	m_sPathTemp 			=  _T("");
	m_sPathExtract			=  _T("");
	m_sPathCompress 		=  _T("");
	m_iExtractMode			=  1;
	m_iCompressMode 		=  1;
	m_iOwnWindow			=  0;
	m_iExplorerOn			=  TRUE;
	m_iExplorerSubMenu		=  TRUE;
	m_iExplorerOpenMenu		=  TRUE;
	m_iExplorerExtractTo	=  TRUE;
	m_iExplorerExtractHere	=  TRUE;
	m_iExplorerExtractBody	=  TRUE;
	m_iExplorerExtractList	=  TRUE;
	m_iExplorerCompressTo	=  TRUE;
	m_iExplorerCompressList =  TRUE;
	m_iExplorerCompressBody =  TRUE;
	//}}AFX_DATA_INIT
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CConfigDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigDlg)
	DDX_Check  (pDX,IDC_CHECK1 ,m_bTypeZip             );
	DDX_Check  (pDX,IDC_CHECK2 ,m_bTypeTar             );
	DDX_Check  (pDX,IDC_CHECK3 ,m_bTypeGz              );
	DDX_Check  (pDX,IDC_CHECK4 ,m_bTypeTgz             );
	DDX_Check  (pDX,IDC_CHECK5 ,m_bTypeBz2             );
	DDX_Check  (pDX,IDC_CHECK6 ,m_bTypeCab             );
	DDX_Check  (pDX,IDC_CHECK7 ,m_bTypeRar             );
	DDX_Check  (pDX,IDC_CHECK8 ,m_bTypeRpm             );
	DDX_Check  (pDX,IDC_CHECK9 ,m_bTypeIso             );
	DDX_Check  (pDX,IDC_CHECK10,m_bType7z              );
	DDX_Check  (pDX,IDC_CHECK20,m_bTypeJar			   );
	DDX_Check  (pDX,IDC_CHECK21,m_bTypeUue			   );
	DDX_Check  (pDX,IDC_CHECK22,m_bTypePio			   );
	DDX_Check  (pDX,IDC_CHECK23,m_bTypeUdf			   );
	DDX_Check  (pDX,IDC_CHECK24,m_bTypeXz			   );
	DDX_Check  (pDX,IDC_CHECK25,m_bTypeLwz			   );
	DDX_Check  (pDX,IDC_CHECK26,m_bTypeLzm			   );
	DDX_Check  (pDX,IDC_CHECK27,m_bTypeZix             );
	DDX_Check  (pDX,IDC_CHECK11,m_iExplorerOn          );
	DDX_Check  (pDX,IDC_CHECK12,m_iExplorerSubMenu     );
	DDX_Check  (pDX,IDC_CHECK13,m_iExplorerExtractTo   );
	DDX_Check  (pDX,IDC_CHECK14,m_iExplorerExtractHere );
	DDX_Check  (pDX,IDC_CHECK15,m_iExplorerExtractBody );
	DDX_Check  (pDX,IDC_CHECK16,m_iExplorerExtractList );
	DDX_Check  (pDX,IDC_CHECK17,m_iExplorerCompressTo  );
	DDX_Check  (pDX,IDC_CHECK19,m_iExplorerCompressList);
	DDX_Check  (pDX,IDC_CHECK18,m_iExplorerCompressBody);
	DDX_Check  (pDX,IDC_CHECK30,m_iExplorerOpenMenu	   );
	DDX_Text   (pDX,IDC_EDIT1  ,m_sPathEditor          );
	DDX_Text   (pDX,IDC_EDIT2  ,m_sPathHexEditor       );
	DDX_Text   (pDX,IDC_EDIT3  ,m_sPathTemp            );
	DDX_Text   (pDX,IDC_EDIT4  ,m_sPathExtract         );
	DDX_Text   (pDX,IDC_EDIT5  ,m_sPathCompress        );
	DDX_Radio  (pDX,IDC_RADIO1 ,m_iExtractMode         );
	DDX_Radio  (pDX,IDC_RADIO4 ,m_iCompressMode        );
	DDX_Radio  (pDX,IDC_RADIO7 ,m_iOwnWindow           );
	DDX_CBIndex(pDX,IDC_COMBO1 ,m_iCompressType        );
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten CConfigDlg
BOOL CConfigDlg::OnInitDialog()
{
unsigned	uPos;
CRegKeys	sKey;
CRegKeys	sType;
CString		sText;
CString		sTemp;
LPBOOL		pBool;
LPBOOL		pInit;



	SetButtonBitmap(this,IDC_BUTTON1,IDB_OPEN);
	SetButtonBitmap(this,IDC_BUTTON2,IDB_OPEN);
	SetButtonBitmap(this,IDC_BUTTON3,IDB_OPEN);
	SetButtonBitmap(this,IDC_BUTTON4,IDB_OPEN);
	SetButtonBitmap(this,IDC_BUTTON5,IDB_OPEN);


	sKey.Open();
	sKey.Up(_T("Config"));
	sKey.Get(m_iExplorerOn          ,_T("ExplorerOn"          ));
	sKey.Get(m_iExplorerSubMenu     ,_T("ExplorerSubMenu"     ));
	sKey.Get(m_iExplorerOpenMenu    ,_T("ExplorerOpenMenu"    ));
	sKey.Get(m_iExplorerExtractTo   ,_T("ExplorerExtractTo"   ));
	sKey.Get(m_iExplorerExtractHere ,_T("ExplorerExtractHere" ));
	sKey.Get(m_iExplorerExtractBody ,_T("ExplorerExtractBody" ));
	sKey.Get(m_iExplorerExtractList ,_T("ExplorerExtractList" ));
	sKey.Get(m_iExplorerCompressTo  ,_T("ExplorerCompressTo"  ));
	sKey.Get(m_iExplorerCompressList,_T("ExplorerCompressList"));
	sKey.Get(m_iExplorerCompressBody,_T("ExplorerCompressBody"));
	sKey.Get(m_sPathEditor          ,_T("PathEditor"          ));
	sKey.Get(m_sPathHexEditor       ,_T("PathHexEditor"       ));
	sKey.Get(m_sPathTemp            ,_T("PathTemp"            ));
	sKey.Get(m_sPathExtract         ,_T("PathExtract"         ));
	sKey.Get(m_sPathCompress        ,_T("PathCompress"        ));
	sKey.Get(m_iExtractMode         ,_T("ExtractMode"         ));
	sKey.Get(m_iOwnWindow           ,_T("OwnWindow"           ));
	sKey.Get(m_iCompressMode        ,_T("CompressMode"        ));
	sKey.Get(m_iCompressType        ,_T("CompressType"        ));


	m_iExplorerOnInit = m_iExplorerOn;

	for(uPos=0;uPos<sizeof(aTypes)/sizeof(aTypes[0]);uPos++)
		{
		pBool = (LPBOOL)(((char*)this)+aTypes[uPos].uBoolOff);
		pInit = (LPBOOL)(((char*)this)+aTypes[uPos].uInitOff);


		if(!sType.Open(HKEY_CLASSES_ROOT,aTypes[uPos].pSuffix,CRK_READ))
			{
			*pBool = 0;
			*pInit = 0;
			SetDlgItemText(aTypes[uPos].uTextId,_T("---"));
			continue;
			}

		sText  =  _T("");
		sType.Get(sText,NULL);

		*pBool = (_tcsnicmp(sText,_T("AzArchiver"),10))? 0:1;
		*pInit =  *pBool;

		if(sText!=_T("") && *pBool==FALSE)
			{
			sTemp.Format(_T("Old%s"),aTypes[uPos].pSuffix);
			sKey.Set(sText,sTemp);
			}

		if(sText==_T(""))sText=_T("---");
		if(*pBool!=FALSE)sText=_T("AzArchiver");
		SetDlgItemText(aTypes[uPos].uTextId,sText);
		}


	CDialog::OnInitDialog();

	OnUpdate();
	ForceWindowToTop(this);

	return TRUE;

}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CConfigDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_BUTTON1);
	DelButtonBitmap(this,IDC_BUTTON2);
	DelButtonBitmap(this,IDC_BUTTON3);
	DelButtonBitmap(this,IDC_BUTTON4);
	DelButtonBitmap(this,IDC_BUTTON5);

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CConfigDlg::OnOK()
{
CRegKeys	sKey;
CRegKeys	sType;
CString		sTemp;
CString		sPath;
CString		sName;
FARPROC		pProc;
LPBOOL		pBool;
LPBOOL		pInit;
HMODULE		hDll;
unsigned	uPos;
unsigned	uTyp;
BOOL		bRet;



	UpdateData();

	if(m_sPathTemp!=_T(""))AddBackSlash(m_sPathTemp);


	uTyp =  IsWin64Bit();



	sKey.Open();
	sKey.Up(_T("Config"));


	for(uPos=0;uPos<sizeof(aTypes)/sizeof(aTypes[0]);uPos++)// Dateitypen einrichten
		{
		pBool = (LPBOOL)(((char*)this)+aTypes[uPos].uBoolOff);
		pInit = (LPBOOL)(((char*)this)+aTypes[uPos].uInitOff);

		if(*pBool==*pInit)continue;

		if(!*pBool)
			{
			sTemp.Format(_T("Old%s"),aTypes[uPos].pSuffix);
			sKey.Get(sTemp,sTemp);
			if(sTemp=="")continue;

			sType.Open(HKEY_CLASSES_ROOT,aTypes[uPos].pSuffix,CRK_WRITE);
			sType.Set(sTemp,NULL);

			ConfigFileRefresh(aTypes[uPos].pSuffix);

			continue;
			}


		GetExeName(sPath);
		sName  = _T("AzArchiver");
		sName += aTypes[uPos].pSuffix;

		ConfigFileIcon	 (aTypes[uPos].pSuffix,sPath,-aTypes[uPos].iIcon,aTypes[uPos].pInfo,sName);
		ConfigFileCommand(aTypes[uPos].pSuffix,sPath,"open");
		}


	sKey.Set(m_iExplorerOn          ,_T("ExplorerOn"          ));
	sKey.Set(m_iExplorerSubMenu     ,_T("ExplorerSubMenu"     ));
	sKey.Set(m_iExplorerOpenMenu    ,_T("ExplorerOpenMenu"    ));
	sKey.Set(m_iExplorerExtractTo   ,_T("ExplorerExtractTo"   ));
	sKey.Set(m_iExplorerExtractHere ,_T("ExplorerExtractHere" ));
	sKey.Set(m_iExplorerExtractBody ,_T("ExplorerExtractBody" ));
	sKey.Set(m_iExplorerExtractList ,_T("ExplorerExtractList" ));
	sKey.Set(m_iExplorerCompressTo  ,_T("ExplorerCompressTo"  ));
	sKey.Set(m_iExplorerCompressList,_T("ExplorerCompressList"));
	sKey.Set(m_iExplorerCompressBody,_T("ExplorerCompressBody"));
	sKey.Set(m_sPathEditor          ,_T("PathEditor"          ));
	sKey.Set(m_sPathHexEditor       ,_T("PathHexEditor"       ));
	sKey.Set(m_sPathTemp            ,_T("PathTemp"            ));
	sKey.Set(m_sPathExtract         ,_T("PathExtract"         ));
	sKey.Set(m_sPathCompress        ,_T("PathCompress"        ));
	sKey.Set(m_iExtractMode         ,_T("ExtractMode"         ));
	sKey.Set(m_iOwnWindow           ,_T("OwnWindow"           ));
	sKey.Set(m_iCompressMode        ,_T("CompressMode"        ));
	sKey.Set(m_iCompressType        ,_T("CompressType"        ));

	m_iCreateType = m_iCompressType;



//*****************************************************************************


	sKey.Open(HKEY_CLASSES_ROOT,_T("CLSID\\{782565E4-41BC-4D85-80DF-885C2F5897DA}\\InprocServer32"),CRK_READ);
	sKey.Get(sName);

	GetExePath(sPath);

	if(uTyp)sPath+=_T("AzArchiver64.dll");
	else	sPath+=_T("AzArchiver32.dll");

	if(CmpFileName(sPath,sName))
		{
		m_iExplorerOnInit = -1;
		}


	if(m_iExplorerOnInit!=m_iExplorerOn)					// Shell-Extension einrichten
		{
		if(uTyp==1)											// 64-Bit-OS und 32-Bit-Programm
			{
			CStartProg	sStart;
			char		cPath[MAX_PATH];



			GetSystemDirectory(cPath,sizeof(cPath));
			strlcat(cPath,"\\regsvr32.exe",sizeof(cPath));

			WinWowRedirect(1);

			if(ExistFile(sPath)!=1)
				{
				MessageBox(_T("AzArchiver64.dll konnte nicht geladen werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
				}
			else if(ExistFile(cPath)!=1)
				{
				MessageBox(_T("regsvr32.exe konnte nicht geladen werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
				}
			else{
				sStart.SetParam("/i");
				sStart.SetParam("/s");
				sStart.SetParam(sPath);
				sStart.SetShow(CSP_HIDE);
				sStart.SetWaitTime(3000);
				
					bRet = sStart.Start(cPath,CSP_WAIT|CSP_SETSHOW);
				if(!bRet || sStart.GetExitCode())
					{
					MessageBox(_T("Die Shell-Erweiterung konnte nicht eingerichtet werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
					}
				}

			WinWowRedirect(0);
			}
		else{
			hDll = LoadLibrary(sPath);

			if(!hDll && !uTyp)
				{
				MessageBox(_T("AzArchiver32.dll konnte nicht geladen werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
				}
			else if(!hDll)
				{
				MessageBox(_T("AzArchiver64.dll konnte nicht geladen werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
				}
			else{
					pProc = GetProcAddress(hDll,(m_iExplorerOn)? "DllRegisterServer":"DllUnregisterServer");
				if(!pProc || pProc()!=S_OK)
					{
					MessageBox(_T("Die Shell-Erweiterung konnte nicht eingerichtet werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
					}
				}
			}
		}


	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CConfigDlg::OnCancel()
{

	CDialog::OnCancel();
}


//*****************************************************************************
//*
//*		Uninstall
//*
//*****************************************************************************
void CConfigDlg::Uninstall()
{
CString		sTemp;
CString		sArch;
CRegKeys	sType;
CRegKeys	sKey;
unsigned	uPos;




	sKey.Open();
	sKey.Up(_T("Config"));


	for(uPos=0;uPos<sizeof(aTypes)/sizeof(aTypes[0]);uPos++)// Dateitypen einrichten
		{
		sType.Open(HKEY_CLASSES_ROOT,aTypes[uPos].pSuffix,CRK_WRITE);
		sType.Get (sArch,NULL);

		if(_tcsnicmp(sArch,_T("AzArchiver"),10))
			{
			continue;
			}

		sTemp.Format(_T("Old%s"),aTypes[uPos].pSuffix);
		sKey .Get(sTemp,sTemp);


		if(sTemp!="")
			{
			sType.Set(sTemp,NULL);
			}
		else{
			sType.Set("",NULL);
			}

		ConfigFileRefresh(aTypes[uPos].pSuffix);
		}



	sKey.Open(HKEY_CLASSES_ROOT,_T("CLSID"),CRK_WRITE);
	sKey.DelKey(_T("{782565E4-41BC-4D85-80DF-885C2F5897DA}"));

	sKey.Open(HKEY_CLASSES_ROOT,_T(""),CRK_WRITE);
	sKey.DelKey(_T("AzArchiver.ShellExtension"));


	for(uPos=0;uPos<sizeof(aTypes)/sizeof(aTypes[0]);uPos++)// Dateitypen lschen
		{
		sTemp.Format(_T("AzArchiver%s"),aTypes[uPos].pSuffix);
		sKey .DelKey(sTemp);
		}

}

//*****************************************************************************
//*
//*		OnPathEditor
//*
//*****************************************************************************
void CConfigDlg::OnPathEditor()
{
CString	sPath;



	UpdateData();

	sPath=m_sPathEditor;
	if(sPath ==_T(""))sPath=_T("*.exe");
	CFileDialog	sFile(FALSE,_T("*.exe"),sPath,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,_T("Programm-Dateien ( *.exe )|*.exe|Alle Dateien|*.*|"));

	   sFile.m_ofn.lpstrTitle=_T("Datei auswhlen");
	if(sFile.DoModal()!=IDOK)return;

	m_sPathEditor=sFile.GetPathName();						// Pfad speichern

	UpdateData(FALSE);


}

//*****************************************************************************
//*
//*		OnPathHexEditor
//*
//*****************************************************************************
void CConfigDlg::OnPathHexEditor()
{
CString	sPath;



	UpdateData();

	sPath=m_sPathHexEditor;
	if(sPath=="")sPath=_T("*.exe");
	CFileDialog	sFile(FALSE,_T("*.exe"),sPath,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,_T("Programm-Dateien ( *.exe )|*.exe|Alle Dateien|*.*|"));

	   sFile.m_ofn.lpstrTitle=_T("Datei auswhlen");
	if(sFile.DoModal()!=IDOK)return;

	m_sPathHexEditor=sFile.GetPathName();					// Pfad speichern

	UpdateData(FALSE);


}

//*****************************************************************************
//*
//*		OnPathTemp
//*
//*****************************************************************************
void CConfigDlg::OnPathTemp()
{
CPathDlg	sDlg(this,_T("Config\\TempList"));


	UpdateData();

	   sDlg.SetPath(m_sPathTemp);
	if(sDlg.DoModal()!=IDOK)return;

	m_sPathTemp = sDlg.GetPath(1);

	UpdateData(FALSE);


}

//*****************************************************************************
//*
//*		OnPathExtract
//*
//*****************************************************************************
void CConfigDlg::OnPathExtract()
{
CPathDlg	sDlg(this,_T("Config\\ExtractList"));


	UpdateData();

	   sDlg.SetPath(m_sPathExtract);
	if(sDlg.DoModal()!=IDOK)return;

	m_sPathExtract = sDlg.GetPath(1);
	m_iExtractMode = 2;

	UpdateData(FALSE);


}

//*****************************************************************************
//*
//*		OnPathCompress
//*
//*****************************************************************************
void CConfigDlg::OnPathCompress()
{
CPathDlg	sDlg(this,_T("Config\\CompressList"));


	UpdateData();

	   sDlg.SetPath(m_sPathCompress);
	if(sDlg.DoModal()!=IDOK)return;

	m_sPathCompress = sDlg.GetPath(1);
	m_iCompressMode	= 2;

	UpdateData(FALSE);


}

//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
void CConfigDlg::OnUpdate()
{

	UpdateData();

	GetDlgItem(IDC_EDIT4  )->EnableWindow(m_iExtractMode ==2);
	GetDlgItem(IDC_BUTTON4)->EnableWindow(m_iExtractMode ==2);
	GetDlgItem(IDC_EDIT5  )->EnableWindow(m_iCompressMode==2);
	GetDlgItem(IDC_BUTTON5)->EnableWindow(m_iCompressMode==2);


}

//*****************************************************************************
//*
//*		GetCreateType
//*
//*****************************************************************************
LPCTSTR	CConfigDlg::GetCreateType()
{
CRegKeys	sKey;


	if(m_iCreateType<0)
		{
		sKey.Open();
		sKey.Up(_T("Config"));
		sKey.Get(m_iCreateType,_T("CompressType"));
		}


	if(m_iCreateType>=sizeof(m_aCreateSuffix)/sizeof(m_aCreateSuffix[0]))
		{
		m_iCreateType = 0;
		}


return m_aCreateSuffix[m_iCreateType];
}
