//*****************************************************************************
//*
//*
//*		InsertExDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"AzArchiver.h"
#include	"AzArchiverData.h"
#include	"InsertNewDlg.h"
#include	"ConfigDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CInsertNewDlg, CDialog)
	//{{AFX_MSG_MAP(CInsertNewDlg)
	ON_BN_CLICKED(IDC_BUTTON1,OnPath)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  Dialogfeld CInsertNewDlg
CInsertNewDlg::CInsertNewDlg(CWnd *pParent): CDialog(CInsertNewDlg::IDD,pParent)
{

	//{{AFX_DATA_INIT(CInsertNewDlg)
	m_bCreateNew	= FALSE;
	m_sArchivPath	= _T("");
	m_sSubPath		= _T("");
	m_sPlusFilter	= _T("");
	m_sMinusFilter	= _T("");
	//}}AFX_DATA_INIT

	m_iNoLast		= 0;

}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CInsertNewDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInsertNewDlg)
	DDX_Check(pDX,IDC_CHECK1,m_bCreateNew  );
	DDX_Text (pDX,IDC_COMBO1,m_sArchivPath );
	DDX_Text (pDX,IDC_EDIT1 ,m_sPlusFilter );
	DDX_Text (pDX,IDC_EDIT2 ,m_sMinusFilter);
	DDX_Text (pDX,IDC_EDIT3 ,m_sSubPath    );
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten CInsertNewDlg
BOOL CInsertNewDlg::OnInitDialog()
{
CRegKeys	sKey;


	SetButtonBitmap(this,IDC_BUTTON1,IDB_OPEN);

	ComboBoxLoad(this,IDC_COMBO1,_T("ArchivName"),_T("#MyProg\\InsertDlg"));

	sKey.Open();
	sKey.Up(_T("InsertDlg"));

	if(!(m_iNoLast&0x01))sKey.Get(m_sLastPath	,_T("LastPath"   ));		
	if(!(m_iNoLast&0x02))sKey.Get(m_sSubPath	,_T("SubPath"    ));
	if(!(m_iNoLast&0x04))sKey.Get(m_sPlusFilter ,_T("PlusFilter" ));
	if(!(m_iNoLast&0x08))sKey.Get(m_sMinusFilter,_T("MinusFilter"));
	if(!(m_iNoLast&0x10))sKey.Get(m_bCreateNew	,_T("CreateNew"  ));

	CDialog::OnInitDialog();



return TRUE;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CInsertNewDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_BUTTON1);

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CInsertNewDlg::OnOK()
{
CRegKeys	sKey;


	UpdateData();

	if(m_sArchivPath=="")
		{
		MessageBox(_T("Bitte einen Archivpfad angeben !"),_T("Warnung"),MB_OK|MB_ICONINFORMATION);
		return;
		}


	ComboBoxSave(this,IDC_COMBO1,_T("ArchivName"),_T("#MyProg\\InsertDlg"));

	sKey.Open();
	sKey.Up(_T("InsertDlg"));

	if(!(m_iNoLast&0x01))sKey.Set(m_sLastPath	,_T("LastPath"   ));		
	if(!(m_iNoLast&0x02))sKey.Set(m_sSubPath	,_T("SubPath"    ));
	if(!(m_iNoLast&0x04))sKey.Set(m_sPlusFilter ,_T("PlusFilter" ));
	if(!(m_iNoLast&0x08))sKey.Set(m_sMinusFilter,_T("MinusFilter"));
	if(!(m_iNoLast&0x10))sKey.Set(m_bCreateNew	,_T("CreateNew"  ));

	CInsertDlg::m_sSubPath		= m_sSubPath;
	CInsertDlg::m_sPlusFilter	= m_sPlusFilter;
	CInsertDlg::m_sMinusFilter	= m_sMinusFilter;


	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CInsertNewDlg::OnCancel()
{

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnPath
//*
//*****************************************************************************
void CInsertNewDlg::OnPath()
{
CString		sPath;
CString		sText;
LPCTSTR		pType;
LPCTSTR		pPath;



	UpdateData();

	pType = CConfigDlg::GetCreateType();	

	DelBackSlash(m_sLastPath);
	
	sPath  = m_sLastPath;
	sPath += _T("\\*.");
	sPath += pType;

	if(ExistFile(m_sLastPath)<2)pPath=0;

	sText.Format(_T("Archiv (%s)|*.%s|Alle Archive|") FILTER_ALL _T("|Alle Dateien|*.*|"),pType,pType);

	CFileDialog	sFile(FALSE,pType,pPath,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,sText);

	if(sFile.DoModal()!=IDOK)return;	

	m_sArchivPath	= sFile.GetPathName();
	GetFilePath(m_sLastPath,m_sArchivPath);
	


	UpdateData(FALSE);

}