//*****************************************************************************
//*
//*
//*		MainFrm.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"AzArchiver.h"
#include	"AzArchiverDoc.h"
#include	"AzArchiverView.h"
#include	"MainFrm.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


#define 	 ID_FORRGROUND		0x4986	
#define 	 ID_DEL_ARCIVE		0x0020

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_MESSAGE(WM_SETSTATUSTEXT,OnSetStatusText)
	ON_MESSAGE(WM_STARTCOMMAND ,OnStartCommand)
	ON_REGISTERED_MESSAGE(CMainFrame::m_uFindMsg,OnFindArchiver)
	ON_COMMAND(ID_STATUS_BAR_FLAT			,OnFlatBar)
	ON_COMMAND(ID_TOOLBAR_SMALL				,OnToolbarSmall)
	ON_COMMAND(ID_TOOLBAR_TEXT				,OnToolbarText)
	ON_COMMAND(ID_TOOLBAR_BIG				,OnToolbarBig)
	ON_UPDATE_COMMAND_UI(ID_TOOLBAR_SMALL	,OnToolbarSmallUI)
	ON_UPDATE_COMMAND_UI(ID_TOOLBAR_TEXT	,OnToolbarTextUI)
	ON_UPDATE_COMMAND_UI(ID_TOOLBAR_BIG		,OnToolbarBigUI)
	ON_UPDATE_COMMAND_UI(ID_STATUS_BAR_FLAT	,OnFlatBarUI)
	ON_WM_SYSCOMMAND()
	ON_WM_COPYDATA()
	ON_WM_DESTROY()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_STATUSBAR()
	ON_MENUICON()
END_MESSAGE_MAP()

UINT	CMainFrame::m_uFindMsg;

static UINT indicators[] =
	{
	ID_SEPARATOR,												
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
	};

PROCESS_RUNNING("AzArchiver");
STATUSBAR_PROC (CMainFrame);
MENUICON_PROC  (CMainFrame);
LAST_PLACE     (CMainFrame);


//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
// 	CMainFrame Konstruktion/Zerstrung
CMainFrame::CMainFrame()
{
CRegKeys	sKey;

	m_bFlatMode = TRUE;
	m_uToolMode = 2;

	sKey.Open();
	sKey.Up(_T("Settings"));
	sKey.Get(m_bFlatMode,_T("FlatMode"));
	sKey.Get(m_uToolMode,_T("ToolMode"));

	m_uFindMsg = RegisterWindowMessage(_T("AzArchiver"));

}


//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
CMainFrame::~CMainFrame()
{
CRegKeys	sKey;

	sKey.Open();
	sKey.Up(_T("Settings"));
	sKey.Set(m_bFlatMode,_T("FlatMode"));
	sKey.Set(m_uToolMode,_T("ToolMode"));

}	

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT pCreateStruct)
{
const WORD	aToolIds[4]={IDR_MAINFRAME,IDR_TOOLBAR_BIG,IDR_TOOLBAR_TEXT,IDR_TOOLBAR_TEXT};
CMenu      *pSysMenu;
DWORD		dwStyle;



	if(CFrameWnd::OnCreate(pCreateStruct) == -1)
		{
		return -1;
		}

	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;
	
	if(!m_wndToolBar.CreateEx(this,dwStyle|CBES_MENU_SMALL|CBES_MENU_MIDDLE|CBES_MENU_BIG|CBES_MENU_FLAT|CBES_MENU_HIDE,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      
		}
	
	if(!m_wndToolBar.LoadToolBar(aToolIds[m_uToolMode&3]))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      
		}

	if(!m_wndStatusBar.Create(this) ||	!m_wndStatusBar.SetIndicators(indicators,sizeof(indicators)/sizeof(UINT)))
		{
		TRACE0("Statusleiste konnte nicht erstellt werden\n");
		return -1;      
		}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle()|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar.SetMenuId (0,ID_TOOLBAR_SMALL);
	m_wndToolBar.SetMenuId (1,ID_TOOLBAR_BIG);
	m_wndToolBar.SetMenuId (2,ID_TOOLBAR_TEXT);
	m_wndToolBar.SetMenuId (3,ID_STATUS_BAR_FLAT);
	m_wndToolBar.SetMenuId (4,ID_VIEW_TOOLBAR);
	m_wndToolBar.SetMenuText(0,"Kleine Symbole");
	m_wndToolBar.SetMenuText(1,"Groe Symbole");
	m_wndToolBar.SetMenuText(2,"Symbole mit Text");

	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	MenuIconsInit(IDR_MAINFRAME);

	pSysMenu = GetSystemMenu(FALSE);
	pSysMenu->AppendMenu(MF_SEPARATOR);
	pSysMenu->AppendMenu(MF_STRING,ID_DEL_ARCIVE,"Lschen und Beenden");



return 0;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CMainFrame::OnDestroy()
{

	LAST_PLACE_GET();
	
	CFrameWnd::OnDestroy();

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT &sCreateStruct)
{

	if(!ProcessRunning())
		{
		LAST_PLACE_SET(&sCreateStruct);
		}

	if(!CFrameWnd::PreCreateWindow(sCreateStruct))
		{
		return FALSE;
		}


return TRUE;
}

//*****************************************************************************
//*
//*		OnSysCommand
//*
//*****************************************************************************
void CMainFrame::OnSysCommand(UINT nID,LPARAM lParam)
{
CView	*pView;	

	if((nID&0xFFF0)==ID_DEL_ARCIVE)
		{
			pView = GetActiveView();
		if(!pView)return;
		
		pView->PostMessage(WM_STARTCOMMAND,252,0);
		return;
		}

	CFrameWnd::OnSysCommand(nID,lParam);
}

#ifdef		_DEBUG						
//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif

//*****************************************************************************
//*
//*		OnFlatBarUI
//*
//*****************************************************************************
void CMainFrame::OnFlatBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFlatMode);
}


//*****************************************************************************
//*
//*		OnFlatBar
//*
//*****************************************************************************
void CMainFrame::OnFlatBar()
{
DWORD	dwStyle;


	dwStyle=(m_bFlatMode)? TBSTYLE_FLAT:0;
	m_wndToolBar.ModifyStyle(dwStyle,dwStyle^TBSTYLE_FLAT);
	m_bFlatMode = (dwStyle)? 0:1;

	if(m_wndToolBar.GetStyle()&WS_VISIBLE)
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		ShowControlBar(&m_wndToolBar,TRUE ,FALSE);
		}


}

//*****************************************************************************
//*
//*		OnStartCommand
//*
//*****************************************************************************
LRESULT CMainFrame::OnStartCommand(WPARAM wParam,LPARAM lParam)
{
CView	*pView;	


		pView = GetActiveView();
	if(!pView)return 0;
	
	pView->PostMessage(WM_STARTCOMMAND,wParam,lParam);


return 0;
}

//*****************************************************************************
//*
//*		OnSetStatusText
//*
//*****************************************************************************
LRESULT CMainFrame::OnSetStatusText(WPARAM wParam,LPARAM lParam)
{
LPCTSTR		pText=(LPCTSTR)lParam;
int			i;


	   i =  m_wndStatusBar.CommandToIndex(wParam);
	if(i>=0)m_wndStatusBar.GetStatusBarCtrl().SetText(pText,i,0);


return 0;
}


//*****************************************************************************
//*
//*		OnFindArchiver
//*
//*****************************************************************************
//	Ein AZ-Archiver wird gesucht
//	wParam		: Suchmodus
//					1 = Alle offenen Fenster	
//					2 = Alle offenen Fenster mit Picturebox
LRESULT CMainFrame::OnFindArchiver(WPARAM wParam,LPARAM lParam)
{
CView	*pView;	



	if(!IsWindowVisible())return 0;

		pView = GetActiveView();
	if(!pView)return 0;
	
	if(pView->SendMessage(WM_PICTUREBOX)==4)
		{
		return 0x11223355;
		}


return (wParam==2)? 0:0x11223344;
}

//*****************************************************************************
//*
//*		OnToolbarSmallUI
//*
//*****************************************************************************
void CMainFrame::OnToolbarSmallUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_uToolMode==0);
}


//*****************************************************************************
//*
//*		OnToolbarSmall
//*
//*****************************************************************************
void CMainFrame::OnToolbarSmall()
{

	m_uToolMode = 0;
	m_wndToolBar.LoadToolBar(IDR_MAINFRAME);
	RecalcLayout();

}

//*****************************************************************************
//*
//*		OnToolbarTextUI
//*
//*****************************************************************************
void CMainFrame::OnToolbarTextUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_uToolMode==2);
}


//*****************************************************************************
//*
//*		OnToolbarText
//*
//*****************************************************************************
void CMainFrame::OnToolbarText()
{

	m_uToolMode = 2;
	m_wndToolBar.LoadToolBar(IDR_TOOLBAR_TEXT);
	RecalcLayout();

}

//*****************************************************************************
//*
//*		OnToolbarBigUI
//*
//*****************************************************************************
void CMainFrame::OnToolbarBigUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_uToolMode==1);
}


//*****************************************************************************
//*
//*		OnToolbarBig
//*
//*****************************************************************************
void CMainFrame::OnToolbarBig()
{

	m_uToolMode = 1;
	m_wndToolBar.LoadToolBar(IDR_TOOLBAR_BIG);
	RecalcLayout();

}


//*****************************************************************************
//*
//*		OnCopyData
//*
//*****************************************************************************
BOOL CMainFrame::OnCopyData(CWnd *pWnd,COPYDATASTRUCT *pCopyData)
{														
TCHAR			 cPath[MAX_PATH];								
CAzArchiverView	*pView;
CWinApp			*pApp;	


	if(pCopyData->dwData!=0x11223344)
		{
		return 0;
		}
			 
	pApp = AfxGetApp();						
	strawcpy(cPath,(wchar_t*)pCopyData->lpData,pCopyData->cbData/sizeof(wchar_t));

	
	if(!pApp->OpenDocumentFile(cPath))
		{
		return 0;
		}

	
	ForceWindowToTop(m_hWnd);

	   pView=(CAzArchiverView*)GetActiveFrame();
	if(pView)pView->SelectFirstItem();


return 0x11223344;
}				

