//*****************************************************************************
//*
//*
//*		PictureBoxFrame.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"AzArchiver.h"
#include	"PictureBoxView.h"
#include	"PictureBoxFrame.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


#ifndef		 ID_ZOOM
#define 	 ID_ZOOM				0x4E01
#endif 	

IMPLEMENT_DYNCREATE(CPictureBoxFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CPictureBoxFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CPictureBoxFrame)
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_COMMAND(ID_ZOOM					,OnZoom)
	ON_COMMAND(ID_FIXWINDOW				,OnFixWindow)
	ON_UPDATE_COMMAND_UI(ID_ZOOM		,OnMenuZoom)
	ON_UPDATE_COMMAND_UI(ID_FIXWINDOW	,OnMenuFixWindow)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

HICON		CPictureBoxFrame::m_hIcon=0;					// Icon fr das Fenster

//*****************************************************************************
//*
//*		CPictureBoxFrame
//*
//*****************************************************************************
// 	CPictureBoxFrame Konstruktion/Zerstrung
CPictureBoxFrame::CPictureBoxFrame()
{
CRegKeys	sKey;


	
	m_pPictueView	= NULL;
	m_pThisPtr		= NULL;
	m_bFlatMode		= TRUE;
	m_bWindowFixed	= FALSE;
	m_bCreated		= FALSE;
	m_bZoomed		= FALSE;
	
	m_sCommonRect.SetRect(0,0,0,0);



	sKey.Open();
	sKey.Up (_T("Settings"));
	sKey.Get( m_bFlatMode   ,_T("FlatMode"    ));
	sKey.Get( m_bWindowFixed,_T("PictureFixed"));
	sKey.Get(&m_sCommonRect,sizeof(m_sCommonRect),_T("PictureBox"));

}

//*****************************************************************************
//*
//*		CPictureBoxFrame
//*
//*****************************************************************************
CPictureBoxFrame::~CPictureBoxFrame()
{
CRegKeys	sKey;

	
	sKey.Open();
	sKey.Up (_T("Settings"));
	sKey.Set( m_bWindowFixed,_T("PictureFixed"));
	sKey.Set(&m_sCommonRect,sizeof(m_sCommonRect),_T("PictureBox"));

	if(m_pThisPtr)
		{
		m_pThisPtr[0] = NULL;
		m_pThisPtr    = NULL;
		}

	m_pPictueView	= NULL;
	m_bCreated		= FALSE;

}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CPictureBoxFrame::OnCreate(LPCREATESTRUCT pCreateStruct)
{
CCreateContext	sContext;
DWORD			dwStyle;
CRect			sRect;



	if(CFrameWnd::OnCreate(pCreateStruct) == -1)
		{
		return -1;
		}

	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;
	
	if(!m_wndToolBar.CreateEx(this,dwStyle,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      
		}
	
	if(!m_wndToolBar.LoadToolBar(IDR_PICTUREBOX))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      
		}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle()|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);


	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);




    sContext.m_pNewViewClass 	= RUNTIME_CLASS(CPictureBoxView); 
    sContext.m_pCurrentFrame 	= this;
	sContext.m_pCurrentDoc   	= NULL;
	sContext.m_pLastView		= NULL;
	sContext.m_pNewDocTemplate	= NULL;

	m_pPictueView				= (CPictureBoxView*)CreateView(&sContext);
	m_bCreated					= TRUE;

	SetActiveView(m_pPictueView);
	
	if(m_bWindowFixed)
		{
		m_bWindowFixed=0;
		OnFixWindow();
		}

	
	
	if(!m_hIcon)
		{
		m_hIcon = LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_PICTURE));
		}

	SetIcon(m_hIcon,FALSE);
	SetIcon(m_hIcon,TRUE);


return 0;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CPictureBoxFrame::OnDestroy()
{
	
	if(!m_bZoomed && !IsZoomed() && !IsIconic())
		{
		GetWindowRect(&m_sCommonRect);
		}
	
	m_bCreated = 0;

	CFrameWnd::OnDestroy();

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CPictureBoxFrame::PreCreateWindow(CREATESTRUCT &sCreateStruct)
{
int				iOk;

	
	m_iScreenX	= GetSystemMetrics(SM_CXSCREEN);
	m_iScreenY	= GetSystemMetrics(SM_CYSCREEN);
	iOk			= 1;

	if(m_sCommonRect.Width ()<8)iOk=0;
	if(m_sCommonRect.Height()<8)iOk=0;
	if(m_sCommonRect.right   <8)iOk=0;
	if(m_sCommonRect.bottom  <8)iOk=0;
	if(m_sCommonRect.left    <0 && m_sCommonRect.right >=m_iScreenX)iOk=0;
	if(m_sCommonRect.top     <0 && m_sCommonRect.bottom>=m_iScreenY)iOk=0;
	if(m_sCommonRect.left    >=m_iScreenX-8)iOk=0;
	if(m_sCommonRect.top     >=m_iScreenY-8)iOk=0;

	if(iOk)
		{
		sCreateStruct.x		= m_sCommonRect.left;
		sCreateStruct.y		= m_sCommonRect.top;
		sCreateStruct.cx	= m_sCommonRect.Width();
		sCreateStruct.cy	= m_sCommonRect.Height();
		}

	if(!CFrameWnd::PreCreateWindow(sCreateStruct))
		{
		return FALSE;
		}


return TRUE;
}


#ifdef		_DEBUG						
//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CPictureBoxFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CPictureBoxFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CPictureBoxFrame::OnSize(UINT nType,int iSizeX,int iSizeY)
{

	if(!m_bZoomed)GetWindowRect(&m_sCommonRect);
	
	CFrameWnd::OnSize(nType,iSizeX,iSizeY);

}

//*****************************************************************************
//*
//*		OnZoom
//*
//*****************************************************************************
void CPictureBoxFrame::OnZoom()
{
CRect		sRect;




	if(m_bZoomed)											// Zoom rckgngig machen
		{
		MoveWindow(m_sCommonRect.left,m_sCommonRect.top,m_sCommonRect.Width(),m_sCommonRect.Height());
		m_bZoomed = FALSE;
//		RedrawWindow();
		return;
		}

	if(IsZoomed() || IsIconic())								
		{
		ShowWindow(SW_SHOWNORMAL);
		}


				GetClientRect (&sRect);
				ClientToScreen(&sRect);
				GetWindowRect (&m_sCommonRect);

	MoveWindow( m_sCommonRect.left-sRect.left,
				m_sCommonRect.top -sRect.top,
				m_iScreenX+m_sCommonRect.right -sRect.right -m_sCommonRect.left+sRect.left,
				m_iScreenY+m_sCommonRect.bottom-sRect.bottom-m_sCommonRect.top +sRect.top);

	
	CRect xRect;
	GetClientRect (&xRect);
	ClientToScreen(&xRect);


	m_bZoomed = TRUE;
//	RedrawWindow();

}

//*****************************************************************************
//*
//*		OnMenuZoom
//*
//*****************************************************************************
void CPictureBoxFrame::OnMenuZoom(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bZoomed);	
}

//*****************************************************************************
//*
//*		SetThisPtr
//*
//*****************************************************************************
void CPictureBoxFrame::SetThisPtr(CPictureBoxFrame **pPtr)
{

	m_pThisPtr = pPtr;

}

//*****************************************************************************
//*
//*		GetState
//*
//*****************************************************************************
//	Dastus der PictureBox abfragen
//	Ergibt den Status des Fensters	
//				0 = Nicht allokiert
//				1 = Fenster ist nicht erzeugt
//				2 = Fenster-Handle ist nicht gltig
//				3 = Fenster ist nicht sichtbar
//				4 = Fenster ist sichtbar
int CPictureBoxFrame::GetState()
{

	if(!this             )return 0;
	if(!m_bCreated       )return 1;
	if(!IsWindow (m_hWnd))return 2;
	if(!IsWindowVisible())return 3;
	if( IsIconic()       )return 3;

return 4;
}

//*****************************************************************************
//*
//*		SetPicture
//*
//*****************************************************************************
int	CPictureBoxFrame::SetPicture(LPCTSTR pPath,LPCTSTR pTitle,BOOL bCheckSufix)
{
return m_pPictueView->SetPicture(pPath,pTitle,bCheckSufix);
}

//*****************************************************************************
//*
//*		OnFixWindowUI
//*
//*****************************************************************************
void CPictureBoxFrame::OnMenuFixWindow(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bWindowFixed);
}

//*****************************************************************************
//*
//*		OnFixWindow
//*
//*****************************************************************************
void CPictureBoxFrame::OnFixWindow()
{
	m_bWindowFixed = !m_bWindowFixed;
	SetWindowPos((m_bWindowFixed)? &wndTopMost:&wndNoTopMost,0,0,0,0,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE);
}

//*****************************************************************************
//*
//*		ClearCache
//*
//*****************************************************************************
void CPictureBoxFrame::ClearCache()
{

	if(!m_pPictueView)return;

	m_pPictueView->ClearCache();

}