//*****************************************************************************
//*
//*
//*		PictureBoxView.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"AzArchiver.h"
#include	"PictureBoxView.h"
#include	"Image\BmpEncoder.h"
#include	"Image\BmpDecoder.h"
#include	"Image\GifDecoder.h"
#include	"Image\JpegDecoder.h"
#include	"Image\ImageLoader.h"
#include	"Image\TiffDecoder.h"
#include	"Image\TiffEncoder.h"
#include	"Image\EpsDecoder.h"
#include	"Image\EpsEncoder.h"



#define		 ID_REDRAW_TIMER 			0x4E00
#define		 ID_TITLE_TIMER 			0x4E01
#define		 ID_REDRAW					0x4E02
#define		 ID_SWITCH					0x4E03
#define		 ID_CHECK					0x4E04
#define		 FRAME						10


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define		 CPB_FILES	"bmp;jpeg;jpg;gif;paz;png;tiff;xpm;xwd;pnm"

IMPLEMENT_DYNCREATE(CPictureBoxView, CView)


BEGIN_MESSAGE_MAP(CPictureBoxView, CView)
	//{{AFX_MSG_MAP(CPictureBoxView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_DESTROY()
	ON_WM_KEYDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEWHEEL()
	ON_WM_RBUTTONUP()
	ON_WM_MBUTTONUP()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_MBUTTONDOWN()
	ON_WM_LBUTTONDOWN()

	ON_COMMAND(ID_EDIT_COPY,				OnCopy)
	ON_COMMAND(ID_CHECK,					OnCheck)
	ON_COMMAND(ID_REDRAW,					OnRedraw)
	ON_COMMAND(ID_SWITCH,					OnSwitch)

	ON_COMMAND(ID_SHOWCOMMON,				OnShowCommon)
	ON_COMMAND(ID_SHOWBIGGER,				OnShowBigger)
	ON_COMMAND(ID_SHOWSMALLER,				OnShowSmaller)
	ON_COMMAND(ID_SHOWFULLSIZE,				OnShowFullSize)
	ON_COMMAND(ID_SHOWFULLWIDTH,			OnShowFullWidth)
	ON_COMMAND(ID_SHOWFULLHEIGHT,			OnShowFullHeight)
	ON_COMMAND(ID_SELNAMEPATH,				OnSelNamePath)
	ON_COMMAND(ID_WHEELMODE,				OnWheelMode)

	ON_UPDATE_COMMAND_UI(ID_SELNAMEPATH,	OnMenuSelNamePath)
	ON_UPDATE_COMMAND_UI(ID_WHEELMODE,		OnMenuWheelMode)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY,		OnMenuImage)
	ON_UPDATE_COMMAND_UI(ID_SHOWFULLHEIGHT,	OnMenuSize)
	ON_UPDATE_COMMAND_UI(ID_SHOWFULLWIDTH,	OnMenuSize)
	ON_UPDATE_COMMAND_UI(ID_SHOWFULLSIZE,	OnMenuSize)
	ON_UPDATE_COMMAND_UI(ID_SHOWSMALLER,	OnMenuSmaller)
	ON_UPDATE_COMMAND_UI(ID_SHOWBIGGER,		OnMenuBigger)
	ON_UPDATE_COMMAND_UI(ID_SHOWCOMMON,		OnMenuSize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static CMutex		sImageMutex;
static CMutex		sDrawMutex;

static DWORD		dwLoadThread;
static _PNH			pOldHandler;
#ifndef _PNH_DEFINED
typedef int (__cdecl * _PNH)(size_t iSize);
#define _PNH_DEFINED
#endif

_PNH AFXAPI			AfxGetNewHandler();
_PNH AFXAPI			AfxSetNewHandler(_PNH pfnNewHandler);
int  AFX_CDECL		AfxNewHandler(size_t iSize);


//*****************************************************************************
//*
//*		PictureBoxHandler
//*
//*****************************************************************************
//	Handler wenn keine Speicher vorhanden ist
int AFX_CDECL PictureBoxHandler(size_t iSize)
{

	if(GetCurrentThreadId()==dwLoadThread || !pOldHandler)
		{
		return 0;
		}

return pOldHandler(iSize);
}



//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CPictureBoxView::CPictureBoxView()
{
CRegKeys	sKey;
int			iPos;


	m_pImagePtr		=  0;							// Zeiger auf angezeigtes Bild (0=keines)
	m_iLoadImg		= -1;							// Bild das geladen werden soll
	m_iSwitchImg	= -1;							// Bild zu dem geschalten werden muss wenn geladen
	m_iCurrendImg	= -1;							// Ist das Bild aus dem Cache das angezeigt werden soll
	m_iStretchImg	= -1;							// Gezoomtes Bild aus dem Cache (-1=keines)
	m_iLastError	= -1;							// Welcher Slot wurde zuletzt gesetzt
	m_iLastErrCnt	=  0;							// Welcher Slot wurde zuletzt wie oft geladen
	m_iShowFormat	=  0;							// Zoom Format (0=noral -1=volle Breite -2=volle Breite -3=voller Schirm)

	m_iScrollX		=  0;							// Scroll-Position
	m_iScrollY		=  0;							//		*
	m_iScreenX		=  0;							// Fenstergre
	m_iScreenY		=  0;							//		*

	m_bZoomed		=  FALSE;						// Ist das Fenster gezoomt
	m_bMouseWheel	=  FALSE;						// Modus fr das Mausrad
	m_bScrollOnX	=  FALSE;						// Ist der X-Scrollbalken sichtbar
	m_bScrollOnY	=  FALSE;						// Ist der Y-Scrollbalken sichtbar
	m_bStretchOn	=  TRUE;						// Ist das Autozoomen der Bilder ein
	m_pImagePtr		=  NULL;						// Zeiger auf angezeigtes Bild (0=keines)

	m_iImageSizeX	=  0;							// Bildgre in Pixel mit Zoom
	m_iImageSizeY	=  0;							//		*
	m_iImageStartX	=  0;							// Startposition des Bildes im Fenster
	m_iImageStartY	=  0;							//		*
	m_iImageStopX	=  0;							// Endposition des Bildes im Fenster
	m_iImageStopY	=  0;							//		*
	m_iImageEndX	=  0;							// Endposition des Bildes mit Rahmen
	m_iImageEndY	=  0;							//		*

	m_bTitleMode	=  FALSE;						// Dateinamen als Namen oder Pfad
	m_bTitlelOn		=  FALSE;						// Bildnamen eingeblentet
	m_pTitle		=  _T("");						// Zeiger auf den Bildnamen
	m_iTitleX		=  0;							// Position des Bildnamens
	m_iTitleY		=  0;							//		*
	m_iTitleTime	=  0;							// Updatezeit fr Bildnamen

	m_bMoveOn		=  0;							// Bild verschieben
	m_iMoveX		=  0;							// Scroll-Position
	m_iMoveY		=  0;							//		*

	m_bThreadOn		=  0;							// Ist ein Thread aktiv
	m_bThreadStop	=  0;							// Den Thread abbrechen


	for(iPos=0;iPos<CPB_CACHE_SIZE;iPos++)
		{
		m_aImgLock[iPos    ] = 0;
		m_aImgPath[iPos*256] = 0;
		m_aImgName[iPos*256] = 0;
		}

	GetCharWidths(m_aChars);

	m_sBgBrush.CreateSolidBrush(GetSysColor(COLOR_WINDOW));

	sKey.Open();
	sKey.Up (_T("Settings"));
	sKey.Get(m_bTitleMode ,_T("TitleMode" ));
	sKey.Get(m_bMouseWheel,_T("MouseWheel"));
	sKey.Get(m_iShowFormat,_T("ShowFormat"));



}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CPictureBoxView::~CPictureBoxView()
{
CRegKeys	sKey;


	sKey.Open();
	sKey.Up (_T("Settings"));
	sKey.Set(m_bTitleMode ,_T("TitleMode" ));
	sKey.Set(m_bMouseWheel,_T("MouseWheel"));
	sKey.Set(m_iShowFormat,_T("ShowFormat"));

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CPictureBoxView::PreCreateWindow(CREATESTRUCT &sCreate)
{

return CView::PreCreateWindow(sCreate);
}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CPictureBoxView::OnCreate(LPCREATESTRUCT pCreateStruct)
{

	if(CView::OnCreate(pCreateStruct) == -1)return -1;

	ShowScrollBar(SB_BOTH,TRUE);						// Scrollbars einschalten
	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)GetStockObject(NULL_BRUSH));

	AfxBeginThread((AFX_THREADPROC)ThreadProc,this,THREAD_PRIORITY_NORMAL, 0);



return 0;
}

//*****************************************************************************
//*
//*		OnMenuImage
//*
//*****************************************************************************
void CPictureBoxView::OnMenuImage(CCmdUI *pCmdUI)
{

	pCmdUI->Enable(m_pImagePtr && m_pImagePtr->IsOk());

}

//*****************************************************************************
//*
//*		OnMenuBigger
//*
//*****************************************************************************
void CPictureBoxView::OnMenuBigger(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_pImagePtr!=0 && m_iShowFormat<1000);
}

//*****************************************************************************
//*
//*		OnMenuSmaller
//*
//*****************************************************************************
void CPictureBoxView::OnMenuSmaller(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_pImagePtr!=0 && m_iShowFormat>10);
}

//*****************************************************************************
//*
//*		OnMenuSize
//*
//*****************************************************************************
void CPictureBoxView::OnMenuSize(CCmdUI *pCmdUI)
{

	if(!m_pImagePtr || !m_pImagePtr->IsOk())
		{
		pCmdUI->Enable(FALSE);
		return;
		}

	pCmdUI->Enable(TRUE);

	switch(pCmdUI->m_nID)
		{
	case ID_SHOWCOMMON:		pCmdUI->SetCheck(m_iShowFormat== 0);break;
	case ID_SHOWFULLWIDTH:	pCmdUI->SetCheck(m_iShowFormat==-1);break;
	case ID_SHOWFULLHEIGHT:	pCmdUI->SetCheck(m_iShowFormat==-2);break;
	case ID_SHOWFULLSIZE:	pCmdUI->SetCheck(m_iShowFormat==-3);break;
		}
}


//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
void CPictureBoxView::OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint)
{



}

//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
void CPictureBoxView::OnDraw(CDC *pDC)
{
TCHAR		cTemp[256];
LPCTSTR		pText;
CSize		sSize;
int			iPosX;
int			iPosY;
int			iSlot;
int			iLen;



	sDrawMutex.Lock();

	if(sImageMutex.Lock(0))								// Neues Bild bernehmen
		{
		iSlot = m_iSwitchImg; 

		if(m_iSwitchImg>=0 && m_aImgLock[m_iSwitchImg]==0)
			{
			m_pImagePtr		=  m_aImages+m_iSwitchImg;
			m_iCurrendImg	=  m_iSwitchImg;
			m_iSwitchImg	= -1;
			m_bTitlelOn		=  0;

			SetShowSize(m_iShowFormat,FALSE,FALSE);
			}

		sImageMutex.Unlock();
		}
	else if(m_iSwitchImg>=0)
		{
		iSlot = -1;
		SetTimer(ID_REDRAW_TIMER,200,NULL);
		}


	if(!m_pImagePtr || !m_pImagePtr->IsOk())			// Kein Bild anzeigen
		{
		SelectObject(pDC->m_hDC,m_sBgBrush);
		SelectObject(pDC->m_hDC,GetStockObject(NULL_PEN));
		pDC->Rectangle(0,0,m_iScreenX+1,m_iScreenY+1);

		if(m_pImagePtr && iSlot>=0 && (m_iLastError!=iSlot || m_iLastErrCnt<2))
			{
			if(m_iLastError!=iSlot)
					m_iLastErrCnt=1;
			else	m_iLastErrCnt++;

			FreePictures(8,iSlot);

			m_iLoadImg		= iSlot;
			m_iSwitchImg	= iSlot;
			m_iLastError	= iSlot;
			m_sThreadSignal.Unlock();					// Thread fr's laden freigeben
			}

		sDrawMutex.Unlock();
		return;
		}


	m_iImageStartX	= (m_iScreenX-m_iImageSizeX)/2;		// Koordinaten berechnen
	m_iImageStartY	= (m_iScreenY-m_iImageSizeY)/2;

	if(m_iImageStartX<FRAME)m_iImageStartX=FRAME;
	if(m_iImageStartY<FRAME)m_iImageStartY=FRAME;

	m_iImageStopX	= m_iImageStartX +m_iImageSizeX;
	m_iImageStopY	= m_iImageStartY +m_iImageSizeY;
	m_iImageEndX	= m_iImageStopX  +m_iImageStartX+1;
	m_iImageEndY	= m_iImageStopY  +m_iImageStartY+1;
	m_iLastError	= -1;
	m_iLastErrCnt	=  0;	

	SelectObject(pDC->m_hDC,m_sBgBrush);
	SelectObject(pDC->m_hDC,GetStockObject(NULL_PEN));

	pDC->SetWindowOrg(m_iScrollX,m_iScrollY);
														// Rahmen Zeichnen
	pDC->Rectangle(0              ,0             ,m_iImageEndX  +1,m_iImageStartY+1);
	pDC->Rectangle(0              ,m_iImageStopY ,m_iImageEndX  +1,m_iImageEndY  +1);
	pDC->Rectangle(0              ,m_iImageStartY,m_iImageStartX+1,m_iImageStopY +1);
	pDC->Rectangle(m_iImageStopX,m_iImageStartY  ,m_iImageEndX  +1,m_iImageStopY +1);


	if(m_iShowFormat)									// Ist das Bild gezoomt
		{
		if(m_bStretchOn)
			{
			if(m_iStretchImg!=m_iCurrendImg ||			// Ist das gezoomte Bild am aktuellen Stand
			   m_sStretchImg.Width ()!=(unsigned)m_iImageSizeX ||
			   m_sStretchImg.Height()!=(unsigned)m_iImageSizeY)
				{
				m_sStretchImg.Stretch(*m_pImagePtr,m_iImageSizeX,m_iImageSizeY,1);
				m_iStretchImg = m_iCurrendImg;
				}

			m_sStretchImg.SetDIB(pDC->m_hDC,m_iImageStartX,m_iImageStartY);
			}
		else{
			m_pImagePtr->StretchDIB(pDC->m_hDC,m_iImageStartX,m_iImageStartY,m_iImageSizeX,m_iImageSizeY);
			}
		}
	else{
		m_pImagePtr->SetDIB(pDC->m_hDC,m_iImageStartX,m_iImageStartY);
		}



	if(m_bTitlelOn)										// Einen Bildtext ausgeben
		{
		if(m_iCurrendImg>=0)
			{
				pText = m_aImgName+m_iCurrendImg*256;
			if(!pText[0])
				{
				pText = m_aImgPath+m_iCurrendImg*256;

				if(m_bTitleMode)
					{
					iLen  = CommpressFileName(pText,cTemp,sizeof(cTemp),350,m_aChars,1);
					pText = cTemp;
					}
				else{
					pText = GetFileName(pText,&iLen);
					}
				}
			}
		else{
			pText = _T("");
			}

		if(*pText)
			{
			SelectObject(pDC->m_hDC,GetStockObject(ANSI_VAR_FONT));

			iLen  =_tcslen(pText);
			sSize = pDC->GetTextExtent(pText,iLen);
			iPosX = m_iTitleX-(sSize.cx>>1)-5;
			iPosY = m_iTitleY-(sSize.cy>>1)-9;

			SelectObject(pDC->m_hDC,m_sBgBrush);
			SelectObject(pDC->m_hDC,GetStockObject(BLACK_PEN));
			SelectObject(pDC->m_hDC,GetSysColorBrush(COLOR_INFOBK));

			pDC->SetWindowOrg(0,0);
			pDC->SetBkColor(GetSysColor(COLOR_INFOBK));
			pDC->Rectangle (iPosX  ,iPosY  ,iPosX+sSize.cx+10,iPosY+sSize.cy+6);
			pDC->TextOut   (iPosX+5,iPosY+3,pText,iLen);

			m_sTitleRect.SetRect(iPosX,iPosY,iPosX+sSize.cx+10,iPosY+sSize.cy+6);
			}
		}


	if(m_iImageStartX<m_iScrollX && m_iImageStopX<m_iScrollX+m_iScreenX-FRAME-2)
		{
		PostMessage(WM_COMMAND,ID_CHECK);
		}
	else if(m_iImageStartY<m_iScrollY && m_iImageStopY<m_iScrollY+m_iScreenY-FRAME-2)
		{
		PostMessage(WM_COMMAND,ID_CHECK);
		}
	else if(m_iImageStartX>m_iScrollX+FRAME+2 && m_iImageStopX>m_iScrollX+m_iScreenX)
		{
		PostMessage(WM_COMMAND,ID_CHECK);
		}
	else if(m_iImageStartY>m_iScrollY+FRAME+2 && m_iImageStopY>m_iScrollY+m_iScreenY)
		{
		PostMessage(WM_COMMAND,ID_CHECK);
		}

	sDrawMutex.Unlock();



}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CPictureBoxView::OnSize(UINT nType,int iSizeX,int iSizeY)
{
SCROLLINFO	sInfo;



	m_iScreenX		= iSizeX;
	m_iScreenY		= iSizeY;
	m_bScrollOnX	= FALSE;
	m_bScrollOnY	= FALSE;

	CheckScroll();


	sInfo.cbSize	= sizeof(SCROLLINFO);
	sInfo.fMask		= SIF_ALL;
	sInfo.nMin 		= 0;
	sInfo.nMax 		= m_iImageSizeX+FRAME*2;
	sInfo.nPage		= m_iScreenX;
	sInfo.nPos 		= m_iScrollX;
	sInfo.nTrackPos	= 0;

	if(sInfo.nMax>(int)sInfo.nPage)
		{
		m_bScrollOnX = TRUE;
		}

	SetScrollInfo(SB_HORZ,&sInfo,TRUE);
	m_iScrollX = GetScrollPos(SB_HORZ);


	sInfo.cbSize	= sizeof(SCROLLINFO);
	sInfo.fMask		= SIF_ALL;
	sInfo.nMin 		= 0;
	sInfo.nMax 		= m_iImageSizeY+FRAME*2;
	sInfo.nPage		= m_iScreenY;
	sInfo.nPos 		= m_iScrollY;
	sInfo.nTrackPos	= 0;

	if(sInfo.nMax>(int)sInfo.nPage)
		{
		m_bScrollOnY  = 1;
		}


	SetScrollInfo(SB_VERT,&sInfo,TRUE);
	m_iScrollY = GetScrollPos(SB_VERT);

	SetShowSize(-6,FALSE);


}

//*****************************************************************************
//*
//*		OnHScroll
//*
//*****************************************************************************
void CPictureBoxView::OnHScroll(UINT Code,UINT iPos,CScrollBar *ScrollBar)
{
int		iStart;


	iStart = m_iScrollX;

	switch(Code)
		{

	case SB_LINERIGHT:		m_iScrollX += 10;				break;
	case SB_LINELEFT:		m_iScrollX -= 10;				break;
	case SB_PAGERIGHT:		m_iScrollX += m_iScreenY-20;	break;
	case SB_PAGELEFT:		m_iScrollX -= m_iScreenY-20;	break;
	case SB_THUMBPOSITION:	m_iScrollX  = iPos;				break;
	case SB_THUMBTRACK:		m_iScrollX  = iPos;				break;
		}

	SetScrollPos(SB_HORZ,m_iScrollX,TRUE);
	m_iScrollX=GetScrollPos(SB_HORZ);

	if(m_iScrollX!=iStart)RedrawWindow();

}

//*****************************************************************************
//*
//*		OnVScroll
//*
//*****************************************************************************
void CPictureBoxView::OnVScroll(UINT Code,UINT uPos,CScrollBar *pScrollBar)
{
int		iStart;


	iStart = m_iScrollY;

	switch(Code)
		{
	case SB_LINEDOWN:		m_iScrollY += 10;				break;
	case SB_LINEUP:			m_iScrollY -= 10;				break;
	case SB_PAGEDOWN:		m_iScrollY += m_iScreenY-1;		break;
	case SB_PAGEUP:			m_iScrollY -= m_iScreenY-1;		break;
	case SB_THUMBPOSITION:	m_iScrollY  = uPos;				break;
	case SB_THUMBTRACK:		m_iScrollY  = uPos;				break;
		}

	SetScrollPos(SB_VERT,m_iScrollY,TRUE);
	m_iScrollY = GetScrollPos(SB_VERT);

	if(m_iScrollY!=iStart)RedrawWindow();
}

//*****************************************************************************
//*
//*		Debug Funktioen
//*
//*****************************************************************************
#ifdef		_DEBUG

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CPictureBoxView::AssertValid() const
{
	CView::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CPictureBoxView::Dump(CDumpContext &dc) const
{
	CView::Dump(dc);
}
#endif


//*****************************************************************************
//*
//*		SetShowSize
//*
//*****************************************************************************
//	Die Anzeigeart der Bilder einstellen
//  iMode	: Ist der Anzeigemodus
//				  0 = 1:1
// 				 -1 = volle Breite
// 				 -2 = volle Hhe
// 				 -3 = vollstntig im Schirm
// 				 -4 = vergrern
// 				 -5 = verkleinern
// 				 -6 = keine Formatnderung
// 				 ...= Gre in %
//	bLock	: Das Zeichen sperren
//	Ergibt 1 wenn sich das Format verndert hat
BOOL CPictureBoxView::SetShowSize(int iMode,BOOL bRedraw,BOOL bLock)
{
int			iSizeX;
int			iSizeY;
int			iAddX;
int			iAddY;
BOOL		iRet;


	if(iMode==100)iMode=0;
	if(iMode== -6)iMode=m_iShowFormat;


	if(!m_pImagePtr)
		{
		iRet			= (m_iShowFormat!=iMode)? 1:0;
		m_iShowFormat	= iMode;

		return iRet;
		}

	if(bLock)
		{
		sDrawMutex.Lock();
		}

	iSizeX	= m_pImagePtr->Width ();
	iSizeY	= m_pImagePtr->Height();
	iAddX	= 0;
	iAddY	= 0;

	if(iSizeX<=0 || iSizeY<=0)
		{
		iSizeX		  = 1;
		iSizeY		  = 1;
		m_iImageSizeX = 1;
		m_iImageSizeY = 1;
		}

	switch(iMode)
		{
	case  0:											// Eins zu eins
				m_iImageSizeX =  iSizeX;
				m_iImageSizeY =  iSizeY;
				break;

	case -1:											// Volle Breite
				m_iImageSizeX =  m_iScreenX-FRAME;
				if(m_iImageSizeX<1)m_iImageSizeX=1;

				m_iImageSizeY = (m_iImageSizeX*iSizeY)/iSizeX;
				if(m_iImageSizeY+FRAME>=m_iScreenY+iAddY)
					{
					iAddX     = -GetSystemMetrics(SM_CXVSCROLL);
					}

				m_iImageSizeX =  m_iScreenX+iAddX-FRAME;
				if(m_iImageSizeX<1)m_iImageSizeX=1;
				m_iImageSizeY = (m_iImageSizeX*iSizeY)/iSizeX;
				break;

	case -2:											// Volle Hhe
				m_iImageSizeY =  m_iScreenY-FRAME;
				if(m_iImageSizeY<1)m_iImageSizeY=1;

				m_iImageSizeX = (m_iImageSizeY*iSizeX)/iSizeY;
				if(m_iImageSizeY+FRAME>=m_iScreenY+iAddX)
					{
					iAddY     = -GetSystemMetrics(SM_CYHSCROLL);
					}

				m_iImageSizeY =  m_iScreenY+iAddY-FRAME;
				if(m_iImageSizeY<1)m_iImageSizeY=1;
				m_iImageSizeX = (m_iImageSizeY*iSizeX)/iSizeY;
				break;

	case -3:											// Vollbild
				m_iImageSizeX =  m_iScreenX-FRAME;
				if(m_iImageSizeX<1)m_iImageSizeX=1;

				m_iImageSizeY = (m_iImageSizeX*iSizeY)/iSizeX;
				if(m_iImageSizeY+FRAME<=m_iScreenY)break;

				m_iImageSizeY =  m_iScreenY-FRAME;
				if(m_iImageSizeY<1)m_iImageSizeY=1;
				m_iImageSizeX = (m_iImageSizeY*iSizeX)/iSizeY;
				break;

	case -4:											// Vergrern
				iMode = (m_iImageSizeX*110)/iSizeX;
				if(iMode<=10)iMode=11;
				iMode = SetZoomSize(iMode);
				break;

	case -5:											// Verkleinern
				iMode = SetZoomSize((m_iImageSizeX*90)/iSizeX);
				break;

	default:											// Prozent
				iMode = SetZoomSize(iMode);
		}


	iRet			= (m_iShowFormat!=iMode)? 1:0;
	m_iShowFormat	= iMode;


	if(bLock)
		{
		sDrawMutex.Unlock();
		}


	if(bRedraw)
		{
		OnSize(0,m_iScreenX,m_iScreenY);

				   SetScrollPos(SB_HORZ,m_iScrollX,TRUE);
		m_iScrollX=GetScrollPos(SB_HORZ);
				   SetScrollPos(SB_VERT,m_iScrollY,TRUE);
		m_iScrollY=GetScrollPos(SB_VERT);

		RedrawWindow();
		}



return iRet;
}


//*****************************************************************************
//*
//*		SetZoomSize
//*
//*****************************************************************************
BOOL CPictureBoxView::SetZoomSize(int iMode,BOOL bMiddle)
{
CPoint		sCursor;
int			iValueX;
int			iValueY;
int			iStartX;
int			iStartY;
int			iSizeX;
int			iSizeY;
int			iOldX;
int			iOldY;



	if(iMode<10  )iMode=10;
	if(iMode>1000)iMode=1000;

	iSizeX		  = m_pImagePtr->Width ();
	iSizeY		  = m_pImagePtr->Height();

	iOldX		  = m_iImageSizeX;
	iOldY		  = m_iImageSizeY;

	m_iImageSizeX = (iSizeX*iMode)/100;
	m_iImageSizeY = (iSizeY*iMode)/100;

	if(bMiddle && iOldX>0 && iOldY>0)					// Zoomen um den Cursor
		{
		GetCursorPos  (&sCursor);
		ScreenToClient(&sCursor);

		if((UINT)sCursor.x>=(UINT)m_iScreenX ||
		   (UINT)sCursor.y>=(UINT)m_iScreenY)
			{
			sCursor.x =  m_iScreenX/2;
			sCursor.y =  m_iScreenY/2;
			}


		iStartX	   = (m_iScreenX-m_iImageSizeX)/2;
		iStartY	   = (m_iScreenY-m_iImageSizeY)/2;

		if(iStartX<FRAME)iStartX=FRAME;
		if(iStartY<FRAME)iStartY=FRAME;


		iValueX	   = sCursor.x+m_iScrollX-m_iImageStartX;
		iValueX   *= m_iImageSizeX;
		iValueX   /= iOldX;
		m_iScrollX = iValueX-sCursor.x+iStartX;

		iValueY	   = sCursor.y+m_iScrollY-m_iImageStartY;
		iValueY   *= m_iImageSizeY;
		iValueY   /= iOldY;
		m_iScrollY = iValueY-sCursor.y+iStartY;

		CheckScroll();
		}


	if(m_iImageSizeX==iSizeX && m_iImageSizeY==iSizeY)
		{
		return 0;
		}


return iMode;
}

//*****************************************************************************
//*
//*		CheckScroll
//*
//*****************************************************************************
void CPictureBoxView::CheckScroll()
{
int		iValue;


	iValue = m_iImageSizeX+FRAME-m_iScreenX;

	if(m_iScrollX>iValue)m_iScrollX=iValue;
	if(m_iScrollX<     0)m_iScrollX=0;

	iValue = m_iImageSizeY+FRAME-m_iScreenY;

	if(m_iScrollY>iValue)m_iScrollY=iValue;
	if(m_iScrollY<     0)m_iScrollY=0;

}

//*****************************************************************************
//*
//*		OnShow???
//*
//*****************************************************************************
void CPictureBoxView::OnShowCommon       (){SetShowSize( 0);}
void CPictureBoxView::OnShowFullWidth    (){SetShowSize(-1);}
void CPictureBoxView::OnShowFullHeight   (){SetShowSize(-2);}
void CPictureBoxView::OnShowFullSize     (){SetShowSize(-3);}
void CPictureBoxView::OnShowSmaller      (){SetShowSize(-5);}
void CPictureBoxView::OnShowBigger       (){SetShowSize(-4);}
void CPictureBoxView::OnShowMode(int iSize){SetShowSize(iSize&0x03FF);}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CPictureBoxView::OnTimer(UINT_PTR nIDEvent)
{

	if(nIDEvent==ID_TITLE_TIMER)						// Bildnamen einblenden
		{
		m_iTitleTime++;

		if(!m_bTitlelOn && m_iTitleTime>6)
			{
			CRect	sRect;

			m_bTitlelOn  = TRUE;
			m_iTitleTime = 0;

			sRect.SetRect(m_iTitleX-200,m_iTitleY-20,m_iTitleX+200,m_iTitleY+20);

			RedrawWindow(&sRect);
			KillTimer(ID_TITLE_TIMER);
			}
		}

	if(nIDEvent==ID_REDRAW_TIMER)						// Bildnamen einblenden
		{
		if(m_iSwitchImg<0)
			{
			KillTimer(ID_REDRAW_TIMER);
			}
		else{
			RedrawWindow();
			}
		}

}

//*****************************************************************************
//*
//*		OnMouseWheel
//*
//*****************************************************************************
BOOL CPictureBoxView::OnMouseWheel(UINT nFlags,short sDelta,CPoint sPoint)
{
int			iPosY;

	if(m_bMouseWheel)
		{
		SetShowSize((sDelta<0)? -5:-4);
		}
	else{
		iPosY = GetScrollPos(SB_VERT);
		OnVScroll(SB_THUMBTRACK,iPosY-sDelta/2,GetScrollBarCtrl(SB_VERT));
		}


return TRUE;
}



//*****************************************************************************
//*
//*		OnMouseMove
//*
//*****************************************************************************
void CPictureBoxView::OnMouseMove(UINT nFlags,CPoint sPoint)
{
int		iMax,iPosX,iPosY;


	if(m_bTitlelOn)										// Titel ausblenden
		{
		m_bTitlelOn = FALSE;
		RedrawWindow(&m_sTitleRect);
		}

	if(m_bMoveOn)										// Das Bild verschieben
		{
		iPosX = m_iMoveX+m_sMovePoint.x-sPoint.x;
		iPosY = m_iMoveY+m_sMovePoint.y-sPoint.y;

		iMax  = m_iImageSizeX+FRAME*2-m_iScreenX;
		if(iPosX>=iMax)iPosX=iMax-1;
		if(iPosX<    0)iPosX=0;

		iMax  = m_iImageSizeY+FRAME*2-m_iScreenY;
		if(iPosY>=iMax)iPosY=iMax-1;
		if(iPosY<    0)iPosY=0;

		if(m_bScrollOnX)
			{
					SetScrollPos(SB_HORZ,iPosX,TRUE);
			iPosX = GetScrollPos(SB_HORZ);
			}

		if(m_bScrollOnY)
			{
					SetScrollPos(SB_VERT,iPosY,TRUE);
			iPosY = GetScrollPos(SB_VERT);
			}

		if(m_iScrollX!=iPosX || m_iScrollY!=iPosY)
			{
			m_iScrollX = iPosX;
			m_iScrollY = iPosY;
			RedrawWindow();
			}

		return;
		}

	if(m_pImagePtr && m_pImagePtr->IsOk())				// Titelanzeige neu starten
		{
		if(!m_iTitleTime)SetTimer(ID_TITLE_TIMER,300,NULL);

		m_iTitleX 		= sPoint.x;
		m_iTitleY 		= sPoint.y;
		m_iTitleTime	= 1;
		}

}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CPictureBoxView::OnLButtonDown(UINT nFlags,CPoint sPoint)
{

	m_sMovePoint	= sPoint;
	m_iMoveX		= m_iScrollX;
	m_iMoveY		= m_iScrollY;
	m_bMoveOn 		= 1;

	SetCursor(LoadCursor(0,IDC_SIZEALL));
	SetCapture();

}

//*****************************************************************************
//*
//*		OnLButtonUp
//*
//*****************************************************************************
void CPictureBoxView::OnLButtonUp(UINT nFlags,CPoint sPoint)
{

	if(m_bMoveOn==1)
		{
		SetCursor(LoadCursor(0,IDC_ARROW));
		if(m_bMoveOn)ReleaseCapture();
		m_bMoveOn = 0;
		}

}

//*****************************************************************************
//*
//*		OnMButtonDown
//*
//*****************************************************************************
void CPictureBoxView::OnMButtonDown(UINT nFlags,CPoint sPoint)
{

	m_sMovePoint	= sPoint;
	m_iMoveX		= m_iScrollX;
	m_iMoveY		= m_iScrollY;
	m_bMoveOn 		= 3;

	SetCursor(LoadCursor(0,IDC_SIZEALL));
	SetCapture();


}

//*****************************************************************************
//*
//*		OnMButtonUp
//*
//*****************************************************************************
void CPictureBoxView::OnMButtonUp(UINT nFlags,CPoint sPoint)
{

	if(m_bMoveOn==3)
		{
		SetCursor(LoadCursor(0,IDC_ARROW));
		if(m_bMoveOn)ReleaseCapture();
		m_bMoveOn = 0;
		}

}

//*****************************************************************************
//*
//*		OnRButtonDown
//*
//*****************************************************************************
void CPictureBoxView::OnRButtonDown(UINT nFlags,CPoint sPoint)
{

	m_sMovePoint	= sPoint;
	m_iMoveX		= m_iScrollX;
	m_iMoveY		= m_iScrollY;
	m_bMoveOn 		= 2;

	SetCursor(LoadCursor(0,IDC_SIZEALL));
	SetCapture();


}

//*****************************************************************************
//*
//*		OnRButtonUp
//*
//*****************************************************************************
void CPictureBoxView::OnRButtonUp(UINT nFlags,CPoint sPoint)
{

	if(m_bMoveOn==2)
		{
		SetCursor(LoadCursor(0,IDC_ARROW));
		if(m_bMoveOn)ReleaseCapture();
		m_bMoveOn = 0;
		}

}

//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
void CPictureBoxView::OnCopy()
{

	if(!m_pImagePtr)return;

	m_pImagePtr->Copy(m_hWnd);

}

//*****************************************************************************
//*
//*		OnRedraw
//*
//*****************************************************************************
void CPictureBoxView::OnRedraw()
{

	OnSize(0,m_iScreenX,m_iScreenY);

			   SetScrollPos(SB_HORZ,m_iScrollX,TRUE);
	m_iScrollX=GetScrollPos(SB_HORZ);
			   SetScrollPos(SB_VERT,m_iScrollY,TRUE);
	m_iScrollY=GetScrollPos(SB_VERT);

	RedrawWindow();
}

//*****************************************************************************
//*
//*		OnSwitch
//*
//*****************************************************************************
void CPictureBoxView::OnSwitch()
{

}

//*****************************************************************************
//*
//*		OnKeyDown
//*
//*****************************************************************************
void CPictureBoxView::OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags)
{
int		iPosX;
int		iPosY;


	iPosX = 0x8000;
	iPosY = 0x8000;

	switch(nChar)
		{
	case 0x23:	iPosY = m_pImagePtr->Height();		break;	// End
	case 0x24:	iPosY = 0;							break;	// Home
	case 0x25:	iPosX = m_iScrollX-50;				break;	// Links
	case 0x27:	iPosX = m_iScrollX+50;				break;	// Rechts
	case 0x26:	iPosY = m_iScrollY-50;				break;	// Auf
	case 0x28:	iPosY = m_iScrollY+50;				break;	// Ab
	case 0x21:	iPosY = m_iScrollY-m_iScreenY/2;	break;	// Seite auf
	case 0x22:	iPosY = m_iScrollY+m_iScreenY/2;	break;	// Seite ab
	default: return;
		}



	if(iPosX!=0x8000)OnHScroll(SB_THUMBPOSITION,iPosX,0);
	if(iPosY!=0x8000)OnVScroll(SB_THUMBPOSITION,iPosY,0);

}



//*****************************************************************************
//*
//*		Load
//*
//*****************************************************************************
// 	Ld ein Bild in einen Slot.
// 	iSlot			: Ist die Slotnummer
//	bAllowDummy		: Kann auch ein Dummy geladen werden
//	Ergibt 1 wenn das Bild geladen wurde, bzw. 0 bei einem Fehler
int CPictureBoxView::Load(int iSlot,BOOL bAllowDummy)
{
BOOL		bDummy;
LPCTSTR		pName;
int			iTurn;
int			iRet;



	if(iSlot<0 || iSlot>=CPB_CACHE_SIZE)return 0;

	sImageMutex.Lock();
	m_aImgLock[iSlot] = 1;

	pName	= m_aImgPath+iSlot*256;
	bDummy	= FALSE;

	if(ExistFile(pName)!=1)								// Existiert die Bilddatei
		{
		m_aImgLock[iSlot] = 0;
		sImageMutex.Unlock();
		if(!bAllowDummy)return 0;
		bDummy = 1;
		}

	sImageMutex.Unlock();



	if(!bDummy)
		{ 
		   pOldHandler	= AfxGetNewHandler();
		if(pOldHandler)									// Kein throw wenn Siecher ausgeht
			{
			dwLoadThread = GetCurrentThreadId();
			AfxSetNewHandler(PictureBoxHandler);
			}

		for(iTurn=0;iTurn<3;iTurn++)					// Das Bild laden
			{
			   iRet = ImageLoader(pName,m_aImages+iSlot);		
			if(iRet!=-6)break;							// Zu wenig Speicher

			FreePictures(2);
			}

		if(pOldHandler)
			{
			dwLoadThread = 0;
			AfxSetNewHandler(pOldHandler);
			}


		if(iRet<0 && bAllowDummy)bDummy = TRUE;
		else if(m_aImages[iSlot].HasAlpha())
			{
			BitmapImage	sImage;

			sImage.SetSize(32,m_aImages[iSlot].Width(),m_aImages[iSlot].Height(),BGR(255,255,255));
			sImage.PutAlpha(m_aImages[iSlot],0,0);
			sImage.Swap(m_aImages[iSlot]);
			}
		}


	if(bDummy)											// Dummy erzeugen
		{
		m_aImages[iSlot].SetSize(1,128,128);
		m_aImages[iSlot].Box (1,1,126,126,1);
		m_aImages[iSlot].Line(1,1,126,126,0);
		m_aImages[iSlot].Line(126,1,1,126,0);
		}


	sImageMutex.Lock();

	m_aImgLock[iSlot] = 0;

	if(m_iSwitchImg>=0)									// Zu einem Bild wechseln
		{
		PostMessage(WM_COMMAND,ID_REDRAW);
		}

	sImageMutex.Unlock();


return (bDummy)? 1:2;
}


//*****************************************************************************
//*
//*		ThreadProc
//*
//*****************************************************************************
unsigned int CPictureBoxView::ThreadProc(CPictureBoxView *pThis)
{
int		iSlot;


	pThis->m_bThreadOn = 1;

	while(!pThis->m_bThreadStop)
		{
		pThis->m_sThreadSignal.Lock(300);				// Warte auf Signal

		sImageMutex.Lock();
		iSlot = pThis->m_iLoadImg;						// Bild das geladen werden soll;
		pThis->m_iLoadImg = -1;
		sImageMutex.Unlock();

		if(iSlot>=0)									// Muss ein Bild geladen werden
			{
			pThis->Load(iSlot);
			}
		}

	pThis->m_bThreadOn = 0;


return 0;
}


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CPictureBoxView::OnDestroy()
{
int		iTurn;



	for(iTurn=0;iTurn<40;iTurn++)						// Warten bis der Thread beendet ist
		{
			m_bThreadStop=1;
		if(!m_bThreadOn)break;

		Sleep(250);
		}

	if(m_iTitleTime)
		{
		KillTimer(ID_TITLE_TIMER);
		m_iTitleTime=0;
		}

	CView::OnDestroy();
}


//*****************************************************************************
//*
//*		SetPicture
//*
//*****************************************************************************
//	Ein Bild anzeigen.
//	pPath		: Ist der Dateiname des Bildes
//	pTitle		: Ist der Titel fr das Bild
//	bCheckSufix	: Soll der Dateityp geprft werden.
//	Ergibt 1 wenn das Bild eingefgt wurde, bzw. 0 wenn nicht
int	CPictureBoxView::SetPicture(LPCTSTR pPath,LPCTSTR pTitle,BOOL bCheckSufix)
{
TCHAR	cPath[256];
LPTSTR	pName;
UINT	uTick;
int		iDiff;
int		iNull;
int		iLast;
int		iMax;
int		iPos;
int		iNow;



	if(bCheckSufix && !CmpFileType(pPath,CPB_FILES))
		{
		return 0;
		}

	if(!pTitle)pTitle=_T("");

	GetFullPathName(pPath,256,cPath,&pName);			// Dateinamen holen
	PathConvert(cPath);

	sImageMutex.Lock();
	uTick = GetTickCount();
	iNull = -1;
	iLast =  0;
	iMax  =  0;

	sDrawMutex.Lock();
	iNow  = m_iCurrendImg;
	sDrawMutex.Unlock();

	if(iLast==iNow)iLast=1;

	for(iPos=0;iPos<CPB_CACHE_SIZE;iPos++)				// Suchen einen freien Slot
		{
		if(!m_aImgPath[iPos*256] && !m_aImgLock[iPos])
			{
			iNull = iPos;
			continue;
			}

		if(!stricmp(cPath,m_aImgPath+iPos*256))			// Ist das Bild schon geladen
			{
			if(iNow==iPos)
				{
				sImageMutex.Unlock();
				return 1;
				}

			if(m_aImgLock[iPos])						// Wird das Bild gerade geladen
				{
				m_bTitlelOn		 = 0;
				m_iSwitchImg	 = iPos;
				}
			else{										// Bild ist schon geladen
				m_pImagePtr		 = m_aImages+iPos;

				if(!m_pImagePtr->IsOk())
					{
					m_aImgPath[iPos*256] = 0;
					m_aImgName[iPos*256] = 0;
					break;
					}

				m_bTitlelOn		 = 0;
				m_iSwitchImg	 = -1;
				m_iCurrendImg	 = iPos;
				m_uImgLast[iPos] = uTick;
				SetShowSize(m_iShowFormat,FALSE);
				PostMessage(WM_COMMAND,ID_REDRAW);
				}

			strlcpy(m_aImgName+iPos*256,pTitle,256);
			sImageMutex.Unlock();

			return 1;
			}

		if(iPos==iNow)continue;							// Angezeigtes Bild ignorieren

		   iDiff  = uTick-m_uImgLast[iPos];
		if(iDiff>iMax && !m_aImgLock[iPos])				// Das am lngsten Unbenutzte finden
			{
			iMax  = iDiff;
			iLast =	iPos;
			}
		}


	iPos = (iNull>=0)? iNull:iLast;

	strlcpy(m_aImgName+iPos*256,pTitle,256);
	strlcpy(m_aImgPath+iPos*256,cPath ,256);
	m_aImages [iPos].Clear();
	m_uImgLast[iPos] = uTick;
	m_iSwitchImg	 = iPos;
	m_iLoadImg		 = iPos;

	m_sThreadSignal.Unlock();							// Thread fr's laden freigeben
	sImageMutex.Unlock();




return 1;
}

//*****************************************************************************
//*
//*		OnSelNamePath
//*
//*****************************************************************************
void CPictureBoxView::OnSelNamePath()
{
	m_bTitleMode = !m_bTitleMode;
}

//*****************************************************************************
//*
//*		OnMenuSelNamePath
//*
//*****************************************************************************
void CPictureBoxView::OnMenuSelNamePath(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bTitleMode);
}

//*****************************************************************************
//*
//*		OnWheelMode
//*
//*****************************************************************************
void CPictureBoxView::OnWheelMode()
{
	m_bMouseWheel = !m_bMouseWheel;
}

//*****************************************************************************
//*
//*		OnMenuWheelMode
//*
//*****************************************************************************
void CPictureBoxView::OnMenuWheelMode(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bMouseWheel);
}

//*****************************************************************************
//*
//*		ClearCache
//*
//*****************************************************************************
void CPictureBoxView::ClearCache()
{
TCHAR	cPath[16];
int		iLen;
int		iPos;


	iLen	= _stprintf(cPath,_T("*%i"),time(0))*sizeof(TCHAR)+sizeof(TCHAR);

	sImageMutex.Lock();

	for(iPos=0;iPos<CPB_CACHE_SIZE;iPos++)
		{
		memcpy(m_aImgPath+iPos*256,cPath,iLen);
		memcpy(m_aImgName+iPos*256,cPath,iLen);
		m_uImgLast[iPos] = 0;
		}

	sImageMutex.Unlock();

}

//*****************************************************************************
//*
//*		OnCheck
//*
//*****************************************************************************
//	Prfe die Bildposition
void CPictureBoxView::OnCheck()
{
int		iPosX;
int		iPosY;
int		iMax;


	sImageMutex.Lock();

	iPosX = m_iScrollX;
	iPosY = m_iScrollY;

	iMax  = m_iImageSizeX+FRAME*2-m_iScreenX;
	if(iPosX>=iMax)iPosX=iMax-1;
	if(iPosX<    0)iPosX=0;

	iMax  = m_iImageSizeY+FRAME*2-m_iScreenY;
	if(iPosY>=iMax)iPosY=iMax-1;
	if(iPosY<    0)iPosY=0;

	sImageMutex.Unlock();

	if(m_bScrollOnX)
		{
		SetScrollPos(SB_HORZ,iPosX,TRUE);
		}

	if(m_bScrollOnY)
		{
		SetScrollPos(SB_VERT,iPosY,TRUE);
		}

	if(m_iScrollX!=iPosX || m_iScrollY!=iPosY)
		{
		m_iScrollX = iPosX;
		m_iScrollY = iPosY;
		RedrawWindow();
		}


}

//*****************************************************************************
//*
//*		FreePictures
//*
//*****************************************************************************
//	Die ltersten Bilder freigeben
void CPictureBoxView::FreePictures(int iCount,int iIgnore)
{
UINT	uTick;
int		iDiff;
int		iLast;
int		iMax;
int		iPos;
int		iNow;



	sDrawMutex.Lock();
	iNow  = m_iCurrendImg;
	sDrawMutex.Unlock();

	uTick = GetTickCount();
	iLast = -1;
	iMax  =  0;	

	while(iCount>0)
		{
		for(iPos=0;iPos<CPB_CACHE_SIZE;iPos++)			// Suchen einen freien Slot
			{
			if(!m_aImgPath[iPos*256] && !m_aImgLock[iPos])
				{
				continue;
				}

			if(iNow==iPos || iPos==iIgnore)
				{
				continue;
				}

			   iDiff  = uTick-m_uImgLast[iPos];
			if(iDiff>iMax && !m_aImgLock[iPos])			// Das am lngsten Unbenutzte finden
				{
				iMax  = iDiff;
				iLast =	iPos;
				}
			}


		if(iLast<0)break;

		m_pImagePtr		 = m_aImages+iLast;
		m_pImagePtr->Clear();
		m_aImgPath[iLast*256] = 0;
		m_aImgName[iLast*256] = 0;

		iCount--;
		}
		
}